// SetLockBuffer.cpp : implementation file
//

#include "stdafx.h"
#include "okmfc.h"
#include "SetLockBuffer.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

long	static currno;

/////////////////////////////////////////////////////////////////////////////
// CSetLockBuffer dialog

CSetLockBuffer::CSetLockBuffer(CWnd* pParent /*=NULL*/)
	: CDialog(CSetLockBuffer::IDD, pParent)
{
	//{{AFX_DATA_INIT(CSetLockBuffer)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
}


void CSetLockBuffer::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CSetLockBuffer)
		// NOTE: the ClassWizard will add DDX and DDV calls here
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CSetLockBuffer, CDialog)
	//{{AFX_MSG_MAP(CSetLockBuffer)
	ON_WM_VSCROLL()
	ON_EN_CHANGE(IDC_INDEXBOARD, OnChangeIndexboard)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CSetLockBuffer message handlers

BOOL CSetLockBuffer::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	char	string[120];
	DWORD	offset,bufsize;

	SetDlgItemInt(IDC_INDEXBOARD,currno,FALSE);
	sprintf(string,"No. %d",currno);

	offset=GetPrivateProfileInt(string,"Offset",0,"okacfg.ini");
	bufsize=GetPrivateProfileInt(string,"Size",0,"okacfg.ini");

	offset/=1024; //to k
	bufsize/=1024;
	SetDlgItemInt(IDC_BUFFEROFFSET,offset,FALSE);
	SetDlgItemInt(IDC_LOCKBUFSIZE,bufsize,FALSE);
	
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void CSetLockBuffer::OnVScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar) 
{
	long	index=0;

	if (nSBCode == SB_LINEDOWN) {
		index=GetDlgItemInt(IDC_INDEXBOARD,NULL,FALSE);
		index=max(0,index-1);
		SetDlgItemInt(IDC_INDEXBOARD,index,FALSE);
	}
	else if (nSBCode == SB_LINEUP) {
		index=GetDlgItemInt(IDC_INDEXBOARD,NULL,FALSE);
		index=index+1;
		SetDlgItemInt(IDC_INDEXBOARD,index,FALSE);
	}
	
	CDialog::OnVScroll(nSBCode, nPos, pScrollBar);
}

void CSetLockBuffer::OnChangeIndexboard() 
{
	// TODO: If this is a RICHEDIT control, the control will not
	// send this notification unless you override the CDialog::OnInitDialog()
	// function and call CRichEditCtrl().SetEventMask()
	// with the ENM_CHANGE flag ORed into the mask.
	
	// TODO: Add your control notification handler code here
	
	long	oldno=currno;
	DWORD	offset,bufsize;
	char	string[120];

	currno=GetDlgItemInt(IDC_INDEXBOARD,NULL,TRUE);
	if(oldno!=currno) {
		sprintf(string,"No. %d",currno);

		offset=GetPrivateProfileInt(string,"Offset",0,"okacfg.ini");
		bufsize=GetPrivateProfileInt(string,"Size",0,"okacfg.ini");

		offset/=1024; //to k
		bufsize/=1024;
		SetDlgItemInt(IDC_BUFFEROFFSET,offset,FALSE);
		SetDlgItemInt(IDC_LOCKBUFSIZE,bufsize,FALSE);
	}
}

void CSetLockBuffer::OnOK() 
{
	char	outstr[120];
	DWORD	offset,bufsize;
	char	string[120];

	currno=GetDlgItemInt(IDC_INDEXBOARD,NULL,TRUE);
	sprintf(string,"No. %d",currno);
	GetDlgItemText(IDC_BUFFEROFFSET,outstr,100);
	offset=strtol(outstr,NULL,0);
	//offset=GetDlgItemInt(hDlg,IDC_BUFFEROFFSET,NULL,TRUE);
	GetDlgItemText(IDC_LOCKBUFSIZE,outstr,100);
	bufsize=strtol(outstr,NULL,0);
	//bufsize=GetDlgItemInt(hDlg,IDC_LOCKBUFSIZE,NULL,TRUE);

	offset*=1024; //to byte
	bufsize*=1024;

	sprintf(outstr,"%d",offset);
	WritePrivateProfileString(string,"Offset",outstr,"okacfg.ini");
	sprintf(outstr,"%d",bufsize);
	WritePrivateProfileString(string,"Size",outstr,"okacfg.ini");
	
	//CDialog::OnOK();
}
