// BufferBox.cpp : implementation file
//

#include "stdafx.h"
#include "okmfc.h"
#include "BufferBox.h"
#include "okapi32.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CBufferBox dialog


CBufferBox::CBufferBox(CWnd* pParent /*=NULL*/)
	: CDialog(CBufferBox::IDD, pParent)
{
	//{{AFX_DATA_INIT(CBufferBox)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
}


void CBufferBox::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CBufferBox)
		// NOTE: the ClassWizard will add DDX and DDV calls here
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CBufferBox, CDialog)
	//{{AFX_MSG_MAP(CBufferBox)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CBufferBox message handlers

BOOL CBufferBox::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	// TODO: Add extra initialization here
	
	DWORD	currsize,newsize;

	okGetAvailBuffer(NULL,&currsize); //in byte
	currsize>>=10; //to k byte
	SetDlgItemInt(IDC_CURRENTSIZE,currsize,FALSE);

	newsize=okSetAllocBuffer(-1); //just get last set in k byte
	SetDlgItemInt(IDC_NEWBUFSIZE,newsize,FALSE);

	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void CBufferBox::OnOK() 
{
	// TODO: Add extra validation here
	DWORD newsize;

	newsize=GetDlgItemInt(IDC_NEWBUFSIZE,NULL,FALSE);
	okSetAllocBuffer(newsize); //set new
	
	CDialog::OnOK();
}
