/*==============================================================================
*
*       filename        OkMfcView.cpp
*       purpose         exam of okdemo with MFC (Ok series image cards)
*       language        Microsoft Visual C 5.0
*       author          He Peng
*       date            00-8-20
*-----------------------
*       modify by       He Peng
*       purpose         
*       language        Microsoft Visual C 5.0 
*       date            00-10-16
*
*-----------------------
*
*		Copyright (C).  All Rights Reserved.
*
*
*==============================================================================*/

// OkMfcView.cpp : implementation of the COkMfcView class
//

#include "stdafx.h"
#include "OkMfc.h"

#include "OkMfcDoc.h"
#include "OkMfcView.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

#include "vfw.h"
#include "okapi32.h"
#include "infobox.h"
#include "signbox.h"
#include "selectbox.h"
#include "seqnum.h"
#include "setsnumbox.h"
#include "setbnumbox.h"
#include "setcsizebox.h"
#include "bufferbox.h"
#include "setlockbuffer.h"

#include "conio.h"

#include <queue.h>

const		NUMINFILE = 30;			//׼ɼֲ֡

		HDC			hDC;
		CDC*		cdc;

//----global variables for board--------
CStatusBar*		sBar;				//״ָ̬

typedef struct _wavfileheader 
{
	char	RIFF[4];
	long	lFileLength;
	char	WAVE[4];
	char	fmt[4];
	long	lHeadSize;

	//PCMWAVEFORMAT pcmheader;	
	WORD	wFormatTag;
	WORD	nChannels;
	DWORD	nSamplesPerSec;
	DWORD	nAvgBytesPerSec;
	WORD	nBlockAlign;
	WORD	wBitsPerSample;
	char	data[4];
	long	lDataLength;
} WAVEFILEHEADER;

WAVEFILEHEADER waveheader;

HANDLE	hAudio;
long	elapsedtimes;
HFILE	hFile;
HPEN	hPen;
char	str[100];
HDC		hdc;
char	lastaudio[1024];

HWND		hWnd;					//Ӧó򴰿ھ
HWND		hwnd;
HANDLE		hLoopThread;
HANDLE		hBoard;					//ɼ
BYTE		bActive = 0;			//ʵʱɼ־
short		total = 2;				//ȫɼ
long		iCurrUsedNo = -1;		//ǰɼ
long		intrMISCCONTROL; //b0:1

short		iNumImage = NUMINFILE;	//ɼ֡

short		bScrnCenter=0; //non-centerize
long		lScrnOffset;			//ɼƫ
short		sampwidth, sampheight;	//ɼڿȡ߶
WORD		horzstart,vertstart;			//horz start, vert start

short		bMakeMirror = 0;		//x,y
int			iClientWidth;			//ͻ
int			iClientHeight;			//ͻ߶

LPSTR		seqfile = "ok.seq";		//ɼļĬ
DWORD		dwMaxMemSize = 30*1024*1024;	//ڴС
DWORD		dwDIBCurrSize=1024*1024*4; //
long		dwBufSize;				//󻺴С

long		lNumImage=NUMINFILE;


LPBITMAPINFOHEADER	lpbi;			//ɼĿʽļͷ
LPSTR				lpdib;			//ɼĿ
LPSTR				lpMemory;		//ûڴָ
BLOCKINFO			blkinfo;		//ûṹָṹ


BOOL				bDispToScreen;	//ʾĻ״̬λ

HWND				hwndPlay; //for ReplayDlgEx

int		iNum = 2;					//࿨ͨɼ
int		NoCapture = 2;
HANDLE	lphBoard[] = {0, 0, 0, 0, 0};


//----local functions-------------------------------------
long exGetTargetSize(HANDLE hBoard, TARGET tgt, short *width, short *heigth);
long exSetBitmapHeader(LPBITMAPINFOHEADER lpbi, short width, short height, short bits, short form);

BOOL CALLBACK exBeginCapture(HANDLE hBoard);
BOOL CALLBACK exBackDisplay(HANDLE hBoard, long no);
BOOL CALLBACK exSetToScreen(HANDLE hBoard, long no);
BOOL CALLBACK exEndCapture(HANDLE hBoard);

long exGetFrameSize(HANDLE hBoard);
BOOL exConvertBitmap(LPBITMAPINFOHEADER lpbi, LPSTR lpdib);
BOOL exSetTestBands(LPBYTE lpLinear, short bits, short height, long stride);
HANDLE exCreateLoopCapture(HANDLE hBoard, HANDLE hWnd);

BOOL exDispPointValue(HANDLE hBoard, HWND hwnd, LPARAM lParam);

/////////////////////////////////////////////////////////////////////////////
// COkMfcView

IMPLEMENT_DYNCREATE(COkMfcView, CView)

BEGIN_MESSAGE_MAP(COkMfcView, CView)
	//{{AFX_MSG_MAP(COkMfcView)
	ON_COMMAND(IDM_ACTIVE, OnActive)
	ON_WM_DESTROY()
	ON_COMMAND(IDM_FREEZE, OnFreeze)
	ON_COMMAND(IDM_SINGLECAPTO, OnSinglecapto)
	ON_WM_PAINT()
	ON_COMMAND(IDM_ABOUT, OnAbout)
	ON_COMMAND(IDM_EXTTRIGGER, OnExttrigger)
	ON_COMMAND(IDM_SIGNALEINFO, OnSignaleinfo)
	ON_COMMAND(IDM_BACKTOSCREEN, OnBacktoscreen)
	ON_UPDATE_COMMAND_UI(IDM_BACKTOSCREEN, OnUpdateBacktoscreen)
	ON_COMMAND(IDM_CAPTOBUFFER, OnCaptobuffer)
	ON_COMMAND(IDM_LOOPTOBUFFER, OnLooptobuffer)
	ON_COMMAND(IDM_SETUPVIDEO, OnSetupvideo)
	ON_COMMAND(IDM_CAPSEQUENCE, OnCapsequence)
	ON_UPDATE_COMMAND_UI(IDM_CENTERSCREEN, OnUpdateCenterscreen)
	ON_COMMAND(IDM_CENTERSCREEN, OnCenterscreen)
	ON_UPDATE_COMMAND_UI(IDM_ENABLEMASK, OnUpdateEnablemask)
	ON_COMMAND(IDM_ENABLEMASK, OnEnablemask)
	ON_COMMAND(IDM_REPLAYBUFFER, OnReplaybuffer)
	ON_COMMAND(IDM_REPLAYMEMORY, OnReplaymemory)
	ON_COMMAND(IDM_REPLAYFILE, OnReplayfile)
	ON_COMMAND(IDM_BUFFERTOSCREEN, OnBuffertoscreen)
	ON_COMMAND(IDM_SCREENTOBUFFER, OnScreentobuffer)
	ON_COMMAND(IDM_BUFFER0TOBUFFER1, OnBuffer0tobuffer1)
	ON_COMMAND(IDM_BUFFER1TOBUFFER0, OnBuffer1tobuffer0)
	ON_COMMAND(IDM_BUFFERTOFRAME, OnBuffertoframe)
	ON_COMMAND(IDM_FRAMETOBUFFER, OnFrametobuffer)
	ON_COMMAND(IDM_FRAMETOSCREEN, OnFrametoscreen)
	ON_COMMAND(IDM_CAPTOMEMORY, OnCaptomemory)
	ON_COMMAND(IDM_CAPTOSEQFILE, OnCaptoseqfile)
	ON_COMMAND(IDM_CAPTOINDIRECT, OnCaptoindirect)
	ON_COMMAND(IDM_CAPTODIRECT, OnCaptodirect)
	ON_COMMAND(IDM_CAPTOFOREVER, OnCaptoforever)
	ON_COMMAND(IDM_CONTTOBUFFER0, OnConttobuffer0)
	ON_COMMAND(IDM_CONTTOBUFFER1, OnConttobuffer1)
	ON_COMMAND(IDM_CAPTOFRAME, OnCaptoframe)
	ON_COMMAND(IDM_DISPFROMBUFFER, OnDispfrombuffer)
	ON_COMMAND(IDM_LOOPFROMBUFFER, OnLoopfrombuffer)
	ON_COMMAND(IDM_DISPFROMMEMORY, OnDispfrommemory)
	ON_COMMAND(IDM_DISPFROMFILE, OnDispfromfile)
	ON_COMMAND(IDM_CAPTOMONITOR, OnCaptomonitor)
	ON_COMMAND(IDM_DISPFROMFRAME, OnDispfromframe)
	ON_COMMAND(IDM_NORMALLUT, OnNormallut)
	ON_COMMAND(IDM_INVERSELUT, OnInverselut)
	ON_COMMAND(IDM_SELECTCARD, OnSelectcard)
	ON_UPDATE_COMMAND_UI(IDM_CAPTOFRAME, OnUpdateCaptoframe)
	ON_UPDATE_COMMAND_UI(IDM_BUFFERTOFRAME, OnUpdateBuffertoframe)
	ON_UPDATE_COMMAND_UI(IDM_FRAMETOBUFFER, OnUpdateFrametobuffer)
	ON_UPDATE_COMMAND_UI(IDM_FRAMETOSCREEN, OnUpdateFrametoscreen)
	ON_UPDATE_COMMAND_UI(IDM_NORMALLUT, OnUpdateNormallut)
	ON_UPDATE_COMMAND_UI(IDM_INVERSELUT, OnUpdateInverselut)
	ON_COMMAND(IDM_LOADFILE, OnLoadfile)
	ON_COMMAND(IDM_SAVESCREEN, OnSavescreen)
	ON_COMMAND(IDM_SAVEBUFFER, OnSavebuffer)
	ON_COMMAND(IDM_SETTOBAND, OnSettoband)
	ON_COMMAND(IDM_PRINTPIC, OnPrintpic)
	ON_WM_MOUSEMOVE()
	ON_COMMAND(IDM_SETTOZERO, OnSettozero)
	ON_UPDATE_COMMAND_UI(IDM_SINGLECAPTO, OnUpdateSinglecapto)
	ON_COMMAND(IDM_ABSOLUTELUT, OnAbsolutelut)
	ON_COMMAND(IDM_MULCHANCAP, OnMulchancap)
	ON_COMMAND(IDM_MULCHANCAPSUB, OnMulchancapsub)
	ON_COMMAND(IDM_ASYNCMULCAP, OnAsyncmulcap)
	ON_COMMAND(IDM_SYNCMULCAP, OnSyncmulcap)
	ON_UPDATE_COMMAND_UI(IDM_MATCHCLIENT, OnUpdateMatchclient)
	ON_COMMAND(IDM_MATCHCLIENT, OnMatchclient)
	ON_COMMAND(IDM_SETMATCHSIZE, OnSetmatchsize)
	ON_WM_MOVE()
	ON_UPDATE_COMMAND_UI(IDM_CAPTUREAUDIO, OnUpdateCaptureaudio)
	ON_COMMAND(IDM_COPYTOCLIPB, OnCopytoclipb)
	ON_COMMAND(IDM_SETALLOCBUF, OnSetallocbuf)
	ON_COMMAND(IDM_CAPTUREAUDIO, OnCaptureaudio)
	ON_COMMAND(IDM_SEQCAPTOBUF, OnSeqcaptobuf)
	ON_UPDATE_COMMAND_UI(IDM_SEQCAPTOBUF, OnUpdateSeqcaptobuf)
	ON_COMMAND(IDM_REGDEVDRIVER, OnRegdevdriver)
	ON_UPDATE_COMMAND_UI(IDM_REGDEVDRIVER, OnUpdateRegdevdriver)
	ON_COMMAND(IDM_CAPTOPSEUDO, OnCaptopseudo)
	ON_UPDATE_COMMAND_UI(IDM_MAKEXMIRROR, OnUpdateMakexmirror)
	ON_UPDATE_COMMAND_UI(IDM_MAKEYMIRROR, OnUpdateMakeymirror)
	ON_COMMAND(IDM_MAKEXMIRROR, OnMakexmirror)
	ON_COMMAND(IDM_MAKEYMIRROR, OnMakeymirror)
	ON_WM_SIZE()
	ON_COMMAND(IDM_ZEROALLBUFFER, OnZeroallbuffer)
	ON_UPDATE_COMMAND_UI(IDM_UPTORIGHT, OnUpdateUptoright)
	ON_UPDATE_COMMAND_UI(IDM_UPTOLEFT, OnUpdateUptoleft)
	ON_COMMAND(IDM_TESTVGACARD, OnTestvgacard)
	ON_COMMAND(IDM_TESTDRAWWND, OnTestdrawwnd)
	ON_COMMAND(IDM_UPTORIGHT, OnUptoright)
	ON_COMMAND(IDM_UPTOLEFT, OnUptoleft)
	ON_UPDATE_COMMAND_UI(IDM_CAPTUREMPEG2, OnUpdateCapturempeg2)
	ON_COMMAND(IDM_CAPTUREMPEG2, OnCapturempeg2)
	ON_COMMAND(IDM_LOADCONFIGFILE, OnLoadconfigfile)
	ON_COMMAND(IDM_SAVECONFIGFILE, OnSaveconfigfile)
	ON_COMMAND(IDM_ABSOLUTEDSA, OnAbsolutedsa)
	ON_UPDATE_COMMAND_UI(IDM_ABSOLUTELUT, OnUpdateAbsolutelut)
	ON_UPDATE_COMMAND_UI(IDM_ABSOLUTEDSA, OnUpdateAbsolutedsa)
	ON_COMMAND(IDM_NORMAINLUT, OnNormainlut)
	ON_COMMAND(IDM_INVERSEINLUT, OnInverseinlut)
	ON_UPDATE_COMMAND_UI(IDM_FILLINGLUT, OnUpdateFillinglut)
	ON_COMMAND(IDM_FILLINGLUT, OnFillinglut)
	ON_COMMAND(IDM_TESTMAINWND, OnTestmainwnd)
	ON_UPDATE_COMMAND_UI(IDM_DISABLEACTIVE, OnUpdateDisableactive)
	ON_UPDATE_COMMAND_UI(IDM_DISABLESYNCVERT, OnUpdateDisablesyncvert)
	ON_COMMAND(IDM_DISABLESYNCVERT, OnDisablesyncvert)
	ON_COMMAND(IDM_DISABLEACTIVE, OnDisableactive)
	ON_COMMAND(IDM_INTERFROMBUFFER, OnInterfrombuffer)
	ON_COMMAND(IDM_LOCKBUFSIZE, OnLockbufsize)
	ON_UPDATE_COMMAND_UI(IDM_INTERTOINDIRECT, OnUpdateIntertoindirect)
	ON_COMMAND(IDM_INTERTOINDIRECT, OnIntertoindirect)
	ON_UPDATE_COMMAND_UI(IDM_LOOPSEQCAPTOBUF, OnUpdateLoopseqcaptobuf)
	ON_COMMAND(IDM_LOOPSEQCAPTOBUF, OnLoopseqcaptobuf)
	ON_UPDATE_COMMAND_UI(IDM_CAPTOINDIRECT, OnUpdateCaptoindirect)
	ON_COMMAND(ID_SETTOZERO, OnSettozero)
	//}}AFX_MSG_MAP
	// Standard printing commands
	ON_COMMAND(ID_FILE_PRINT, CView::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_DIRECT, CView::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_PREVIEW, CView::OnFilePrintPreview)

	ON_MESSAGE(WM_ASKWAITVERTICAL, OnAskWaitVertical)
	ON_MESSAGE(WM_BEGINSEQPROC, BeginProc)
	ON_MESSAGE(WM_SEQPROGRESS, SeqPross)
	ON_MESSAGE(WM_ENDSEQPROC, EndProc)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// COkMfcView construction/destruction

COkMfcView::COkMfcView()
{
	//ʼΪƥģʽ
	m_MatchClient = false;
}

COkMfcView::~COkMfcView()
{
}

BOOL COkMfcView::PreCreateWindow(CREATESTRUCT& cs)
{
	return CView::PreCreateWindow(cs);
}

/////////////////////////////////////////////////////////////////////////////
// COkMfcView drawing

void COkMfcView::OnDraw(CDC* pDC)
{
	//COkMfcDoc* pDoc = GetDocument();
	//ASSERT_VALID(pDoc);
}

/////////////////////////////////////////////////////////////////////////////
// COkMfcView printing

BOOL COkMfcView::OnPreparePrinting(CPrintInfo* pInfo)
{
	// default preparation
	return DoPreparePrinting(pInfo);
}

void COkMfcView::OnBeginPrinting(CDC* /*pDC*/, CPrintInfo* /*pInfo*/)
{
}

void COkMfcView::OnEndPrinting(CDC* /*pDC*/, CPrintInfo* /*pInfo*/)
{
}

/////////////////////////////////////////////////////////////////////////////
// COkMfcView diagnostics

#ifdef _DEBUG
void COkMfcView::AssertValid() const
{
	CView::AssertValid();
}

void COkMfcView::Dump(CDumpContext& dc) const
{
	CView::Dump(dc);
}

COkMfcDoc* COkMfcView::GetDocument() // non-debug version is inline
{
	ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(COkMfcDoc)));
	return (COkMfcDoc*)m_pDocument;
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// COkMfcView message handlers

//------------callback runtines----------
long		elapsed;
long		numframe;
char		string[256];
long		bufform;
BLOCKINFO	blk;

long		num;
float		ratio = 25;

float exCalcCaptureRatio()
{
	static	long	times;

	if ((num>=12) ||  ((okGetTickCount()-times)>2000)&&(num>=2))
	{
		times = GetTickCount() - times;
		ratio = (float)num * 1000 / times;
		num = 0;
	}

	if(num == 0)
		times = GetTickCount();
	num++;

	return ratio;
}

// display gray value of current postion when mouse moved
BOOL exDispPointValue(HANDLE hBoard, HWND hwnd, LPARAM lParam)
{
	RECT	rcRect;
	POINT	pt;
	int		x,y;
	char	szString[100]={0};
	char	szText[512];

	if(!lpbi) //error
		return 0;

	rcRect.left=LOWORD(lScrnOffset);
	rcRect.top=HIWORD(lScrnOffset);
	rcRect.right=rcRect.left+lpbi->biWidth;
	rcRect.bottom=rcRect.top+lpbi->biHeight;
	MapWindowPoints(hwnd,HWND_DESKTOP,(LPPOINT)&rcRect,2);

	pt.x=LOWORD(lParam);
	pt.y=HIWORD(lParam);
	MapWindowPoints(hwnd,HWND_DESKTOP,(LPPOINT)&pt,1);

	//to dib coor
	x=pt.x-rcRect.left+horzstart;
	y=pt.y-rcRect.top+vertstart;
	if( (x>=0) && (x<lpbi->biWidth) && (y>=0) && (y<lpbi->biHeight) ) 
	{
		WORD	gray;
		WORD	r,g,b;
		LPBYTE	lpPixel;
		long	stride;
		long	scrform,bufform;
		BYTE	byBits;
		char	szSource[32];

		//1. screen
		scrform=okSetCaptureParam(hBoard,CAPTURE_SCRRGBFORMAT,GETCURRPARAM); //-1	
		byBits=(BYTE)HIWORD(scrform);

	
		if( okGetCaptureStatus(hBoard,2) ) { //capturing to
			lpPixel=(LPBYTE)okGetTargetInfo(hBoard, SCREEN, 0, NULL, NULL, &stride);
			if(lpPixel) //may be 0
				lpPixel+=pt.x*byBits/8+pt.y*stride;
			strcpy(szSource,"SCREEN");

		}
		else { //forzen
			//wbytes=((((lpbi->biWidth*bits)+31)&~31)>>3);//bmp need 4 byte align		
			byBits=(BYTE)lpbi->biBitCount;
			stride=(lpbi->biWidth*byBits/8+3)/4*4; //dword align
			lpPixel=(LPBYTE)lpdib+x*byBits/8+(lpbi->biHeight-y-1)*stride; 	
			strcpy(szSource,"DIB");

		}

		if(lpPixel) {

			if(byBits<=8) { //8 bits
				gray=*lpPixel;
				//gray=(BYTE)okReadPixel(hBoard,SCREEN,0,x,y-10);
				//okWritePixel(hBoard,SCREEN,0,x,y-10,0x00ffff);

				sprintf(szString,"(%4i,%4i) =  %s (%3i);    ",x,y,szSource,gray);
				//sprintf(szString,"(%4i,%4i) =  %s (%3i|0x%x);    ",x,y,szSource,gray,gray);
			} 
			else {
				WORD	wPixel;
				DWORD	dwPixel;

				if(LOWORD(scrform)==FORM_RGB555) {
					wPixel=((LPWORD)lpPixel)[0];
					b= (wPixel&0x1f)<<3;
					g= ((wPixel>>5)&0x1f)<<3;
					r= ((wPixel>>10)&0x1f)<<3;
				}
				else if(byBits==16) {
					wPixel=((LPWORD)lpPixel)[0];
					b= (wPixel&0x1f)<<3;
					g= ((wPixel>>5)&0x3f)<<2;
					r= ((wPixel>>11)&0x1f)<<3;
				}
				else if(byBits>=24) {
					dwPixel=((LPDWORD)lpPixel)[0];

					b= (BYTE)(dwPixel&0xff);
					g= (BYTE)(dwPixel>>8)&0xff;
					r= (BYTE)(dwPixel>>16)&0xff;

				}
				sprintf(szString,"(%4i,%4i) =  %s (%3i,%3i,%3i);    ",x,y,
											szSource,r,g,b);
				//sprintf(szString,"(%4i,%4i) =  %s (%3i,%3i,%3i), (0x%x, 0x%x, 0x%x);     ",x,y,
				//							szSource,r,g,b,r,g,b);
			
			}
		}

		//2. buffer
		bufform=okSetCaptureParam(hBoard,CAPTURE_BUFRGBFORMAT,GETCURRPARAM); //-1

		//if( LOWORD(bufform)!= LOWORD(scrform) ) 
		{
			long	dwPixel;

			dwPixel=okReadPixel(hBoard,BUFFER,-1,(short)x,(short)y); // read current frame
			switch (LOWORD(bufform) ) { 
				case FORM_GRAY8:
				case FORM_GRAY888:
				case FORM_GRAY8888:
					//dwPixel&=0xffff;
					sprintf(szString+strlen(szString)," BUFFER (%5d), (0x%x)",dwPixel,dwPixel);
					break;
					//dwPixel&=0xff;
				case FORM_GRAY10:
					//dwPixel&=0x3ff;
				case FORM_GRAY12:
					//dwPixel&=0xfff;
				case FORM_GRAY14:  //gray
				case FORM_GRAY16:  //gray
					//dwPixel&=0xffff;
					sprintf(szString+strlen(szString)," BUFFER (%d), (0x%x)",dwPixel,dwPixel);
					break;

				//color
				case FORM_RGB555:
					b= (WORD)((dwPixel&0x1f)<<3);
					g= (WORD)(((dwPixel>>5)&0x1f)<<3);
					r= (WORD)(((dwPixel>>10)&0x1f)<<3);
					sprintf(szString+strlen(szString)," BUFFER (%4i,%4i,%4i), (0x%x,0x%x,0x%x)",r,g,b,r,g,b);
					break;
				case FORM_RGB888:
				case FORM_RGB8888:
				case FORM_RGB8886:
					b= (WORD)(dwPixel&0xff);
					g= (WORD)((dwPixel>>8)&0xff);
					r= (WORD)((dwPixel>>16)&0xff);
					if(LOWORD(bufform)==FORM_RGB8886) {
						b=(b<<2) | (WORD)((dwPixel>>24)&0x3);
						g=(g<<2) | (WORD)((dwPixel>>26)&0x3);
						r=(r<<2) | (WORD)((dwPixel>>28)&0x3);
					}
					sprintf(szString+strlen(szString)," BUFFER (%4i,%4i,%4i), (0x%x,0x%x,0x%x)",r,g,b,r,g,b);
					break;
				default:
					//if(LOWORD(bufform)==FORM_RGB565) {
					b= (WORD)((dwPixel&0x1f)<<3);
					g= (WORD)(((dwPixel>>5)&0x3f)<<2);
					r= (WORD)(((dwPixel>>11)&0x1f)<<3);
					sprintf(szString+strlen(szString)," BUFFER (%4i,%4i,%4i), (0x%x,0x%x,0x%x)",r,g,b,r,g,b);
					//sprintf(szString+strlen(szString)," BUFFER (%4i(0x%x),%4i(0x%x),%4i(0x%x))",r,r,g,g,b,b);
					break;
			}
		}



	}


	GetWindowText(hwnd,szText,200);
	memset(szText+strlen(szText),' ',100);
	strcpy(szText+50,szString);
#ifndef _DEBUG
	sBar->SetPaneText(0, szText);
#endif

	return 1;

}

long exAllocateDIBMemory(HANDLE hBoard )
{
	char	flag=0,string[100];
	DWORD	dwDIBMemSize;
	RECT	rcBuf;


	//allocate memory for bi and dib to paint current window
	if(lpbi==NULL) { //just one time
		lpbi=(LPBITMAPINFOHEADER)GlobalAlloc(GPTR,2048);
	}

	if(!hBoard)
		return 0;

	//get current buffer size
	SetRect(&rcBuf,0,0,-1,-1);
	okSetTargetRect(hBoard,BUFFER,&rcBuf);
	dwDIBMemSize =(((rcBuf.right+3)*4/4)*rcBuf.bottom*4) ; // 32  

	if( dwDIBMemSize>dwDIBCurrSize ) {
		dwDIBCurrSize=dwDIBMemSize;
		GlobalFree(lpdib);
		lpdib=0;
	}
	if( lpbi->biSizeImage>dwDIBCurrSize) {
		dwDIBCurrSize=lpbi->biSizeImage;
		if(lpdib)
			GlobalFree(lpdib);
		lpdib=0;
	}


	if(lpdib==NULL) {
		lpdib=(LPSTR)GlobalAlloc(GPTR,dwDIBCurrSize);
		flag=1; //changed
	}

	if(!lpdib) { //no allocated
		sprintf(string,"Allocate DIB memory failed !");
		MessageBox(hwnd, string,"Warning",MB_OK);
		return FALSE;
	}


	//GlobalMemoryStatus(&Status);
	if((flag==1) ) //re-allocated
	{ //changed or init;		
		if( dwDIBCurrSize<= (4*(1<<20)) ) { //for small than 4M  
			dwMaxMemSize=dwDIBCurrSize*4;//16M
		}else { //big dib
			dwMaxMemSize=dwDIBCurrSize;//
		}
		if(lpMemory)
			GlobalFree(lpMemory);

		lpMemory=(char *)GlobalAlloc(GPTR,dwMaxMemSize);
	}

	return (dwDIBCurrSize); //total allocated
}

int	exStopMulCapture()
{
	int		i;

	if (NoCapture) 
	{
		for(i=0; i<NoCapture; i++) 
		{
			if(lphBoard[i])
				okStopCapture(lphBoard[i]);
		}

		okUnlockAllBuffer();

		for(i=0;i<NoCapture;i++) {
			//close specified board
			if(lphBoard[i])
				okCloseBoard(lphBoard[i]);
			lphBoard[i]=0;
		}
	}

	NoCapture=0; //clear

	return 1;
}

//special demo for measuring trigger speed on trigger mode capturing


exCheckLineScan(HANDLE hBoard)
{
	static	lineLast,lineStart;
	long	lineCount, frmno;
	static  long	length=0;

	if((lineCount=okGetLineReady(hBoard, &frmno, 0))>0) { //line scan
		if(lineLast!=lineCount) { //new line ready
			if(lineLast>0) { //after one line
				if((okGetTickCountMicro(NULL)-lineStart)>200) { //its correct when >200vs
					sprintf(string,"Line=%6i;  Period=%d vs;  ",lineCount, (okGetTickCountMicro(NULL)-lineStart)/(lineCount-lineLast) );
					length=strlen(string);
					string[length]=' ';
					SetWindowText(hwnd,string);

					lineLast=lineCount;
					lineStart=okGetTickCountMicro(NULL);
				}
			}
			else {
				lineLast=lineCount;
				lineStart=okGetTickCountMicro(NULL);
			}
		}

		return length;
	}

	//sprintf(string,"                                                    Current Line =%6i; %d, ",lineCount,frmno );
	//SetWindowText(hwnd,string);

	return length;
}

static bBufToWnd;

LRESULT WINAPI WatchingCapture(HANDLE hBoard) 
{
	long	t1,t2,c1=0,c2=0,count=0;
	int		lineFlag=0,trigMode=0;		

	num=0;
	numframe=0;

	if( LOWORD(okSetCaptureParam(hBoard,CAPTURE_TRIGCAPTURE,-1)) 
		|| HIWORD(okSetVideoParam(hBoard,VIDEO_SIGNALTYPE,-1)) )
		trigMode=1;


	while(1) 
	{

		{
			t1=okGetTickCount();
			do {  //-/  //find high, capturing
				if( !okGetCaptureStatus(hBoard,0) ) //may be stoped
					break; //end this thread

				//check if it is linescan
				lineFlag=exCheckLineScan( hBoard);

				if( (count>10) && (c2>20) ) //just sleep in which coming level will stand longer period
					Sleep(1);

				if(!trigMode) //non trig mode
					if( (okGetTickCount()-t1)>500 ) //1 S too long
						break;
				
			} while( !okGetSignalParam(hBoard, SIGNAL_TRANSFERING ) );
			t2=okGetTickCount();

			t1=t2-t1;
			if(count<10) 
				c1+=t1;

			do { // -\    // find to low, blanking
				if( !okGetCaptureStatus(hBoard,0) )  //may be stoped 
					break;
				//check if it is linescan
				lineFlag=exCheckLineScan( hBoard);

				if( (count>10) && (c1>20) )
					Sleep(1);

				if(!trigMode) //non trig mode
					if( (okGetTickCount()-t2)>500 ) //too long
						break;
			} while( okGetSignalParam(hBoard, SIGNAL_TRANSFERING ) );
			t2=okGetTickCount()-t2;
			if(count<10) 
				c2+=t2;

			if( !okGetCaptureStatus(hBoard,0) ) {  //if end
				break;
			}

			if(bBufToWnd) { //0:screen, 1:buf0, 2:buf1
				exSetToScreen(hBoard, bBufToWnd-1); //buf no 0,1
			}

			if(lineFlag) {
				sprintf(string+lineFlag," | Capturing ratio = %5.2f;  Total frames = %d; ",exCalcCaptureRatio(), numframe++);
			}
			else {
				sprintf(string,"  Capturing ratio = %5.2f;  Total frames = %d; ",exCalcCaptureRatio(), numframe++);
			}
			SetWindowText(hwnd,string);

			count++;
			if(count==10) {
				c1/=count;
				c2/=count;
			} else if(count>=10) {
				count=11; //now not count again
			}
		}
	}

	bBufToWnd=0;

	return 0;
}

HANDLE exCreateWatching(HANDLE hBoard, HWND hWnd, long lBufNo)
{
	HANDLE	hThread;
	DWORD	dwThreadID;
	long	lTransfer;


	if(bDispToScreen) { //backplay

		if( okGetTypeCode(hBoard, NULL)<0)
			return (HANDLE)-1;

		lTransfer=okGetSignalParam(hBoard, SIGNAL_TRANSFERING );
		if( lTransfer==-1) {//not support
			SetWindowText(hWnd," This board not support to display frame rate on capturing !");
			return (HANDLE)-1;
		}

		if( okGetSignalParam(hBoard,SIGNAL_VIDEOEXIST)==0 ) {
			SetWindowText(hWnd," Now no video signal is checked !");
			return (HANDLE)-2; //no video signal
		}

		if(lBufNo) //back display when to buffer
		{
			bBufToWnd=lBufNo;

			blk.iType=BMPHEADER;  //data is dib format
			blk.lpBits=(LPBYTE)lpdib;
			blk.iBitCount=lpbi->biBitCount;
			blk.iWidth=(short)lpbi->biWidth;

			if( okSetCaptureParam(hBoard,CAPTURE_SAMPLEFIELD,-1)==0 ) //sample in field by field
				if( LOWORD(okSetVideoParam(hBoard,VIDEO_SIGNALTYPE,-1))==1 ) //interlace video
					if(okSetConvertParam(hBoard,CONVERT_FIELDEXTEND,-1)!=0 )
						lpbi->biHeight*=2; //double size for ht

			blk.iHeight=-(short)lpbi->biHeight; //note: minus is for invert dib in y by ConvertRect	
		}

		hThread=CreateThread (
			  NULL,
			  0,
			  (LPTHREAD_START_ROUTINE) WatchingCapture,
			  (LPVOID)hBoard,
			  0,
			  &(dwThreadID)
			);


	}
	
	return hThread;
}

DrawToScreenDC(HWND hWnd, HANDLE hBoard, long start, LPBITMAPINFOHEADER	lpBI)
{
	HDC			hDC;
	RECT		rect,rcBuf;
	LPBYTE		lpDIB;
	int			width,height,form;
	long		elapsed,elapsed1;
	BLOCKINFO	BlkInfo;
	static DWORD	dwPaintTime;
	//LPDIRECTDRAWSURFACE     lpDDSPrimary=0;


	rect.right=-1;
	okSetTargetRect(hBoard,SCREEN, &rect);
	form=okSetCaptureParam(hBoard,CAPTURE_SCRRGBFORMAT,-1);
	
	width=rect.right-rect.left;
	width=max(4,width);
	height=rect.bottom-rect.top;
	height=max(1,height);

	rcBuf.right=-1;
	okSetTargetRect(hBoard,BUFFER, &rcBuf);
	BlkInfo.iType=BMPHEADER;//		BLKHEADER;//
	BlkInfo.iWidth=(short)(rcBuf.right-rcBuf.left);
	BlkInfo.iHeight=-(short)(rcBuf.bottom-rcBuf.top);
	BlkInfo.iBitCount=HIWORD(form);//lpApi->byScrBits; //buf
	BlkInfo.iFormType=LOWORD(form);//lpApi->iScrForm;
	BlkInfo.lBlockStep=0;
	BlkInfo.lpBits=(LPBYTE)lpBI+2048;
	
	okConvertRect(hBoard,(TARGET)&BlkInfo,0,BUFFER,start,1); //

	lpDIB=(LPBYTE)lpBI+2048; //okGetBufferAddr(lpApi,0); //


	//if(!(lpApi->lcvtFieldExtend&0x2000) ) 
	{//sync
		//if(dwPaintTime<dwFieldPeriod) //paint faster than monitor fresh
//			okWaitVerticalSync(hBoard,0);
		//	okWaitVerticalSync(lpApi,1);
	}

	elapsed=okGetTickCount();

	if(!okSetConvertParam(hBoard,CONVERT_NOSYNCSCREEN,-1)) { //0: sync
		long	lret;
		lret=SendMessage(hWnd,WM_ASKWAITVERTICAL,0,0);
		if(!lret) //not support message mode
			okWaitVerticalSync(hBoard,0);
	}

	elapsed1=okGetTickCount()-elapsed;

	hDC=GetDC((HWND)hWnd);
	//lplpDD[0]->lpVtbl->GetGDISurface(lplpDD[0], &lpDDSPrimary);
	//lpDDSPrimary->lpVtbl->GetDC(lpDDSPrimary,&hDC);

	//SetScreenPalette(lpApi, hDC);
	//SetStretchBltMode(hDC,STRETCH_DELETESCANS);

	MapWindowPoints(HWND_DESKTOP,hWnd,(LPPOINT)&rect,2);
		
		//sprintf(str,"left=%d,right=%d",rect.left,rect.right);
		//TextOut(hDC,0,0,str,strlen(str));

			SetDIBitsToDevice(hDC,	
				rect.left,rect.top,
				width,height,
				0, lpBI->biHeight-height-0, 
				0,lpBI->biHeight,
				lpDIB,
				(LPBITMAPINFO)lpBI,
				DIB_RGB_COLORS
				);


//			StretchDIBits(hDC,
//				rect.left,rect.top,
//				//lpBI->biWidth,lpBI->biHeight, 
//				width,height,
//				//0,0,
//				LOWORD(lpApi->lcapScrOffsetVid), lpBI->biHeight-height-HIWORD(lpApi->lcapScrOffsetVid), 
//				//lpBI->biWidth,lpBI->biHeight,
//				width,height,
//				lpDIB,(LPBITMAPINFO)lpBI, 
//				DIB_RGB_COLORS,SRCCOPY);
//

	dwPaintTime=(WORD)(okGetTickCount()-elapsed-elapsed1);



	//set bitmap header same as screen
	//SetBitmapData(lpApi, SCREEN, 0, lpApi->lpWndBuf, NULL);	

	//ClientToScreen
	//----comp screen pos

	//lpDDSPrimary->lpVtbl->ReleaseDC(lpDDSPrimary,&hDC);

	ReleaseDC((HWND)hWnd,hDC);



	return dwPaintTime;
}

LRESULT WINAPI CaptureOneByOne(HWND hWnd) 
{
	long		count=0, no, form;
	long		width,height,bytes,lSize;
	RECT		rcBuf, rcScr;
	HANDLE		hBoard;
	char		string[120];

	hBoard=(HANDLE)GetWindowLong(hWnd,GWL_USERDATA);

	rcScr.right=-1;
	okSetTargetRect(hBoard,SCREEN, &rcScr);
	form=okSetCaptureParam(hBoard,CAPTURE_SCRRGBFORMAT,-1);

	rcBuf.right=-1;
	okSetTargetRect(hBoard,BUFFER, &rcBuf);
	
	width= rcBuf.right-rcBuf.left;  
	height= rcBuf.bottom-rcBuf.top;  
	bytes=HIWORD(form+7)/8*8;
	lSize=2048+(long)width*bytes*height*2;
	lpbi=(LPBITMAPINFOHEADER)GlobalAlloc(GPTR,lSize);
	exSetBitmapHeader(lpbi, (short)width, (short)height, HIWORD(form), HIWORD(form));


	//BlkInfo.iWidth=rcBuf.right-rcBuf.left;
	//BlkInfo.iHeight=-(rcBuf.bottom-rcBuf.top);
	//BlkInfo.iBitCount=HIWORD(form);//lpApi->byScrBits; //buf
	//BlkInfo.iFormType=LOWORD(form);//lpApi->iScrForm;
	//BlkInfo.lBlockStep=0;
	//BlkInfo.lpBits=(LPBYTE)lpbi+2048;

	while (1)
	{
		no=okGetSeqCapture(hBoard, 0, count++); //start capture

		DrawToScreenDC(hWnd, hBoard, no, lpbi);

		if(bDispToScreen==1) 
		{
			sprintf(string," Ratio = %5.2f; Total frames =%6i; Current =%6i;  Paint times=%4i     ",exCalcCaptureRatio(),count, no,elapsed);
			SetWindowText(hwnd,string);
		}

	}

	return 1;
}

HANDLE exCreateLoopCapture(HANDLE hBoard, HANDLE hWnd)
{

	DWORD		dwCapThreadID;
	HANDLE		hCapThread;

	::SetWindowLong((HWND)hWnd, GWL_USERDATA, (long)hBoard);

	hCapThread=CreateThread (
		  NULL,
		  0,
		  (LPTHREAD_START_ROUTINE) CaptureOneByOne,
		  (LPVOID)hWnd,
		  0,
		  &(dwCapThreadID)
		);


	return hCapThread;
}	

HANDLE	hStream = NULL;

exCloseThisBoard(HANDLE hBoard)
{
	//okSetVideoParam(hBoard,VIDEO_BRIGHTNESS,10);
	//okSaveInitParam(hBoard,2);
	SendMessage(hwndPlay,WM_COMMAND,IDCANCEL,0);			

	okSetConvertParam(hBoard,CONVERT_UPRIGHT,0); //un
	okSetConvertParam(hBoard,CONVERT_MIRROR,0);

	if(hAudio) {//audio opened
		okCloseAudio(hAudio);
		hAudio=0;
	}
	if(hStream) {//stream opened
		okCloseStream(hStream);
		hStream=0;
	}
	if(hLoopThread) {
		TerminateThread(hLoopThread,0);
		hLoopThread=0;
	}

	//restore interrupt set
	okSetCaptureParam(hBoard,CAPTURE_MISCCONTROL,intrMISCCONTROL|
			(okSetCaptureParam(hBoard,CAPTURE_MISCCONTROL,-1)&~0x3));
	okCloseBoard(hBoard); 

	exStopMulCapture(); //to stop in case mul-capturing
	return 1;
}

void COkMfcView::OnActive() 
{
	//ʵʱʾ

	//must to not match
	m_MatchClient = 0;

	//must not to upright
	m_UptoRightCheck = FALSE;
	m_UptoLeftCheck = FALSE;
	okSetConvertParam(hBoard, CONVERT_UPRIGHT, 0); //un to upright

	exGetBitmapHeader(hBoard, SCREEN, lpbi); 
	lScrnOffset = exSetToWndRectEx(hBoard, hWnd, m_Centerscreen); 
	//UpdateWindow();

	okStopCapture(hBoard); //confirm
	//specail capture to frame
	if (okGetTypeCode(hBoard, NULL) == OK_C70) 
	{
		okCaptureTo(hBoard, FRAME, 0, 0);
		exEnableItem(IDM_ACTIVE, FALSE);
		exEnableItem(IDM_FREEZE, TRUE);
	} //normal to screen
	else 
	{
		if(okCaptureToScreen(hBoard) <= 0)
			MessageBox("Please try 256 color mode for B/W grabber, and 24 bits mode for color grabber.");
		else 
		{
			exEnableItem(IDM_ACTIVE, FALSE);
			exEnableItem(IDM_FREEZE, TRUE);
			bActive = 1;
			if(m_BackToScreen)
				bDispToScreen=1;
			else
				bDispToScreen=0;
			exCreateWatching(hBoard, hWnd, 0); //to screen
		}
	}
	sBar->SetPaneText(0, "ʵʱʾ");
}

BOOL COkMfcView::Create(LPCTSTR lpszClassName, LPCTSTR lpszWindowName, DWORD dwStyle, const RECT& rect, CWnd* pParentWnd, UINT nID, CCreateContext* pContext) 
{
	BOOL b;

	b = CWnd::Create(lpszClassName, lpszWindowName, dwStyle, rect, pParentWnd, nID, pContext);
	hwnd = pParentWnd->GetSafeHwnd();	
	exGetInitSet(hWnd);
	hBoard = exOpenCard(hWnd);
	//make mirror when convert
	okSetConvertParam(hBoard, CONVERT_MIRROR, bMakeMirror);
	hWnd = GetSafeHwnd();			//have problem
	return b;
}

void COkMfcView::OnDestroy() 
{
	CView::OnDestroy();

	exCloseThisBoard(hBoard);

	GlobalFree((HGLOBAL)lpbi);  
	lpdib = 0;
	exSaveInitSet();
}

exEndCaptureAudio(HANDLE hAudio)
{
	if (hAudio) 
	{
		elapsedtimes = GetTickCount() - elapsedtimes;
		sprintf(str," Stoped ! captured times = %d ms",elapsedtimes);
		AfxGetApp()->m_pMainWnd->SetWindowText(str);
		ReleaseDC(AfxGetApp()->m_pMainWnd->GetSafeHwnd(), hdc);
		
		okStopCaptureAudio(hAudio);
		okCloseAudio(hAudio);
		hAudio = 0;

		//way1 and way2 end file

	}

	return 1;
}

void COkMfcView::OnFreeze() 
{
	//ֹͣ
	if (hAudio)  //audio capturing
		exEndCaptureAudio(hAudio);

	exStopMulCapture(); //to stop in case mul-capturing

	if(hLoopThread) {
		TerminateThread(hLoopThread,0);
		hLoopThread=0;
	}

	okStopCapture(hBoard);
	ValidateRect(NULL);
	if (bActive) 
	{	
		//take buffer size
		exGetBitmapHeader(hBoard, BUFFER, lpbi); 
		exSetDataToDIB(SCREEN, 0, lpbi, (unsigned char *)lpdib);
		//exGetBitmapData(hBoard, SCREEN, 0, lpbi, lpdib);
		exDisplayDIBInfo();
	}
	bActive = 0;
	exEnableItem(IDM_FREEZE, FALSE);
	exEnableItem(IDM_ACTIVE, TRUE);
}

/*
* ܣʾǰɼϢ
*			ڱ׼CʾнϢʾڱ
*			ڸʾʾ״̬
*			ʽ
* ھ
* 
*   ֵ
*/
void COkMfcView::exDisplayDIBInfo(void)
{

	char	string[200];

	sprintf(string,"%d x %d x %d", lpbi->biWidth, lpbi->biHeight, lpbi->biBitCount);
	if (lpbi->biWidth)
		sBar->SetPaneText(0,string);
}

void COkMfcView::OnSinglecapto() 
{
	//֡
	SendMessage(WM_COMMAND,IDM_FREEZE,0);

	if (okGetTypeCode(hBoard,NULL) == OK_C70)   //to frame
	{
		okCaptureTo(hBoard,FRAME,0,1);
//test						okGetCaptureStatus(hBoard,1);

		if(okConvertRect(hBoard,SCREEN,0,FRAME,0,1)>0) {
			//okConvertRect(hBoard,BUFFER,0,FRAME,0,0x30001); //test
			//take buffer size
			exGetBitmapHeader(hBoard, BUFFER, lpbi); 
			exSetDataToDIB(SCREEN, 0, lpbi, (LPBYTE)lpdib);
		}
	}
	else
	{
		long	basetime,elapse,times,times1,times2,lret;
		char	str[120];

		strcpy(str,"");
		lret=okSetCaptureParam(hBoard,CAPTURE_TRIGCAPTURE,-1);
		if( LOWORD(lret)>0 ) {
			sprintf(str," Triggered capture mode!   Now waiting for trigger ...");
		}
		else {
			lret=okSetVideoParam(hBoard,VIDEO_SIGNALTYPE,-1);
			if(HIWORD(lret))
				sprintf(str," Video by external trigger!   Now waiting for video of next frame ...");
		}

		if(strlen(str))
			sBar->SetPaneText(0, str);
			//SetWindowText(str);


		basetime=okGetTickCount();
		//okCaptureTo(hBoard,SCREEN,0,1);//single
		//okCaptureSingle(hBoard,BUFFER,0);//single
		okCaptureTo(hBoard,BUFFER,0,1);//single
		//okCaptureSequence(hBoard,0,1);//single
		elapse=okGetTickCount();
		//okCaptureSequence(hBoard,0,1);//single
		okGetCaptureStatus(hBoard,1);
		times=okGetTickCount();
		//okSleep(20);						

		//buf->scr
		exGetBitmapHeader(hBoard, BUFFER, lpbi); 
		exSetDataToDIB(BUFFER, 0, lpbi, (LPBYTE)lpdib);
		times1=okGetTickCount();

		lScrnOffset=exSetToWndRectEx( hBoard,hWnd,m_Centerscreen);
		InvalidateRect(NULL,FALSE);
		UpdateWindow();

		times2=okGetTickCount();
		//okStopCapture(hBoard);

		sprintf(str," Start=%d ms,  Capture=%d ms,  Trans=%d,  Paint=%d ms",elapse-basetime,times-elapse,times1-times, times2-times1);
		sBar->SetPaneText(0, str);
		//SetWindowText(str);
	}
}

void COkMfcView::OnPaint() 
{
//	CPaintDC dc(this); // device context for painting
	{
		PAINTSTRUCT	ps;
		HDC			hDC;
		CDC*		cdc;
		LPBITMAPINFOHEADER	lpBI;
		LPBYTE				lpDIB;
		HDRAWDIB	hdd;
		//HPALETTE	hPal;		

		//hWnd = GetSafeHwnd();
		//hDC = ::BeginPaint(hWnd, &ps);
		cdc = BeginPaint(&ps);
		hDC = cdc->m_hDC;
		exSetPaletteToWnd(hDC);

		lpBI = lpbi;
		lpDIB = (LPBYTE)lpdib;
			
		if (lpBI) 
		{
			RECT	rect;	POINT	pt;
			short	scrbits;

			scrbits = HIWORD(okSetCaptureParam(hBoard, CAPTURE_SCRRGBFORMAT, GETCURRPARAM));
			GetClientRect(&rect);
			if (lpBI->biHeight>rect.bottom)
				rect.top = lpBI->biHeight-rect.bottom;
			else
				rect.top = 0;
			//pt.x=rect.left;
			//ClientToScreen(hWnd,&pt);

			//adjust x abs. offset to 4 align
			//pt.x=LOWORD(lScrnOffset);
			//pt.x= pt.x%4 ? pt.x+4-pt.x%4 : pt.x;
			//pt.y=HIWORD(lScrnOffset);

			pt.x = LOWORD(lScrnOffset);
			pt.y = HIWORD(lScrnOffset);
			ClientToScreen(&pt);
			//adjust x abs. offset to 4 align
			//pt.x = pt.x%4 ? pt.x+4-pt.x%4 : pt.x;
			ScreenToClient(&pt);
				
			hdd = DrawDibOpen(); //when to 8 bit dib on NT platform you should use function group DrawDib
							//because they are too slow with GDI funtions group
						// to use DrawDib you must add vfw.h and vfw32.lib 

			//hPal=exSetPaletteToWnd(hDC);
				
			if(!okSetConvertParam(hBoard,CONVERT_NOSYNCSCREEN,-1)) //0: sync
				okWaitVerticalSync(hBoard,1); //);

			GetVersion();
			if (m_MatchClient == 0) 
				if ((scrbits==8) && (lpBI->biBitCount != 8))  //only on NT4.0 need to do so 
				{
					//DrawDibDraw can not support 16 and 32
					DrawDibDraw(hdd, hDC,				//you must add vfw32.lib 	
						pt.x, pt.y,
						lpBI->biWidth, lpBI->biHeight,				
						(LPBITMAPINFOHEADER)lpBI, lpDIB,
						0, 0, 
						lpBI->biWidth, lpBI->biHeight,
						//DDF_SAME_HDC );
						DDF_BACKGROUNDPAL );
				}
				else  //you can always use this on win95/98/2000
				{
					SetDIBitsToDevice(hDC,	
						pt.x, pt.y,
						lpBI->biWidth, lpBI->biHeight,				
						0, 0,//rect.top, 
						0, lpBI->biHeight,
						lpDIB,
						(LPBITMAPINFO)lpBI,
						DIB_RGB_COLORS
						);
				}
			else //strech in order to match client rect
			{
				rect.left = pt.x;
				rect.top = pt.y;
				if ((iClientWidth > 0) && (iClientHeight>0)) 
				{
					rect.right = iClientWidth + rect.left;
					rect.bottom = iClientHeight + rect.top;
				}

				if ((scrbits == 8) && (lpBI->biBitCount != 8))  //only on NT4.0 need to do so 
				{
					DrawDibDraw(hdd, hDC,
						rect.left,rect.top,
						rect.right,rect.bottom, 
						(LPBITMAPINFOHEADER)lpBI, lpDIB,
						0, 0, 
						lpBI->biWidth, lpBI->biHeight,
						DDF_BACKGROUNDPAL );
				}
				else  //you can always use this on win95/98/2000
				{
					SetStretchBltMode(hDC, STRETCH_DELETESCANS);     
					StretchDIBits(hDC,
						rect.left, rect.top,
						rect.right, rect.bottom, 
						0, 0, 
						lpBI->biWidth, lpBI->biHeight,
						lpDIB, (LPBITMAPINFO)lpBI, 
						DIB_RGB_COLORS,SRCCOPY);
				}
			}
			DrawDibClose(hdd);
		}

		EndPaint(&ps);
	}
	// Do not call CView::OnPaint() for painting messages
}

void COkMfcView::OnExttrigger() 
{
	//ⴥ
	char	string[128];
	int		trigger;

	okCaptureToScreen(hBoard);
	sprintf(string, " Waiting extern trigger...");
	sBar->SetPaneText(0, string);
	trigger = okWaitSignalEvent(hBoard, EVENT_EXTTRIGGER, 10000);//max 10 seconds
	if (trigger == 1) 
		sprintf(string, " Extern trigger came.");
	else if (trigger == -1)
		sprintf(string, " Not support trigger");
	else
		sprintf(string, " Waiting time out");
	okStopCapture(hBoard);
	sBar->SetPaneText(0, string);
}

void COkMfcView::OnAbout() 
{
	//ϵͳϢ
	CInfoBox	infoBox;
	infoBox.DoModal();
}

void COkMfcView::OnSignaleinfo() 
{
	//źԴϢ
	CSignBox	signBox;
	signBox.DoModal();
}

void COkMfcView::OnBacktoscreen() 
{
	//ʹвɼʾ

	if (m_BackToScreen)
		m_BackToScreen = FALSE;
	else
		m_BackToScreen = TRUE;
}

void COkMfcView::OnUpdateBacktoscreen(CCmdUI* pCmdUI) 
{
	//˵
	pCmdUI->SetCheck(m_BackToScreen);
}

void COkMfcView::OnCaptobuffer() 
{
	//вɼ
	long num;

	exEnableItem(IDM_FREEZE, TRUE);
	if(m_BackToScreen)
		bDispToScreen=1;
	else
		bDispToScreen=0;
	okSetSeqCallback(hBoard, exBeginCapture, exBackDisplay, exEndCapture);
	//okSetSeqProcWnd(hBoard,hWnd);
	num = okGetBufferSize(hBoard, NULL, NULL);//			
	okCaptureTo(hBoard, BUFFER, 0, num);//
}

void COkMfcView::OnLooptobuffer() 
{
	//ѭвɼ
	exEnableItem(IDM_FREEZE, TRUE);
	if(m_BackToScreen)
		bDispToScreen=1;
	else
		bDispToScreen=0;
	okSetSeqCallback(hBoard, exBeginCapture, exBackDisplay, exEndCapture);
	//okSetSeqProcWnd(hBoard,hWnd);
	okCaptureTo(hBoard, BUFFER, 0, -1);//-1: loop infiniately
	//okCaptureSequence(hBoard, 0, -1);//-1: loop infiniately
}

void COkMfcView::OnSetupvideo() 
{
	//ò

	//restore interrupt set
	okSetCaptureParam(hBoard,CAPTURE_MISCCONTROL,intrMISCCONTROL|
			(okSetCaptureParam(hBoard,CAPTURE_MISCCONTROL,-1)&~0x3));

	okOpenSetParamDlg(hBoard, hWnd);
	//may be initialized
	intrMISCCONTROL=okSetCaptureParam(hBoard,CAPTURE_MISCCONTROL,-1)&0x3;

	//dest(buffer) rect may be changed
	exGetBitmapHeader(hBoard, BUFFER, lpbi); 
	//get current size  
	sampwidth = (short)lpbi->biWidth;
	sampheight = (short)lpbi->biHeight;
	lScrnOffset = exSetToWndRectEx(hBoard, hWnd, m_Centerscreen);
	//get current mask mode
	m_Enablemask = (short)okEnableMask(hBoard, -1);
	if( !okSetConvertParam(hBoard,CONVERT_UPRIGHT,-1))  //rotate offed
	{
		m_UptoRight = TRUE;
		m_UptoLeft = TRUE;
	}
	InvalidateRect(NULL, TRUE);
}

void COkMfcView::OnCapsequence() 
{
	//вɼ	
	total = okOpenSeqCaptureDlg(hBoard, hWnd);
	//dest(buffer) rect may be changed
	exGetBitmapHeader(hBoard, BUFFER, lpbi); 
	//get current size  
	sampwidth = (short)lpbi->biWidth;
	sampheight = (short)lpbi->biHeight;
	lScrnOffset = exSetToWndRectEx(hBoard, hWnd, m_Centerscreen);
}

void COkMfcView::OnUpdateCenterscreen(CCmdUI* pCmdUI) 
{
	pCmdUI->SetCheck(m_Centerscreen);
}

void COkMfcView::OnCenterscreen() 
{
	//ʹɼĻ

	if (m_Centerscreen)
		m_Centerscreen = 0;
	else
		m_Centerscreen = 1;
	lScrnOffset = exSetToWndRectEx(hBoard, hWnd, m_Centerscreen); 
	InvalidateRect(NULL, TRUE);
}

void COkMfcView::OnEnablemask() 
{
	//ɼλĻ

	if(m_Enablemask)
		m_Enablemask = 0; //disable mask
	else
		m_Enablemask = 1; //positive mask
	okEnableMask(hBoard, m_Enablemask); //set mask
}

void COkMfcView::OnReplaybuffer() 
{
	//طŻ

	total = (short)okGetBufferSize(hBoard, NULL, NULL);
	//way 1 fresh image on hWnd by thie function
	//SetWindowLong(hWnd,GWL_USERDATA,lScrnOffset);
	//lpDibPlay=okOpenReplayDlg(hBoard, hWnd, BUFFER,total);
	//way 2 fresh image on hWnd by user 
	hwndPlay = okOpenReplayDlgEx(hBoard, hWnd, BUFFER, total, lpbi, (LPBYTE)lpdib);
}

void COkMfcView::OnReplaymemory() 
{
	//طڴ
	int	num;

	num = dwMaxMemSize/exGetFrameSize(hBoard);
	if (lpbi)
		//lpDibPlay=okOpenReplayDlg(hBoard, hWnd, (TARGET)lpMemory,num);
		hwndPlay = okOpenReplayDlgEx(hBoard, hWnd, (TARGET)lpMemory, num, lpbi, (LPBYTE)lpdib);
}

void COkMfcView::OnReplayfile() 
{
	//طļ
	char	szFileName[128]="\0";
	CSeqNum	csf;

	if (!exGetLoadName(hWnd, szFileName))
		return;
	if (stricmp(strrchr(szFileName, '.'), ".seq")) //non seq file
	{
		if (!csf.DoModal()) return;
	}
	else
		//just get num
		iNumImage = (short)okLoadImageFile(hBoard, szFileName, 0, SCREEN, 0, 0);

	hwndPlay = okOpenReplayDlgEx(hBoard, hWnd, (TARGET)szFileName, iNumImage, lpbi, (LPBYTE)lpdib);
}

void COkMfcView::OnBuffertoscreen() 
{
	//0Ļ

	exSetDataToDIB(BUFFER, 0, lpbi, (LPBYTE)lpdib);
	InvalidateRect(NULL, FALSE);
}

void COkMfcView::OnScreentobuffer() 
{
	//Ļ0

	okConvertRect(hBoard, BUFFER, 0, SCREEN, 0, 1);
}

void COkMfcView::OnBuffer0tobuffer1() 
{
	//01

	okTransferRect(hBoard, BUFFER, 1, BUFFER, 0, 1);
}

void COkMfcView::OnBuffer1tobuffer0() 
{
	//10

	okTransferRect(hBoard, BUFFER, 0, BUFFER, 1, 1);
}

void COkMfcView::OnBuffertoframe() 
{
	//0֡

	exEnableItem(IDM_FREEZE, TRUE);
	if (okGetTypeCode(hBoard, NULL) == OK_M60) //special for M60 with frame
		//can only by TransferRect for M60
		okTransferRect(hBoard, FRAME, 0, BUFFER, 0, 1);
	else
		okConvertRect(hBoard, FRAME, 0, BUFFER, 0, 1);
}

void COkMfcView::OnFrametobuffer() 
{
	//֡洫0
	
	okConvertRect(hBoard, BUFFER, 0, FRAME, 0, 1);
}

void COkMfcView::OnFrametoscreen() 
{
	//֡洫Ļ

	if (okConvertRect(hBoard, SCREEN, 0, FRAME, 0, 1) > 0) 
	{
		//take buffer size
		exGetBitmapHeader(hBoard, BUFFER, lpbi); 
		exSetDataToDIB(SCREEN, 0, lpbi, (LPBYTE)lpdib);
	}
}

void COkMfcView::OnCaptomemory() 
{
	//вɼڴ
	
	exEnableItem(IDM_FREEZE, TRUE);
	if(m_BackToScreen)
		bDispToScreen=1;
	else
		bDispToScreen=0;
	okSetSeqCallback(hBoard, exBeginCapture, exBackDisplay, exEndCapture);
	if (lpbi) {
		int			num;
		BLOCKINFO	blk;

		blk.iType = BLKHEADER;
		blk.lpBits = (LPBYTE)lpMemory;
		num = dwMaxMemSize/exGetFrameSize(hBoard);
		lpMemory[0]=0;
		//okCaptureByBuffer(hBoard, (TARGET)lpMemory, 0, num);
		okCaptureByBuffer(hBoard,(TARGET)&blk,0,num);
	}
}

void COkMfcView::OnCaptoseqfile() 
{
	//ɼļ
	CSeqNum	csf;
	char	szFileName[128]="\0";
	
	if (!exGetSaveName(hWnd, szFileName))
		return;

	exEnableItem(IDM_FREEZE, TRUE);
	if(m_BackToScreen)
		bDispToScreen=1;
	else
		bDispToScreen=0;
	okSetSeqCallback(hBoard, exBeginCapture, exBackDisplay, exEndCapture);
	if (csf.DoModal()) 
	{
		//first delete ok.seq
		DeleteFile(seqfile);
		MessageBox(szFileName);
		okCaptureByBuffer(hBoard, (TARGET)szFileName, 0, iNumImage);
	}
	else
	{
		exEnableItem(IDM_FREEZE, FALSE);
	}
}

void COkMfcView::OnCaptoindirect() 
{
	//()ʵʱʾ
	exEnableItem(IDM_FREEZE, TRUE);
	okSetConvertParam(hBoard, CONVERT_PALETTE, (LPARAM)NULL);
	bDispToScreen = 2;
	okSetSeqCallback(hBoard,exBeginCapture,exBackDisplay,exEndCapture);
	//just capture to buffer
	okCaptureByBuffer(hBoard, BUFFER, 0, 0);//0: cont.
}

void COkMfcView::OnCaptodirect() 
{
	//(ͣ)ʵʱ
	okStopCapture(hBoard);

	//must not to upright
	m_UptoRightCheck = FALSE;
	m_UptoLeftCheck = FALSE;
	okSetConvertParam(hBoard,CONVERT_UPRIGHT,0); //un to upright

	lScrnOffset = exSetToWndRectEx(hBoard, hWnd, m_Centerscreen);
	if (okCaptureToScreen(hBoard) <= 0)
		MessageBox("Please try 256 color mode for B/W grabber, and 24 bits mode for color grabber.");
	else {
		MSG		msg;

		exEnableItem(IDM_ACTIVE, FALSE);
		exEnableItem(IDM_FREEZE, TRUE);
		bActive = 1;
		//okCaptureTo(hBoard,BUFFER,0,0);//0: cont.
		//SleepEx(40,TRUE);				

		SetCapture();
		while (1) {

			//PeekMessage(&msg, NULL, 0, 0, PM_REMOVE);
			GetMessage(&msg, NULL, 0, 0);
			if ((msg.message == WM_KEYDOWN) ||
				(msg.message == WM_LBUTTONDOWN) ||
				(msg.message == WM_NCLBUTTONDOWN)) {
				break;
			}
		}
		ReleaseCapture();

		SendMessage(WM_COMMAND, IDM_FREEZE, 0);
		InvalidateRect(NULL, TRUE);
		//UpdateWindow(NULL);
	}
	
}

void COkMfcView::OnCaptoforever() 
{
	//()ʵʱ

	//must to not match
	m_MatchClient = 0;

	//must not to upright
	m_UptoRightCheck = FALSE;
	m_UptoLeftCheck = FALSE;
	okSetConvertParam(hBoard, CONVERT_UPRIGHT, 0); //un to upright

	exGetBitmapHeader(hBoard, SCREEN, lpbi); 
	lScrnOffset = exSetToWndRectEx(hBoard, hWnd, m_Centerscreen); 
	//UpdateWindow(hWnd);
	okStopCapture(hBoard); //confirm
	//specail capture to frame
	if (okGetTypeCode(hBoard, NULL) == OK_C70) {

		okCaptureTo(hBoard, FRAME, 0, 0);
		exEnableItem(IDM_ACTIVE, FALSE);
		exEnableItem(IDM_FREEZE, TRUE);


	} //normal to screen
	else if (okCaptureToScreen(hBoard) <= 0)
		MessageBox("Please try 256 color mode for B/W grabber, and 24 bits mode for color grabber.");
	else {
		exEnableItem(IDM_ACTIVE, FALSE);
		exEnableItem(IDM_FREEZE, TRUE);
		bActive = 2;
		if(m_BackToScreen)
			bDispToScreen=1;
		else
			bDispToScreen=0;
		exCreateWatching(hBoard, hWnd, 0); //to screen
	}
}

void COkMfcView::OnConttobuffer0() 
{
	//ʵʱɵ0
	exEnableItem(IDM_FREEZE, TRUE);
	okCaptureTo(hBoard, BUFFER, 0, 0);
	if(m_BackToScreen)
		bDispToScreen=1;
	else
		bDispToScreen=0;
}

void COkMfcView::OnConttobuffer1() 
{
	//ʵʱɵ1
	exEnableItem(IDM_FREEZE, TRUE);
	okCaptureTo(hBoard, BUFFER, 1, 0);
	if(m_BackToScreen)
		bDispToScreen=1;
	else
		bDispToScreen=0;
}

void COkMfcView::OnCaptoframe() 
{
	//ʵʱɵ֡
	exEnableItem(IDM_FREEZE, TRUE);
	okCaptureTo(hBoard, FRAME, 0, 0); //cont.
}

void COkMfcView::OnDispfrombuffer() 
{
	//л
	long num;

	if (m_BackToScreen)
		bDispToScreen=1;
	else
		bDispToScreen=0;
	//bDispToScreen=0;
	OnFreeze();
	exEnableItem(IDM_FREEZE, TRUE);
	okSetSeqCallback(hBoard, exBeginCapture, exBackDisplay, exEndCapture);
	num = okGetBufferSize(hBoard, NULL, NULL);//			

	okPlaybackFrom(hBoard, BUFFER, 0, num);//
}

void COkMfcView::OnLoopfrombuffer() 
{
	//ѭл
	long num;

	if (m_BackToScreen)
		bDispToScreen=1;
	else
		bDispToScreen=0;
	//bDispToScreen=0;
	OnFreeze();
	exEnableItem(IDM_FREEZE, TRUE);
	okSetSeqCallback(hBoard, exBeginCapture, exBackDisplay, exEndCapture);
	num = okGetBufferSize(hBoard, NULL, NULL);//
	
	okPlaybackFrom(hBoard, BUFFER, 0, -num);//
}

void COkMfcView::OnDispfrommemory() 
{
	//ѭлڴ
	long num;

	exEnableItem(IDM_FREEZE, TRUE);
	okSetSeqCallback(hBoard, exBeginCapture, exBackDisplay, exEndCapture);
	if (lpbi) {
		num = dwMaxMemSize/exGetFrameSize(hBoard);
		okPlaybackByBuffer(hBoard, (TARGET)lpMemory, 0, -num);
	}
}

void COkMfcView::OnDispfromfile() 
{
	//ѭлļ
	CSeqNum	csf;
	char	szFileName[128]="\0";
	long num;

	if (!exGetLoadName(hWnd, szFileName))
		return;
	exEnableItem(IDM_FREEZE, TRUE);
	okSetSeqCallback(hBoard, exBeginCapture, exBackDisplay, exEndCapture);
	if (!stricmp(strrchr(szFileName, '.'), ".seq")) 
		//just get num
		num = okLoadImageFile(hBoard, szFileName, 0, SCREEN, 0, 0);
	else {
		if (!csf.DoModal())
			exEnableItem(IDM_FREEZE, FALSE);
		num = iNumImage;
	}
	okPlaybackByBuffer(hBoard, (TARGET)szFileName, 0, -num);
}

void COkMfcView::OnCaptomonitor() 
{
	//ʾƵ
	exEnableItem(IDM_FREEZE, TRUE);
	okCaptureTo(hBoard, MONITOR, 0, 0);//0: cont.
}

void COkMfcView::OnDispfromframe() 
{
	//֡
	exEnableItem(IDM_FREEZE, TRUE);
	okPlaybackFrom(hBoard, FRAME, 0, 0); //cont.
}

void COkMfcView::OnNormallut() 
{
	//
	exFillOutLUT(hBoard, 0);
}

void COkMfcView::OnInverselut() 
{
	//
	exFillOutLUT(hBoard, 1);
}


void COkMfcView::OnAbsolutelut() 
{
	//ֵʾ
	exFillOutLUT(hBoard, 2);
}

void COkMfcView::OnSelectcard() 
{
	//ѡͼ
	CSelectBox	selectBox;
	HANDLE	hOld;
	int i;

	hOld=hBoard;

	i = selectBox.DoModal();
	if (i != 1)
		return;

	exCloseThisBoard(hBoard);

	hBoard=exOpenCard(hwnd);
	bActive=0;
}

void COkMfcView::OnUpdateCaptoframe(CCmdUI* pCmdUI) 
{
	pCmdUI->Enable(m_CapToFrame);
}

void COkMfcView::OnUpdateBuffertoframe(CCmdUI* pCmdUI) 
{
	pCmdUI->Enable(m_BufferToFrame);
}

void COkMfcView::OnUpdateFrametobuffer(CCmdUI* pCmdUI) 
{
	pCmdUI->Enable(m_FrameToBuffer);	
}

void COkMfcView::OnUpdateFrametoscreen(CCmdUI* pCmdUI) 
{
	pCmdUI->Enable(m_FrameToScreen);
}

void COkMfcView::OnUpdateNormallut(CCmdUI* pCmdUI) 
{
	pCmdUI->Enable(m_NormalLut);
}

void COkMfcView::OnUpdateInverselut(CCmdUI* pCmdUI) 
{
	pCmdUI->Enable(m_InverseLut);	
}

void COkMfcView::OnLoadfile() 
{
	//װͼļ
	okStopCapture(hBoard);
	if (bActive){
		SendMessage(WM_COMMAND, IDM_FREEZE, 0);
	}
	exLoadImageFile(hBoard, hWnd);
	lScrnOffset=exSetToWndRectEx(hBoard, hWnd, m_Centerscreen);
	InvalidateRect(NULL, TRUE);

	exDisplayDIBInfo();
}

void COkMfcView::OnSavescreen() 
{
	exSaveScreenFile(hBoard, hWnd);
	InvalidateRect(NULL, FALSE);
}

void COkMfcView::OnSavebuffer() 
{
	//滺
	exSaveBufferFile(hBoard, hWnd);
	InvalidateRect(NULL, FALSE);
}

void COkMfcView::OnSettoband() 
{
	//״ɫ
	//set gray and color bands to dib and buffer 0
	LPBYTE	lpLinear;
	short	height,width;
	long	stride;
	BLOCKINFO	blk;
	
	//set dib 
	exSetTestBands((LPBYTE)lpdib, (short)lpbi->biBitCount, (short)lpbi->biHeight, lpbi->biSizeImage/lpbi->biHeight); 
	exConvertBitmap(lpbi,lpdib);

	lpLinear=(LPBYTE)okGetTargetInfo(hBoard,BUFFER,0, &width,&height,&stride);
	if(lpLinear && (lpbi->biBitCount!=24) ) {
		exSetTestBands(lpLinear,(short)(stride/width*8),height, stride); //buffer
		exSetDataToDIB(BUFFER, 0, lpbi, (LPBYTE)lpdib);
	}
	else { //dib is 24 bits mode
		//set dib first
		exSetTestBands((LPBYTE)lpdib, (short)lpbi->biBitCount, (short)lpbi->biHeight, lpbi->biSizeImage/lpbi->biHeight); 
		exConvertBitmap(lpbi,lpdib);

		ZeroMemory(&blk,sizeof(BLOCKINFO));
		//get image to app buffer from tgt
		blk.lpBits=(LPBYTE)lpdib;			
		blk.iWidth=(short)lpbi->biWidth;
		blk.iHeight=-(short)lpbi->biHeight; //!!!to invert y
		blk.iBitCount=lpbi->biBitCount;
		blk.lBlockStep=(short)lpbi->biSizeImage; //must be set
		blk.iHiStep=HIWORD(lpbi->biSizeImage);
		if(lpbi->biCompression==BI_BITFIELDS ) {//
			DWORD	*lpMask;
			lpMask=(DWORD *)((LPBYTE)lpbi+lpbi->biSize);
			if(lpMask[1]==0x03e0) //555
				blk.iFormType=FORM_RGB555;
			else if(lpbi->biBitCount==16)
				blk.iFormType=FORM_RGB565;
			else if(lpbi->biBitCount==32)
				blk.iFormType=FORM_RGB8888;
		}
		okConvertRect(hBoard,BUFFER,0,(TARGET)&blk,0,1);
	}
	InvalidateRect(NULL, FALSE);
}

/*
* ܣװļ
* hWndھ
* szFileNameļ
*   ֵȷTRUE
*			󷵻FALSE
*/
BOOL COkMfcView::exGetLoadName(HWND hWnd, char *szFileName)
{
	OPENFILENAME ofn;	 
	char		*szFilter=
					"BMP file  (*.BMP)\0*.BMP\0"
					"Jpeg format file (*.JPG,JPEG)\0*.JPG;*.JPEG\0"
					"Sequence file  (*.SEQ)\0*.SEQ\0"
					"Audio-video interleaved (*.AVI)\0*.AVI\0"
					"Mpeg2 Video stream (*.M2V)\0*.M2V\0"
					"TIFF file  (*.TIF)\0*.TIF\0"
					"GIF file  (*.GIF)\0*.GIF\0"
					"Raw format files (*.RAW)\0*.RAW\0"
					"All Above format files \0*.BMP;*.JPG;*.JPEG;*.SEQ;*.AVI;*.M2V;*.TIF;*.GIF;*.RAW\0";

    //Get file name
	// fill in non-variant fields of OPENszFileName struct. 
    ZeroMemory(&ofn,sizeof(OPENFILENAME));
	ofn.lStructSize		= sizeof(OPENFILENAME);
    ofn.hwndOwner	  	= hWnd;
    ofn.lpstrFilter 	= szFilter;
	ofn.nFilterIndex	= 8;
    ofn.lpstrFile	  	= szFileName;
    ofn.nMaxFile	  	= 256;
    ofn.Flags		  	= OFN_HIDEREADONLY|OFN_LONGNAMES;

    if (!GetOpenFileName((LPOPENFILENAME)&ofn)) {
		return FALSE;
	}
	return TRUE;

}

/*
* ܣñļ
* hWndھ
* szFileNameļ
*   ֵȷTRUE
*			󷵻FALSE
*/
BOOL COkMfcView::exGetSaveName(HWND hWnd, char *szFileName)
{
	OPENFILENAME ofn;	 
	char		*szFilter=
					"BMP file (*.BMP)\0*.BMP\0"
					"Jpeg format file (*.JPG)\0*.JPG\0"
					"Sequence file (*.SEQ)\0*.SEQ\0"
					"Sequence file in JPEG (*.SEQ)\0*.SEQ\0"
					"Audio-video interleaved (*.AVI)\0*.AVI\0"
					"Compressed AVI in MJPEG  (*.AVI)\0*.AVI\0"
					"Compressed AVI in MPEG4  (*.AVI)\0*.AVI\0"
					"Jpeg 2000 format file (*.JP2)\0*.JP2\0"
					"MPEG2(DVD) file (*.MPG)\0*.MPG\0"
					"TIFF format file (*.TIF)\0*.TIF\0"
					"Raw format files (*.RAW)\0*.RAW\0";

    //Get file name
	// fill in non-variant fields of OPENszFileName struct. 
    ZeroMemory(&ofn,sizeof(OPENFILENAME));
    ofn.lStructSize		= sizeof(OPENFILENAME);
    ofn.hwndOwner	  	= hWnd;
    ofn.lpstrFilter 	= szFilter;
	ofn.nFilterIndex	= 1;
    ofn.lpstrFile	  	= szFileName;
    ofn.nMaxFile	  	= 256;
	ofn.lpstrDefExt		= "seq";

    ofn.Flags		  	= OFN_HIDEREADONLY|OFN_OVERWRITEPROMPT;

    if (!GetSaveFileName((LPOPENFILENAME)&ofn)) {
		return FALSE;
	}

	if( !strnicmp(strrchr(szFileName,'.'),".seq",4) ||
			!strnicmp(strrchr(szFileName,'.'),".avi",4) ||
				!strnicmp(strrchr(szFileName,'.'),".m2v",4) 
		)  {
		//first delete ok.seq or .avi
		DeleteFile(szFileName);							
	}

	if(ofn.nFilterIndex==4) { //seq file in jpeg data
		strcat(szFileName,",jpg,50"); //quality=50
	}
	else if(ofn.nFilterIndex==6) { //avi in mjpg
		strcat(szFileName,",mjpg,60"); //mjpeg
	}
	else if(ofn.nFilterIndex==7) { //avi in mpeg4
		strcat(szFileName,",mpg4"); //mpeg4 ,default 6 (2~31)
	}

	return TRUE;
}

/*
* ܣװͼļ
* hBoardɼ
*			hWndھ
* 
*   ֵȷTRUE
*			󷵻FALSE
*/
BOOL COkMfcView::exLoadImageFile(HANDLE hBoard, HWND hWnd)
{
	CSeqNum		csf;
	char		szFileName[512]="\0";
	short		total;
	long		length;
	BLOCKINFO	blkinfo;

	if (!exGetLoadName(hWnd, szFileName))
		return FALSE;

	if (!strrchr(szFileName, '.'))
		return FALSE;

	if (!strnicmp(strrchr(szFileName,'.'),".seq",4) ||
			!strnicmp(strrchr(szFileName,'.'),".avi",4) ||
				!strnicmp(strrchr(szFileName,'.'),".m2v",4) ||
					!strnicmp(strrchr(szFileName,'.'),".mpg",4))
	{ 		
		//first get inf about seq file 		
		total = (short)okLoadImageFile(hBoard, szFileName, 0, (TARGET)&blkinfo, 0, 0);//no=0

		//how many
		lNumImage=total;
		length=total;

		if (csf.DoModal())
		{
			total=(short)lNumImage;


		
			//then load them into buffer
			if (okLoadImageFile(hBoard, szFileName, 0, BUFFER, 0, total)) 
			{
				//last set first block to dib
				EXTRAFRMINFO	extraInfo; //

				//buffer size changed
				if( !exAllocateDIBMemory(hBoard) ) {
						return 0;
				}

				okGetCurrImageInfo(hBoard, (LPARAM)&extraInfo, sizeof(EXTRAFRMINFO));

				exGetBitmapHeader(hBoard, BUFFER, lpbi); 
				exSetDataToDIB(BUFFER, 0, lpbi, (LPBYTE)lpdib);
			}
		}
	}
	else 
	{ //if( !stricmp(strrchr(szFileName,'.'),".bmp") ){//bmp
		//load bmp or raw into buffer and dib 	
		if (okGetBufferSize(hBoard, NULL, (DWORD *)&dwBufSize))  //buffer being
		{
			long	lParam1=0, lNum=1;
			RAWFILEPARAM sRawFile;
			CSeqNum	csf;
			
			if( !stricmp(strrchr(szFileName,'.'),".raw") ){
				memset(&sRawFile,0,sizeof(RAWFILEPARAM)); //zero all for init
				lParam1=(long)(&sRawFile);
			}

			//memset(&blkinfo,0,sizeof(BLOCKINFO)); //zero all for init

			blkinfo.lpBits=NULL; //only get block info
			if(okLoadImageFile(hBoard,szFileName,lParam1,(TARGET)&blkinfo,0,1)<0)
				return 0; 
			
			if(sRawFile.wPixBits) //filled
				sRawFile.wRawFlag=RAWFILE;

			//RAWFILEPARAM RawFile;
			//if( !stricmp(strrchr(szFileName,'.'),".raw") ){
			//	RawFile.wRawFlag=RAWFILE;
			//	RawFile.wPixBits=8;
			//	RawFile.dwWidth=576;
			//	RawFile.dwHeight=768;
			//	RawFile.dwOffset=0;
			//	lParam1=(long)(&RawFile);
			//}
			//okLoadImageFile(hBoard,szFileName,0,SCREEN,0,1); //test

	
			//how many
			lNumImage=lNum;
	
			if (csf.DoModal()) 
			{
				lNum = lNumImage;

				//then load them into buffer
				if (length = okLoadImageFile(hBoard, szFileName, lParam1, BUFFER, 0, lNum)) 
				{

					//buffer size changed
					if( !exAllocateDIBMemory(hBoard) ) {

							return 0;
					}

					//last set first block to dib
					exGetBitmapHeader(hBoard, BUFFER, lpbi); 
					exSetDataToDIB(BUFFER, 0, lpbi, (BYTE *)lpdib);
				}
			}
		}
		else if(hBoard) { // no buffer
			//way 2
			//just load to dib (& screen)
			memset(&blkinfo, 0, sizeof(blkinfo)); //zero all for init

			blkinfo.lpBits = NULL; //only get block info
			okLoadImageFile(hBoard,szFileName,0,(TARGET)&blkinfo,0,1);

			// set dib info	
			exGetBitmapHeader(hBoard, (TARGET)&blkinfo, lpbi);
			//buffer size changed
			if( !exAllocateDIBMemory(hBoard) ) {
				return 0;
			}

			//get dib for wnd paint
			blkinfo.lpBits = (LPBYTE)lpdib;
			blkinfo.lpExtra = (LPBYTE)((LPSTR)lpbi+lpbi->biSize);  //do here
			if (okLoadImageFile(hBoard, szFileName, 0, (TARGET)&blkinfo, 0, 1))
			{
				exConvertBitmap(lpbi, lpdib); //invert y
			}
			
			//okLoadImageFile(hBoard,szFileName,0,SCREEN,0,1);
		}
	}

	if(length==0)
		MessageBox(" Load file failed ?!  Try to check the file or memory size. ", "Warning !", MB_OK); 

	return TRUE;
}

/*
* ܣĻͼļ Ŀǰ֧bmp,jpg,rawʽ
* hBoardɼ
*			hWndھ
* 
*   ֵȷTRUE
*			󷵻FALSE
*/
BOOL COkMfcView::exSaveScreenFile(HANDLE hBoard, HWND hWnd)
{
	char		szFileName[512]="\0";
	BLOCKINFO	blkinfo;

	if (!exGetSaveName(hWnd, szFileName))
		return FALSE;

	if (!strrchr(szFileName, '.'))
		return FALSE;

	//save current dib
	blkinfo.iWidth = (short)lpbi->biWidth;
	blkinfo.iHeight = (short)lpbi->biHeight;
	blkinfo.iBitCount = (short)lpbi->biBitCount;
	blkinfo.lpBits = (LPBYTE)lpdib;
	blkinfo.lpExtra = (LPBYTE)((LPSTR)lpbi+lpbi->biSize);

	blkinfo.iFormType = 0; //unknown
	//special for 565
	if (lpbi->biBitCount == 16)
	{
		DWORD	*lpMask=(DWORD *)blkinfo.lpExtra;

		if (lpMask[1] == 0x07e0) //565
			blkinfo.iFormType = FORM_RGB565;
		else
			blkinfo.iFormType = FORM_RGB555;
	}

	//first inverse dib to bitmap
	exConvertBitmap(lpbi, lpdib);
	okSaveImageFile(hBoard, szFileName, 0, (TARGET)&blkinfo, 0, 1);	
	//restore to dib
	exConvertBitmap(lpbi, lpdib);
	return TRUE;
}

/*
* ܣ滺ͼļ Ŀǰ֧bmp,jpg,raw,seqʽ
* hBoardɼ
*			hWndھ
* 
*   ֵȷTRUE
*			󷵻FALSE
*/
BOOL COkMfcView::exSaveBufferFile(HANDLE hBoard, HWND hWnd)
{
	char		szFileName[512]="\0";
	BLOCKINFO	blkinfo;
	CSeqNum	csf;

	ZeroMemory(&blkinfo,sizeof(BLOCKINFO));

	if (!exGetSaveName(hWnd, szFileName))	return FALSE;

	if (!strrchr(szFileName, '.'))	return FALSE;

	if(!strnicmp(strrchr(szFileName,'.'), ".seq", 4) ||
			!strnicmp(strrchr(szFileName,'.'), ".avi", 4) ||
				!strnicmp(strrchr(szFileName,'.'), ".m2v", 4)) 
	{
		//save buffer seq
		total = (short)okGetBufferSize(hBoard, NULL, NULL);
		okSaveImageFile(hBoard, szFileName, 0, BUFFER, 0, total);	

		//than set this first block to dib to see what we saved
		exGetBitmapHeader(hBoard, BUFFER, lpbi); 
		exSetDataToDIB(BUFFER, 0, lpbi, (LPBYTE)lpdib);
	}
	else  //bmp or bmp
	{
		if (okGetBufferSize(hBoard, NULL, (DWORD*)&dwBufSize))  //buffer being
		{
			long	lNum = 1;

			//how many
			if (!csf.DoModal()) 
				return FALSE;
			lNum = iNumImage;

			okSaveImageFile(hBoard,szFileName,1,BUFFER,0,lNum);	

			//than set this first block to dib to see what we saved
			exGetBitmapHeader(hBoard, BUFFER, lpbi); 
			exSetDataToDIB(BUFFER, 0, lpbi, (LPBYTE)lpdib);
		}
		else  //no buffer allocated
		{
			//save current dib
			blkinfo.iWidth = (short)lpbi->biWidth;
			blkinfo.iHeight = (short)lpbi->biHeight;

			blkinfo.lBlockStep=0;
			blkinfo.iHiStep=0;

			blkinfo.iBitCount = (short)lpbi->biBitCount;
			blkinfo.lpBits = (LPBYTE)lpdib;
			blkinfo.lpExtra = (LPBYTE)((LPSTR)lpbi+lpbi->biSize);

			blkinfo.iFormType = 0; //unknown
			//special for 565
			if (lpbi->biBitCount == 16) 
			{
				DWORD	*lpMask=(DWORD *)blkinfo.lpExtra;

				if (lpMask[1] == 0x07e0) //565
					blkinfo.iFormType = FORM_RGB565;
				else
					blkinfo.iFormType = FORM_RGB555;
			}

			//first inverse dib to bitmap
			exConvertBitmap(lpbi, lpdib);
			okSaveImageFile(hBoard, szFileName, 0, (TARGET)&blkinfo, 0, 1);	
			//restore to dib
			exConvertBitmap(lpbi, lpdib);
		}
	}
	return TRUE;
}

/*
* ܣʾдұ
* hBoardɼ
*			index״̬ 0- 1- 2ֵ 3ֵDSAʾ
* 
*   ֵȷTRUE
*			󷵻FALSE
*/
BOOL COkMfcView::exFillOutLUT(HANDLE hBoard, short index)
{
	short	i,bits,start=0;


	//check how much bits LUT suppored
	bits=(short)okFillOutLUT(hBoard, NULL, 0, 0);

	if(	bits<=8) //for 8 bits lut
	{	
		BYTE	bLUT[768][3];
		short	iLUT[256],num=255,gray=256;

		switch (index) {
			case 0: //normal
				for(i=0;i<gray;i++) {
					bLUT[i][0]=(BYTE)i;
					bLUT[i][1]=(BYTE)i;
					bLUT[i][2]=(BYTE)i;
				}
				break;
			case 1: //inverse
				for(i=0;i<=num;i++) {
					bLUT[i][0]=(BYTE)(num-i);
					bLUT[i][1]=(BYTE)(num-i);
					bLUT[i][2]=(BYTE)(num-i);
				}
				for(i=num;i<gray;i++) {
					bLUT[i][0]=0;
					bLUT[i][1]=0;
					bLUT[i][2]=0;
				}
				break;
			case 2: //absolute for M60A
				for(i=0;i<128;i++) {
					bLUT[i][0]=(BYTE)(i);
					bLUT[i][1]=(BYTE)(i);
					bLUT[i][2]=(BYTE)(i);
				}
				for(i=128;i<gray;i++) {
					bLUT[i][0]=(BYTE)(256-i);
					bLUT[i][1]=(BYTE)(256-i);
					bLUT[i][2]=(BYTE)(256-i);
				}
				break;

			case 3: //dsa absolute for M60A
				//1. take true value with minus
				for(i=0;i<128;i++) { //>0  0~127
					iLUT[i]=(BYTE)(i);
				}
				for(i=128;i<gray;i++) { //<0 -1~-128
					iLUT[i]=(i-256);
				}
				//2. inverse at gray 165
				for(i=0;i<256;i++) { //37~293
					iLUT[i]=165-iLUT[i];
				}
				//3. stretch in several sects 
				for(i=0;i<256;i++) { //12~245
					if( iLUT[i]<105) { //12~35
						iLUT[i]=(short)(0.334*iLUT[i]);
					}
					else if( iLUT[i]<165) {//35~150
						iLUT[i]=(short)(1.916*iLUT[i]-166);
					}
					else if( iLUT[i]<205) {//150~245
						iLUT[i]=(short)(2.38*iLUT[i]-242);
					}
					else { //245~255
						iLUT[i]=(short)(0.113*iLUT[i]+222);
					}
				}
				//4. to lut in byts
				for(i=0;i<256;i++) { 
					bLUT[i][0]=(char)iLUT[i];
					bLUT[i][1]=(char)iLUT[i];
					bLUT[i][2]=(char)iLUT[i];
				}
				break;
			default:
				return 0;
		}
		okFillOutLUT(hBoard, (LPBYTE)bLUT, start, gray);	

	}
	else { //for great than 8 bits lut
		WORD	wLUT[4096][3];
		short	num,gray;

		gray=(1<<bits);
		num=gray-1;
		switch (index) {
			case 0: //normal
				for(i=0;i<gray;i++) {
					wLUT[i][0]=i;
					wLUT[i][1]=i;
					wLUT[i][2]=i;
				}
				break;
			case 1: //inverse
				for(i=0;i<=num;i++) {
					wLUT[i][0]=(num-i);
					wLUT[i][1]=(num-i);
					wLUT[i][2]=(num-i);
				}
				break;
			default:
				return -1;
		}
		okFillOutLUT(hBoard, (LPBYTE)wLUT, start, gray);	
	}

	return 1;
}

//--demo to fill outlut to these cards with out LUT
/*
* ܣʾдұ
* hBoardɼ
*			index״̬ 0- 1-
* 
*   ֵȷTRUE
*			󷵻FALSE
*/
BOOL COkMfcView::exFillInputLUT(HANDLE hBoard, short index)
{
	short	i,bits,start=0;

	//check how much bits LUT suppored
	bits=(short)okFillInputLUT(hBoard, NULL, 0, 0);
	if(bits==-1)
		return -1; //not support
	
	if(	bits<=8) //for 8 bits lut
	{	
		BYTE	bLUT[256][3];
		short	num=255,gray=256;

		switch (index) {
			case 0: //normal
				for(i=0;i<gray;i++) {
					bLUT[i][0]=(BYTE)i;
					bLUT[i][1]=(BYTE)i;
					bLUT[i][2]=(BYTE)i;
				}
				break;
			case 1: //inverse
				for(i=0;i<num;i++) {
					bLUT[i][0]=(BYTE)(num-i);
					bLUT[i][1]=(BYTE)(num-i);
					bLUT[i][2]=(BYTE)(num-i);
				}
				for(i=num;i<gray;i++) {
					bLUT[i][0]=0;
					bLUT[i][1]=0;
					bLUT[i][2]=0;
				}
				break;
			default:
				return 0;
		}
		okFillInputLUT(hBoard, (LPBYTE)bLUT, start, gray);	

	}
	else { //for great than 8 bits lut
		WORD	wLUT[4096][3]; //max for 12 bits
		short	gray;

		gray=(1<<bits);

		switch (index) {
			case 0: //normal
				for(i=0;i<gray;i++) {
					wLUT[i][0]=i;
					wLUT[i][1]=i;
					wLUT[i][2]=i;
				}
				break;
			case 1: //inverse
				for(i=0;i<gray;i++) {
					wLUT[i][0]=(gray-i-1);
					wLUT[i][1]=(gray-i-1);
					wLUT[i][2]=(gray-i-1);
				}
				break;
			default:
				return -1;
		}
		okFillInputLUT(hBoard, (LPBYTE)wLUT, start, gray);	
	}

	return 1;
}

//switch menu freeze/active
void COkMfcView::exEnableItem(int iMenuID, BOOL bEnable)
{
	CMenu*	cMenu;

	cMenu = AfxGetApp()->m_pMainWnd->GetMenu();
	if (bEnable) 
		cMenu->EnableMenuItem(iMenuID, MF_BYCOMMAND|MF_ENABLED);
	else
		cMenu->EnableMenuItem(iMenuID, MF_BYCOMMAND|MF_GRAYED);

	AfxGetApp()->m_pMainWnd->DrawMenuBar();
}

/*
* ܣʾʵλ
* 
* 
*   ֵ
*/
void COkMfcView::exDemoMask()
{
	int		i;
	RECT	rect;
	BYTE	lpMask[40960];
	BLOCKINFO	blk;
	LOGFONT 	lfLogFont = {-20, 0, 0, 0, 400, 0, 0, 0, 0, 1, 2, 1, 26, "Arial"};
	SETTEXTMODE	textmode = {0x0, 0xffffff, 2, 0, 0};  //

	//1.------ overlay graph--------------------------------------------------------
	{ //set graph overlay
		RECT		rect= {0,0,0,0};
		//SETTEXTMODE	textmode={0xffffff,0x0,COPYFONT,0,0};  //
		SETTEXTMODE	textmode={0xffffff,0x0,FULLCOPY,0,0};  //
		POINT		pt0={100,20},pt1={200,120};
		long		oldGraph=okSetVideoParam(hBoard, VIDEO_ENABLEGRAPHS, -1);
		LPBYTE		lpGraph;
		short		wid,ht;
		long		stride;
		RECT		rcRect;


		//SetRect(&rcRect,8,0,768+8,576);


		//-------capture graph overlay---------------------------------------------------

		rcRect.right=-1;
		okSetTargetRect(hBoard,BUFFER,&rcRect);

		rcRect.left-=100;rcRect.top-=100;
		rcRect.right+=100;rcRect.bottom+=100;

		//okSetVideoParam(hBoard, VIDEO_ENABLEGRAPHS, 0x803);
		//select cap-graph frm0
		okSetVideoParam(hBoard, VIDEO_ENABLEGRAPHS, 0x003);
		lpGraph=(LPBYTE)okGetTargetInfo(hBoard, GRAPH, 0, &wid, &ht, &stride);
		if(lpGraph) //clear
			ZeroMemory(lpGraph, stride*ht);// ZeroMemory


		//okFillCircleTo(hBoard, (TARGET)BUFFER, 0, &rcRect, 1, 0); //graph gray==1 for overlay 0

		okFillCircleTo(hBoard, (TARGET)GRAPH, 0, &rcRect, 1, 0);
		okSetTextTo(hBoard, (TARGET)GRAPH, &rect, &lfLogFont, &textmode, " JOINHOPEκ", 16); 
		//okSetTextTo(hBoard, (TARGET)GRAPH, &rect, &lfLogFont, &textmode, "H", 1); 
		okDrawLineTo(hBoard,(TARGET)GRAPH,0,pt0,pt1,0xff);
		SetRect(&rect,200,120,200,120);
		okSetTextTo(hBoard, (TARGET)GRAPH, &rect, &lfLogFont, &textmode, " κJOINHOPE", 16); 


		//select cap-graph frm1
		okSetVideoParam(hBoard, VIDEO_ENABLEGRAPHS, 0x203);
		if(lpGraph) //clear
			ZeroMemory(lpGraph, stride*ht);// ZeroMemory

		okFillCircleTo(hBoard, (TARGET)GRAPH, 0, &rcRect, 1, 0);
		SetRect(&rect,0,0,0,0);
		okSetTextTo(hBoard, (TARGET)GRAPH, &rect, &lfLogFont, &textmode, " JOINHOPEκ", 16); 
		//okSetTextTo(hBoard, (TARGET)GRAPH, &rect, &lfLogFont, &textmode, "H", 1); 
		okDrawLineTo(hBoard,(TARGET)GRAPH,0,pt0,pt1,0xff);
		SetRect(&rect,200,120,200,120);
		okSetTextTo(hBoard, (TARGET)GRAPH, &rect, &lfLogFont, &textmode, " κJOINHOPE", 16); 


		//-------output graph overlay---------------------------------------------------
		//SetRect(&rcRect,0,0,768,576);

		//select out-graph frm0
		okSetVideoParam(hBoard, VIDEO_ENABLEGRAPHS, 0x103);
		if(lpGraph) //clear
			ZeroMemory(lpGraph, stride*ht);// ZeroMemory

		okFillCircleTo(hBoard, (TARGET)GRAPH, 0, &rcRect, 1, 0);
		SetRect(&rect,0,0,0,0);
		okSetTextTo(hBoard, (TARGET)GRAPH, &rect, &lfLogFont, &textmode, " JOINHOPEκ", 16); 
		//okSetTextTo(hBoard, (TARGET)GRAPH, &rect, &lfLogFont, &textmode, "H", 1); 
		okDrawLineTo(hBoard,(TARGET)GRAPH,0,pt0,pt1,0xff);
		SetRect(&rect,200,120,200,120);
		okSetTextTo(hBoard, (TARGET)GRAPH, &rect, &lfLogFont, &textmode, " κJOINHOPE", 16); 


		//select out-graph frm1
		okSetVideoParam(hBoard, VIDEO_ENABLEGRAPHS, 0x303);
		if(lpGraph) //clear
			ZeroMemory(lpGraph, stride*ht);// ZeroMemory

		okFillCircleTo(hBoard, (TARGET)GRAPH, 0, &rcRect, 1, 0);
		SetRect(&rect,0,0,0,0);
		okSetTextTo(hBoard, (TARGET)GRAPH, &rect, &lfLogFont, &textmode, " JOINHOPEκ", 16); 
		//okSetTextTo(hBoard, (TARGET)GRAPH, &rect, &lfLogFont, &textmode, "H", 1); 
		okDrawLineTo(hBoard,(TARGET)GRAPH,0,pt0,pt1,0xff);
		SetRect(&rect,200,120,200,120);
		okSetTextTo(hBoard, (TARGET)GRAPH, &rect, &lfLogFont, &textmode, " κJOINHOPE", 16); 


		//okSetVideoParam(hBoard, VIDEO_ENABLEGRAPHS, 0x003); //enable both graph overlay
		okSetVideoParam(hBoard, VIDEO_ENABLEGRAPHS, oldGraph); //restore 

	}




	//2.------ mask graph--------------------------------------------------------
	//1. way (to set whole rect to enable/disable)
	//graph 1.
	rect.left = 200;
	rect.top = 100;
	rect.right = 280;
	rect.bottom = 180;
	okSetMaskRect(hBoard, &rect, (LPBYTE)0); //disable Big Rect video 
	InflateRect(&rect, -20, -20);	
	okSetMaskRect(hBoard, &rect, (LPBYTE)1); //enable Small Rect video 

	//graph 2.
	SetRect(&rect, 0, 200, 200, 201);
	okSetMaskRect(hBoard, &rect, (LPBYTE)0);  //D ---
	SetRect(&rect, 0, 202, 200, 203);
	okSetMaskRect(hBoard, &rect, (LPBYTE)0);  //D ---
	SetRect(&rect, 0, 205, 200, 206);
	okSetMaskRect(hBoard, &rect, (LPBYTE)0);  //D ---



	//2. way (to set mask rect with each pixel setting)

	//graph 3.
	ZeroMemory(lpMask, 20000); //clear bits 
	for(i=20; i<80; i++)
		lpMask[100+i] = 1;		//E ~~~

	for(i=1; i<99; i++)
		lpMask[100*50+i] = 1;	//E ---
	for(i=1; i<99; i++)
		lpMask[i*100+50] = 1;	//E  |

	for(i=0; i<=99; i++) 
		lpMask[i*100+i] = 1;	//E  /
	SetRect(&rect, 10, 310, 110, 410); //Disable Rect with + \ ~
	okSetMaskRect(hBoard, &rect, lpMask);

	//graph 4.
	FillMemory(lpMask, 40000, 1); //set bits 
	for(i=1; i<99; i++)
		lpMask[5000+i] = 0;		//D ---
	for(i=1; i<99; i++)
		lpMask[i*100+50] = 0;	//D  |
	SetRect(&rect, 200, 319, 300, 419);	 //disable +
	okSetMaskRect(hBoard, &rect, lpMask);


	//example to set char
	{
		RECT		rect = {0, 0, 0, 0};


		FillMemory(lpMask, 40000, 1); //set bits to init 
		blk.lpBits = lpMask;
		blk.iBitCount = 8;
		blk.iWidth = 100;
		blk.iHeight = 30; 
		okSetTextTo(hBoard, (TARGET)&blk, &rect, &lfLogFont, &textmode, "κ", 8); 

		SetRect(&rect, 300, 200, 300+100, 200+30);	 //set characters
		okSetMaskRect(hBoard, &rect, lpMask);


		FillMemory(lpMask, 40000, 1); //set bits to init 
		SetRect(&rect, 0, 0, 0, 0);	 //set characters
		okSetTextTo(hBoard, (TARGET)&blk, &rect, &lfLogFont, &textmode, "JoinHope", 8); 
		SetRect(&rect, 300, 240, 300+100, 240+30);	 //set chinese characters
		okSetMaskRect(hBoard, &rect, lpMask);

	}

	//example to set char and graphics by way of windows hdc
	{
		HANDLE	hDCBitmap;
		HDC		hdcMem;
		RECT	rect= {0,0,200,100};

		FillMemory(lpMask,40000,1); //set bits to init 
		blk.lpBits=lpMask;
		blk.iBitCount=8;
		blk.iWidth=200;
		blk.iHeight=100; 

		hdcMem=okCreateDCBitmap( hBoard, (TARGET)&blk, &hDCBitmap);

		SetTextColor(hdcMem,0xffffff); //cf
		SetBkColor(hdcMem,0); //cf
		TextOut(hdcMem,100,0,"7123456",7);
		MoveToEx(hdcMem,100,100,NULL);
		LineTo(hdcMem,200,500);
		Ellipse(hdcMem,0,0,200,100);

		okMapDCBitmapTo(hDCBitmap,0);

		okFreeDCBitmap(hDCBitmap);

		okSetMaskRect(hBoard,&rect,lpMask);

	}					

	//turn on mask
	okEnableMask(hBoard, m_Enablemask); //1 positive mask
	//okEnableMask(hBoard,2); //2 negtive mode
}

/*
* ܣʾ
* hBoardɼ
* 
*   ֵȷTRUE
*			󷵻FALSE
*/
short COkMfcView::exGetInitSet(HWND hWnd)
{
	m_Centerscreen = GetPrivateProfileInt("Init", "Centerize", 1, "OkDemo.ini");

	m_MatchClient = GetPrivateProfileInt("Init", "MatchClient", 0, "OkDemo.ini");

	iClientWidth = GetPrivateProfileInt("Init", "ClientWidth", 0, "OkDemo.ini");
	iClientHeight = GetPrivateProfileInt("Init", "ClientHeight", 0, "OkDemo.ini");

	return 1;
}

/*
* ܣʾα
* 
* 
*   ֵ1
*/
short COkMfcView::exSaveInitSet(void)
{
	char	string[20];

	sprintf(string, "%d", m_Centerscreen);
	WritePrivateProfileString("Init", "Centerize", string, "OkDemo.ini");

	if (m_MatchClient)
		sprintf(string, "%d", 1);
	else
		sprintf(string, "%d", 0);
	WritePrivateProfileString("Init", "MatchClient", string, "OkDemo.ini");

	sprintf(string,"%d", bMakeMirror);
	WritePrivateProfileString("Init", "MakeMirror", string, "OkDemo.ini");

	sprintf(string, "%d", iClientWidth);
	WritePrivateProfileString("Init", "ClientWidth", string, "OkDemo.ini");
	sprintf(string, "%d", iClientHeight);
	WritePrivateProfileString("Init", "ClientHeight", string, "OkDemo.ini");

	return 1;
}

/*
* ܣʾͼλ
* hBoard ɼ
*			hWnd Ӧó
*			lMode ʾʽ 0-Ͻ 1-
* 
*   ֵʾͼλ
*/
//--demo to set current capture rect on screen. mode=0: left-top, 1:centerize
long COkMfcView::exSetToWndRectEx(HANDLE hBoard, HWND hWnd, long lMode)
{
	long	lSize;
	RECT	rect;
	
	if (!IsWindow(hWnd)) return FALSE;

	if (IsIconic()) return FALSE;

	//get client rect
	GetClientRect(&rect);
	okSetToWndRect(hBoard, hWnd);

	if (lMode == 1)  //set to center
	{
		short		width,height;
		//get available rect size
		//lSize=okSetVideoParam(hBoard,VIDEO_AVAILRECTSIZE,-1);
		//or set to expected size
		//sampwidth=LOWORD(lSize);
		//sampheight=HIWORD(lSize);
		if (okGetCaptureStatus(hBoard, 0))  //capturing
		{
			width = sampwidth;
			height = sampheight;
		}
		else  //frozen status
		{
			width = (short)lpbi->biWidth;
			height = (short)lpbi->biHeight;
		}
		if (rect.right > width)
			rect.left = (rect.right - width )/2;//& (~0x3);
		if ((rect.bottom) > height)
			rect.top = (rect.bottom - height )/2;
	}

	//make offset x,y
	lSize = MAKELONG(rect.left, rect.top);
	rect.right = rect.left + min(sampwidth, rect.right);
	rect.bottom = rect.top + min(sampheight, rect.bottom);

	//map to absolute screen rect
	//::MapWindowPoints(hWnd, HWND_DESKTOP, (LPPOINT)&rect, 2);
	MapWindowPoints((CWnd*)HWND_DESKTOP,(LPPOINT)&rect,2);

	if (m_MatchClient == 0) //need not to match client rect
		okSetTargetRect(hBoard, SCREEN, &rect);

	return lSize;

}

/*
* ܣ򿪲ɼ ʼ
* hWnd Ӧó
* 
*   ֵɹͼ񿨾
*			ʧܷNULL
*/
HANDLE	COkMfcView::exOpenCard(HWND hWnd)
{
	//RECT			rcVidRect;	
	long	iNoBoards;
	//MEMORYSTATUS Status;
	long	error;
	char	str[120];



	//check ok boards sloted in PC
	//iNoBoards=okGetSlotBoard(NULL);
	iNoBoards=okGetImageDevice(NULL,0);

	//check if pre_allocated buffer
	okGetAvailBuffer(NULL,(DWORD *)&dwBufSize); //whole buffer
	//okGetBufferSize(hBoard,NULL,&dwBufSize); //available buffer for image			

	//check if reg device driver for nt/2k/xp 
	if( !okSetNTDriver(0) ) { // TRUE:registered already, -1:not nt system
		::MessageBox(hwnd, "There are not yet registered device service driver!","Warning",MB_OK);
	}
	else if( okSetNTDriver(0)==-1 ) { //win95/98
		if( !iNoBoards && (!okSetStaticVxD(0)) ) 
			::MessageBox(hwnd, "There are not yet registered vxd device driver!","Warning",MB_OK);
	}
	else {
		if(dwBufSize==0) //may be not reg driver, or no board, ... 
			::MessageBox(hwnd, "There are no buffer pre-allocated !","Warning",MB_OK);
	}

//					DialogBox(hInst, szSelectBox, hWnd, (FARPROC)exSelectDlgProc);





	WritePrivateProfileString("Route","To Open Board","","OkDemo.ini");
	//iCurrUsedNo=1//-1222;
	//open one specified board
	if( !(hBoard=okOpenBoard(&iCurrUsedNo)) ) {//set 
	//if( !(hBoard=okOpenBoard("128.64.32.1")) ) {//set 
	//if( !(hBoard=okOpenBoard("OK_C20B")) ) {//set 
	//if( !(hBoard=okOpenBoard("OK_AM1360")) ) {//set 
	//iCurrUsedNo=201360;
	//if( !(hBoard=okOpenBoard(&iCurrUsedNo)) ) {//set 
			//if( !(hBoard=okOpenImageBoard(-1)) ) //select default 

		error=okGetLastError();
		if(error==ERR_NOTFOUNDBOARD) {
			sprintf(str," ErrorCode=%d\n\n Not found correct 'Ok series Image Boards' in this Machine! ",error );
		//else if (error==ERR_NOTFOUNDVXDDRV)
		//	sprintf(str," ErrorCode=%d\n\n Failed to open device vxd/service driver for Ok Image Board!",error);
		}
		else {
			sprintf(str," ErrorCode=%d\n\n Open selected board failed! ",error);
		}
		::MessageBox(hwnd, str,"Error !",MB_OK);

	}
	else {
		error=okGetLastError();
		if (error==ERR_NOTFOUNDVXDDRV) {
			sprintf(str," ErrorCode=%d\n\n Failed to open device driver for Ok Image Board!",error);
			::MessageBox(hwnd, str,"Warning !",MB_OK);
		}
	}

	//just starting, then allocated memory for dib
	{ 
		//GlobalMemoryStatus(&Status);

		//determaine how many memory will be allocated as user memory
		//dwMaxMemSize=Status.dwTotalPhys-dwBufSize-32*(1<<20); //I'd keep min. 32M for window system
		//if(dwMaxMemSize<=0)
		//	dwMaxMemSize=5*(1<<20); //5M
		//else if( dwMaxMemSize>Status.dwAvailPhys )
		//	dwMaxMemSize=Status.dwAvailPhys/2;
		
		//if( dwMaxMemSize<5*(1<<20) ) //need 5M at least for user memory
		//	dwMaxMemSize=max(5*(1<<20),Status.dwAvailPhys);
		exAllocateDIBMemory(hBoard);

		if(!hBoard)
			return 0;

	}


	InitSetMenu(hWnd, hBoard);


	return hBoard;
}

/*
* ܣָĿʽ
* hBoard ͼ񿨾
*			src Ŀ
* lpbi bitmapʽļͷ
*   ֵĻʽ
*/
BOOL COkMfcView::exGetBitmapHeader(HANDLE hBoard, TARGET src, LPBITMAPINFOHEADER lpbi)
{
	short		width,height;
	long		form,extend;

	form = exGetTargetSize(hBoard, src, &width, &height);
	extend=okSetCaptureParam(hBoard,CAPTURE_SAMPLEFIELD,-1);
	if(extend==0) { //in field
		extend=okSetConvertParam(hBoard,CONVERT_FIELDEXTEND,-1);
		if(extend==FIELD_COPYEXTEND || extend==FIELD_COPYINTERPOL)
			height*=2;
	}

	//here take form as screen forever 
	if(src <= 1)
		form = okSetCaptureParam(hBoard, CAPTURE_SCRRGBFORMAT, GETCURRPARAM); //-1

	{ //treat rotate
		short temp;
		
		temp=(short)okSetConvertParam(hBoard,CONVERT_UPRIGHT,-1); //un
		if(temp>0) {
			temp=width;
			width=height;
			height=temp;
		}
	}

	exSetBitmapHeader(lpbi, width, height, HIWORD(form), LOWORD(form) );

	return LOWORD(form);
}

/*
* ܣָĿС
* hBoard ͼ񿨾
*			tgt Ŀ
* width ָĿ
*			height ָĿ߶
*   ֵָĿʽ
*/
long exGetTargetSize(HANDLE hBoard, TARGET tgt, short *width, short *height)
{
	RECT	rect;
	long	form;


	if ((tgt==SCREEN ) ||(tgt==BUFFER)) 
	{
		rect.right = -1;
		okSetTargetRect(hBoard, tgt, &rect); //get current rect
		if(width)
			*width=(short)(rect.right - rect.left);
		if(height)
			*height=(short)(rect.bottom - rect.top);

		if (tgt == SCREEN) 
		{
			form = okSetCaptureParam(hBoard, CAPTURE_SCRRGBFORMAT, GETCURRPARAM); //-1
			//limit to video rect
			rect.right = -1; //max. captured rect
			okSetTargetRect(hBoard, VIDEO, &rect); //get video rect
			if(width)
				*width = (short)min(*width, rect.right - rect.left);
			if(height)
				*height = (short)min(*height, rect.bottom - rect.top);
		}
		else if (tgt == BUFFER) 
			form = okSetCaptureParam(hBoard, CAPTURE_BUFRGBFORMAT, GETCURRPARAM); //-1

	} else if (tgt > BUFFER)  //from blkinfo
	{
		LPBLOCKINFO	lpblk;
		lpblk = (LPBLOCKINFO)tgt;

		if(width)
			*width = lpblk->iWidth;
		if(height)
			*height = abs(lpblk->iHeight);
		form = MAKELONG(lpblk->iFormType, lpblk->iBitCount);
	}


	return form;
}

/*
* ܣbitmapļͷ
* width õĿ
*			height õĸ߶
*			form õĸʽ
* lpbi bitmapļͷָ
*   ֵļͷʽ
*/
long exSetBitmapHeader(LPBITMAPINFOHEADER lpbi,short width,short height, short bits, short form)
{
	long	wbytes;

	if(!lpbi)
		return FALSE;


	if(form==FORM_RGB555)
		bits=16;
	wbytes=((((width*bits)+31)&~31)>>3);//bmp need 4 byte align

	lpbi->biWidth=width;
	lpbi->biHeight=height;

	lpbi->biSize=sizeof(BITMAPINFOHEADER);
	lpbi->biPlanes=1;

	lpbi->biBitCount=bits;
	lpbi->biSizeImage=wbytes*height;


	lpbi->biClrUsed=0;
	//special format for 555,565 & 32 
	if(form==FORM_RGB555 || form==FORM_RGB565 || form==FORM_RGB8888 || form==FORM_RGB8886) 
		lpbi->biCompression=BI_BITFIELDS;
	else
		lpbi->biCompression=0;
	if(lpbi->biCompression==BI_BITFIELDS ) {//
		DWORD	*lpmask;
		lpmask=(DWORD *)((LPSTR)lpbi+lpbi->biSize);

		if(form==FORM_RGB555) {
			lpmask[2]=0x001f; //blue
			lpmask[1]=0x03e0;
			lpmask[0]=0x7c00;
		}
		else if(form==FORM_RGB565) {
			lpmask[2]=0x001f; //blue
			lpmask[1]=0x07e0;
			lpmask[0]=0xf800;
		}
		else if(bits==32 ) {
			lpmask[2]=0x0000ff;
			lpmask[1]=0x00ff00;
			lpmask[0]=0xff0000;
		}
	}
	else if(bits<=14) { // 8,10,12
		int		i,ratio;
		RGBQUAD	*lpRGB=(RGBQUAD *)((LPSTR)lpbi+lpbi->biSize);

		lpbi->biClrUsed=(1<<bits);
		ratio=lpbi->biClrUsed/256;

		lpbi->biClrUsed=min(256,lpbi->biClrUsed); //limit
		for(i=0; i<(short)lpbi->biClrUsed;i++) {
			lpRGB[i].rgbBlue=i;//i/ratio;
			lpRGB[i].rgbGreen=i;//i/ratio;
			lpRGB[i].rgbRed=i;//i/ratio;
			lpRGB[i].rgbReserved=0;
		}
		/*for(i=0;i<10;i++) {
			lpRGB[i].rgbBlue=10;
			lpRGB[i].rgbGreen=10;
			lpRGB[i].rgbRed=10;
			lpRGB[i].rgbReserved=10;
		}
		for(i=lpbi->biClrUsed-10;i<(int)lpbi->biClrUsed;i++) {
			lpRGB[i].rgbBlue=245;
			lpRGB[i].rgbGreen=245;
			lpRGB[i].rgbRed=245;
			lpRGB[i].rgbReserved=0;
		}*/
		/*short	*lpPal=(short *)((LPSTR)lpbi+lpbi->biSize);
		lpbi->biClrUsed=(1<<bits);
		for(i=0; i<(short)lpbi->biClrUsed;i++) {
			lpPal[i]=i;
		}*/
	} 
	lpbi->biClrImportant=lpbi->biClrUsed;

	return lpbi->biClrUsed;

}

/*
* ܣͼдָڴ
* src ԴĿ
*			start ʼ֡
*			lpbi ͼʽ
* lpdib дͼ
*   ֵַ֧-1
*			ʧܷ0
*			ɹشֽ
*/
long COkMfcView::exSetDataToDIB(TARGET src, short start, LPBITMAPINFOHEADER lpbi, LPBYTE lpdib)
{
	BLOCKINFO	blk;

	ZeroMemory(&blk,sizeof(BLOCKINFO));
	//get image to app buffer from tgt
	blk.lpBits = lpdib;			
	blk.iWidth = (short)lpbi->biWidth;
	blk.iHeight = -(short)lpbi->biHeight; //to invert y
	blk.iBitCount = lpbi->biBitCount;
	blk.lBlockStep = LOWORD(lpbi->biSizeImage); //must be set
	blk.iHiStep = HIWORD(lpbi->biSizeImage); //must be set

	if(lpbi->biCompression == BI_BITFIELDS) //
	{
		DWORD	*lpMask;
		lpMask = (DWORD *)((LPSTR)lpbi+lpbi->biSize);
		if (lpMask[1] == 0x03e0) //555
			blk.iFormType = FORM_RGB555;
	}

	return okConvertRect(hBoard, (TARGET)&blk, 0, src, start, 1);
	
}

/*
* ܣõɫ
* hDC Ӧóͼ
* 
*   ֵ1
*/
HPALETTE COkMfcView::exSetPaletteToWnd(HDC hDC)
{
	static	HPALETTE	hPalette;
	long	form;
	short	bits;

	//get current screen(VGA) format 
	form = okSetCaptureParam(hBoard, CAPTURE_SCRRGBFORMAT, GETCURRPARAM); //-1
	bits = HIWORD(form); //take HIWORD
	form = LOWORD(form);

	if (bits==8 || bits==10) { //gray
		if (!hPalette)  
			hPalette = exMakeLogPalette(bits, (short)form);

		SelectPalette(hDC, hPalette, 0);
		RealizePalette(hDC);     // GDI Bug
	}
	return (HPALETTE)1;
}

/*
* ܣɵɫ
* iBits ɫ
*			rgbForm ɫҶ
* 
*   ֵɫ
*/
HPALETTE COkMfcView::exMakeLogPalette(short iBits, short rgbForm)
{
    HPALETTE    hLogPal; 
    NPLOGPALETTE npPal;
    WORD        nNumColors;
    short		i;

	nNumColors = (WORD)(1<<iBits);
	npPal = (NPLOGPALETTE)LocalAlloc(LMEM_FIXED, sizeof(LOGPALETTE) + 
				    nNumColors * sizeof(PALETTEENTRY));
    if (!npPal)	return(FALSE);
	
	npPal->palVersion = 0x300;
    npPal->palNumEntries = nNumColors;
	//set palette
	if (rgbForm == FORM_RGB332)  //rgb 332
	{
		BYTE	red=0, green=0, blue=0;
			
		for (i=0; i<nNumColors; i++ ) 
		{
			npPal->palPalEntry[i].peBlue = blue;
			npPal->palPalEntry[i].peGreen = green;
			npPal->palPalEntry[i].peRed = red;
			npPal->palPalEntry[i].peFlags = 0;
			if (!(red += 32))
				if (!(green += 32))
			    	blue += 64;			
		}
	}
	else  //gray 256 or 1024
	{
		for (i=0; i<nNumColors; i++ ) 
		{
			npPal->palPalEntry[i].peRed = (BYTE)i;
			npPal->palPalEntry[i].peGreen = (BYTE)i;
			npPal->palPalEntry[i].peBlue = (BYTE)i;
			npPal->palPalEntry[i].peFlags = 0;
		}
	}

	hLogPal = CreatePalette((LPLOGPALETTE)npPal);
	LocalFree((HANDLE)npPal);

	return(hLogPal);
}


/*
* ܣʼɼص
* hBoard ͼ񿨾
* 
*   ֵȷTRUE
*			󷵻FALSE
*/
//------------callback example runtines----------
//bDispToScreen=0: not back display
//				1, back display
//				2: back display, and take same bits as screen
//				3: pseudo back display
BOOL CALLBACK exBeginCapture(HANDLE hBoard)
{
	short		width,height;
	long		form;


	if (bDispToScreen) 
	{
		bufform=exGetTargetSize(hBoard, BUFFER, &width, &height);

		form=okSetCaptureParam(hBoard,CAPTURE_SCRRGBFORMAT,GETCURRPARAM); //-1

		
		{ //treat rotate
			short temp;
			
			temp=(short)okSetConvertParam(hBoard,CONVERT_UPRIGHT,-1); //un
			if(temp>0) {
				temp=width;
				width=height;
				height=temp;
			}
		}

		exSetBitmapHeader(lpbi, width, height, HIWORD(form), LOWORD(form) );

		if (bDispToScreen > 1)
		{ //take same bits as screen for callback exSetToScreen
			if (bDispToScreen == 3)
			{ //make pseudo-display
				int	i;

				#define	way1

				#ifdef	way1
				//way1 by convert 
				{
					PALETTEENTRY		palPalEntry[256];

					exSetBitmapHeader(lpbi, width, height, HIWORD(form), LOWORD(form) );

					//just exam to set palette to yellow
					for (i = 0; i<256; i++ ) {
						palPalEntry[i].peRed = (BYTE)i;
						palPalEntry[i].peGreen = (BYTE)i;
						palPalEntry[i].peBlue = (BYTE)0;
						palPalEntry[i].peFlags = 0;
					}
					//if( LOWORD(blkform)!=FORM_GRAY8) ////set mapping palette
						okSetConvertParam(hBoard, CONVERT_PALETTE, (LPARAM)palPalEntry);
				}
				#else
				//way2 by windows palette 
				{
					RGBQUAD	*lpRGB = (RGBQUAD *)((LPSTR)lpbi + lpbi->biSize);

					for (i = 0; i<256; i++ ) 
					{
						lpRGB[i].rgbRed = (BYTE)i;
						lpRGB[i].rgbGreen = (BYTE)i;
						lpRGB[i].rgbBlue = (BYTE)0;
						lpRGB[i].rgbReserved = 0;
					}
				}
				#endif
			}
		}
	}

	blk.lpBits = (LPBYTE)lpdib;
	blk.iBitCount = lpbi->biBitCount;

	if (bMakeMirror & 1) //x mirror
		blk.iWidth = -(short)lpbi->biWidth;
	else
		blk.iWidth = (short)lpbi->biWidth;

	if (okSetCaptureParam(hBoard, CAPTURE_SAMPLEFIELD, -1) == 0) //sample in field by field
		if (LOWORD(okSetVideoParam(hBoard, VIDEO_SIGNALTYPE, -1)) == 1) //interlace video
			if (okSetConvertParam(hBoard, CONVERT_FIELDEXTEND, -1) != 0)
				lpbi->biHeight *= 2; //double size for ht

	if(bMakeMirror & 2) //y mirror
		blk.iHeight = (short)lpbi->biHeight; // y mirror
	else
		blk.iHeight = -(short)lpbi->biHeight; //note: minus is for invert dib in y by ConvertRect	

	elapsed = GetTickCount();
	numframe = 0;

	return 1;
}


/*
* ܣɼеĻص
* hBoard ͼ񿨾
*			no ʶɼڼ֡
* 
*   ֵȷTRUE
*			󷵻FALSE
*/
BOOL CALLBACK exBackDisplay(HANDLE hBoard,long no)
{		
	//return 1;

	numframe++;
	//sprintf(string,"captured frames = %d ",no);
	sprintf(string, " Ratio = %4.1f; Total frames = %d; Current = %d ", exCalcCaptureRatio(), numframe, no);
#ifndef _DEBUG
	sBar->SetPaneText(0, string, TRUE);
#endif

	if (bDispToScreen) 
	{
		if ((LOWORD(bufform)==FORM_GRAY10) 
			|| (LOWORD(bufform)==FORM_GRAY12)
				|| (LOWORD(bufform)==FORM_GRAY16))  //special  
		{
			//way 1
			okConvertRect(hBoard, (TARGET)&blk, 0, BUFFER, (short)no, 1);
			//way 2
			//okReadRectEx(hBoard,BUFFER,(short)no,lpdib, MAKELONG(FORM_GRAY8,1)); 
														 //read only red data
		}
		else 
		{
			//Sleep(5);
			//way 1
			//okTransferRect(hBoard, (TARGET)&blk, 0,BUFFER, (short)no, 1);
			okConvertRect(hBoard, (TARGET)&blk, 0, BUFFER, (short)no, 1);
			//way 2
			//okReadRect(hBoard,BUFFER,(short)no,lpdib);
		}
		InvalidateRect(hWnd, NULL, FALSE);
		UpdateWindow(hWnd);
	}

	return 1;
}


/*
* ܣɼеĻص
* hBoard ͼ񿨾
*			no ʶɼڼ֡
* 
*   ֵȷTRUE
*			󷵻FALSE
*/
BOOL CALLBACK exSetToScreen(HANDLE hBoard,long no)
{		
	numframe++;

	sprintf(string, " Capture ratio = %4.1f; Captured frames = %d", exCalcCaptureRatio(), numframe);
#ifndef _DEBUG
	sBar->SetPaneText(0, string);
#endif

	if((LOWORD(bufform)==FORM_GRAY10) || 
			(LOWORD(bufform)==FORM_GRAY12) ||
				(LOWORD(bufform)==FORM_GRAY16))  //special  
	{
		//way 1
		okConvertRect(hBoard, (TARGET)&blk, 0, BUFFER, (short)no, 1);

		//way 2
		//okReadRect(hBoard,BUFFER,(short)no,lpdib);
		//exConvertBitmap(lpbi,lpdib);
	}
	else 
	{
		//way 1
		okConvertRect(hBoard, (TARGET)&blk, 0, BUFFER, (short)no, 1);
		//okTransferRect(hBoard, (TARGET)&blk, 0, BUFFER, (short)no, 1);	

		//way 2
		//okReadRect(hBoard,BUFFER,(short)no,lpdib);
		//exConvertBitmap(lpbi,lpdib);
	}

//	InvalidateRect(NULL, NULL, FALSE);
//	UpdateWindow(NULL);
	InvalidateRect(hWnd, NULL, FALSE);
	//UpdateWindow(hWnd);

	return 1;
}

/*
* ܣɼĻص
* hBoard ͼ񿨾
* 
*   ֵȷTRUE
*			󷵻FALSE
*/
BOOL CALLBACK exEndCapture(HANDLE hBoard)
{
	
	elapsed = GetTickCount()-elapsed;								

	sprintf(string, "Total frames = %d;  elapsed time= %d ms", numframe, elapsed);
#ifndef _DEBUG
	sBar->SetPaneText(0, string);
#endif

	//clear callback
	okSetSeqCallback(hBoard, NULL, NULL, NULL);

	okStopCapture(hBoard);

	return 1;
}


void COkMfcView::OnUpdateEnablemask(CCmdUI* pCmdUI) 
{
	// TODO: Add your command update UI handler code here
	pCmdUI->SetCheck(m_Enablemask);	
	pCmdUI->Enable(b_Enablemask);
}

/*
* ܣûһ֡ͼĴС
* hBoard ͼ񿨾
* 
*   ֵصǰʽһ֡ͼĴС
*/
long exGetFrameSize(HANDLE hBoard)
{
	long	bits,size;

	size = okSetCaptureParam(hBoard, CAPTURE_BUFBLOCKSIZE, -1);
	bits = okSetCaptureParam(hBoard, CAPTURE_BUFRGBFORMAT, -1);
	size = (HIWORD(bits))/8*LOWORD(size)*HIWORD(size);

	return size;
}

/*
* ܣbitmapļͼ
* hBoard ͼ񿨾
*			src Ŀ
*			lpbi bitmapļͷ
* lpdib ͼ
*   ֵȷTRUE
*			󷵻FALSE
*/
BOOL COkMfcView::exGetBitmapData(HANDLE hBoard, TARGET src, short start, LPBITMAPINFOHEADER lpbi, LPSTR lpdib)
{
	short		width,height;
	long		form;

	form = exGetTargetSize(hBoard, src, &width, &height);

	if (src <= BUFFER)  //not from blkinfo
	{
		//take form as screen 
		form = okSetCaptureParam(hBoard, CAPTURE_SCRRGBFORMAT, GETCURRPARAM); //-1
	}
	exSetBitmapHeader(lpbi, width, height, HIWORD(form), LOWORD(form) );

	exSetDataToDIB(src, start, lpbi, (LPBYTE)lpdib);

	return LOWORD(form);
}

/*
* ܣתͼ
* lpbi bitmapļͷ
* lpdib ͼ
*   ֵȷTRUE
*			󷵻FALSE
*/
BOOL exConvertBitmap(LPBITMAPINFOHEADER lpbi,LPSTR lpdib)
{
	long	i, wbytes;
	LPSTR	lpbuf;
	LPSTR	lptop, lpbottom;

	if (!lpbi)	return FALSE;

	if (!lpbi->biHeight) return FALSE;

	//inverse dib (top to bottom)
	wbytes = lpbi->biSizeImage/lpbi->biHeight;
	lpbuf = (LPSTR)GlobalAlloc(GPTR, wbytes);

	lptop = lpdib;
	lpbottom = lpdib+(lpbi->biHeight-1)*wbytes;
	for (i=0; i<lpbi->biHeight/2; i++) 
	{
		CopyMemory(lpbuf, lptop, wbytes);
		CopyMemory(lptop, lpbottom, wbytes);
		CopyMemory(lpbottom, lpbuf, wbytes);
		lptop += wbytes;
		lpbottom -= wbytes;
	}
	GlobalFree(lpbuf);
	return TRUE;
}

/*
* ܣڻд״ɫ
* lpLinear Եַ
*			height ߶
*			stride п
* 
*   ֵȷTRUE
*			󷵻FALSE
*/
BOOL exSetTestBands(LPBYTE lpLinear, short bits, short height, long stride)
{ //set gray and color bands to dib and buffer 0
	int			i,j,k;
	short		offx,offy,step=bits/8;
	short		bwid=32*bits/8, halfx=stride/2/bits*bits,endx=stride-step+1;


	//set bands.  suppose buffer as format of 24 bits 

	if(!lpLinear)
		return FALSE;

	for(i=0;i<height;i++)  //clear whole zero
		FillMemory(lpLinear+stride*i,stride,0);//i);

	offy=min(256,height/2);  // down half section (gray level section)
	for(i=offy;i<height;i+=1) {
		FillMemory(lpLinear+stride*i,stride/2,i-offy); //left half lines
		
		for(k=0,j=stride/2;j<stride;j+=24*4,k+=32) { //right half
			if(k==256)
				k=255;
			FillMemory(lpLinear+stride*i+j,24*4,k);  //k is value
		}
	}

	//for(i=0;i<height;i++)  //clear zero
	//	for(j=0;j<stride;j+=2) {
	//		*(WORD *)(lpLinear+stride*i+j)=i+1;
	//	}
	

	//-------------------------------------------------------

	offy=0;	//up half section (color bands section)
	//1black
	for(i=offy;i<offy+32;i++) {		//right half lines
		for(j=halfx;j<=endx;j+=step)
			*(DWORD *)(lpLinear+stride*i+j)=0x0;
	}
	offy=i;

	//1black
	offx=0;
	for(i=0;i<min(256,height/2);i++) {	//left half lines
		for(j=offx;j<offx+bwid;j+=step) {
			*(DWORD *)(lpLinear+stride*i+j)=0x0;
		}
	}

	//2blue
	for(i=offy;i<offy+32;i++) {
		for(j=halfx;j<endx;j+=step)
			*(DWORD *)(lpLinear+stride*i+j)=0xff;
	}
	offy=i;

	//2blue
	offx+=bwid;
	for(i=0;i<min(256,height/2);i++) {
		for(j=offx;j<offx+bwid;j+=step) {
			*(DWORD *)(lpLinear+stride*i+j)=0xff;
		}
	}

	//3red
	for(i=offy;i<offy+32;i++) {
		for(j=halfx;j<endx;j+=step)
			*(DWORD *)(lpLinear+stride*i+j)=0xff0000;
	}
	offy=i;

	//3green
	offx+=bwid;
	for(i=0;i<min(256,height/2);i++) {
		for(j=offx;j<offx+bwid;j+=step) {
			*(DWORD *)(lpLinear+stride*i+j)=0xff00;
		}
	}

	//4magenta
	for(i=offy;i<offy+32;i++) {
		for(j=halfx;j<endx;j+=step)
			*(DWORD *)(lpLinear+stride*i+j)=0xff00ff; ;
	}
	offy=i;

	//4red
	offx+=bwid;
	for(i=0;i<min(256,height/2);i++) {
		for(j=offx;j<offx+bwid;j+=step) {
			*(DWORD *)(lpLinear+stride*i+j)=0xff0000;
		}
	}

	//5green
	for(i=offy;i<offy+32;i++) {
		for(j=halfx;j<endx;j+=step)
			*(DWORD *)(lpLinear+stride*i+j)=0xff00;
	}
	offy=i;

	//5cyan
	offx+=bwid;
	for(i=0;i<min(256,height/2);i++) {
		for(j=offx;j<offx+bwid;j+=step) {
			*(DWORD *)(lpLinear+stride*i+j)=0xffff;
		}
	}

	//6cyan
	for(i=offy;i<offy+32;i++) {
		for(j=halfx;j<endx;j+=step)
			*(DWORD *)(lpLinear+stride*i+j)=0xffff;
	}
	offy=i;

	//6magenta
	offx+=bwid;
	for(i=0;i<min(256,height/2);i++) {
		for(j=offx;j<offx+bwid;j+=step) {
			*(DWORD *)(lpLinear+stride*i+j)=0xff00ff;
		}
	}

	//7yellow
	for(i=offy;i<offy+32;i++) {
		for(j=halfx;j<endx;j+=step)
			*(DWORD *)(lpLinear+stride*i+j)=0xffff00;
	}
	offy=i;
	//7yellow
	offx+=bwid;
	for(i=0;i<min(256,height/2);i++) {
		for(j=offx;j<offx+bwid;j+=step) {
			*(DWORD *)(lpLinear+stride*i+j)=0xffff00;
		}
	}

	//8white
	for(i=offy;i<offy+32;i++) {
		for(j=halfx;j<endx;j+=step)
			*(DWORD *)(lpLinear+stride*i+j)=0xffffff;
	}
	offy=i;
	//8white
	offx+=bwid;
	for(i=0;i<min(256,height/2);i++) {
		for(j=offx;j<offx+bwid;j+=step) {
			*(DWORD *)(lpLinear+stride*i+j)=0xffffff;
		}
	}

	//repeat
//	offx+=bwid;
//	while(stride/2>offx) {//remain 	
//		for(i=0;i<min(256,height/2);i++) {
//			memcpy(lpLinear+stride*i+offx,lpLinear+stride*i,stride/2-offx);
//		}
//		offx+=bwid*8;
//	}

	offx+=bwid;
	offx+=bwid/2; // blue vertical line
	for(i=0;i<min(256,height/2);i++) {
		*(DWORD *)(lpLinear+stride*i+offx)=0xff;
	}

	offx+=bwid/2; // green vertical line
	for(i=0;i<min(256,height/2);i++) {
		*(DWORD *)(lpLinear+stride*i+offx)=0xff00;
	}

	offx+=bwid/2; //red vertical line
	for(i=0;i<min(256,height/2);i++) {
		*(DWORD *)(lpLinear+stride*i+offx)=0xff0000;
	}

	offx+=bwid/2; //cyan vertical line
	for(i=0;i<min(256,height/2);i++) {
		*(DWORD *)(lpLinear+stride*i+offx)=0xffff00;
	}

	offx+=bwid/2; //magenta vertical line
	for(i=0;i<min(256,height/2);i++) {
		*(DWORD *)(lpLinear+stride*i+offx)=0xff00ff;
	}

	offx+=bwid/2; //yellow vertical line
	for(i=0;i<min(256,height/2);i++) {
		*(DWORD *)(lpLinear+stride*i+offx)=0xffff00;
	}

	offx+=bwid/2; //white vertical line
	for(i=0;i<min(256,height/2);i++) {
		*(DWORD *)(lpLinear+stride*i+offx)=0xffffff;
	}

	//repeat
	offx+=bwid;
	while(stride/2>offx) {//remain 	
		for(i=0;i<min(256,height/2);i++) {
			memcpy(lpLinear+stride*i+offx,lpLinear+stride*i+bwid,stride/2-offx);
		}
		offx+=bwid*8;
	}


	//set test vert line raster
	//for(i=0;i<height;i++)  //clear zero
	//	FillMemory(lpLinear+stride*i,stride,0);//i);
	//for(j=0;j<stride;j+=3*8) {
	//	for(i=0;i<height;i++) {
	//		*(DWORD *)(lpLinear+stride*i+j)=0xffffff;
	//	}
	//}

	//set test horz line raster
	//for(i=0;i<height;i+=8) {
	//	FillMemory(lpLinear+stride*i,stride,255);
	//}

	
	return 1;
}

BOOL exOutReport(HDC hPr, LPBITMAPINFOHEADER lpbi, LPSTR lpdib)
{
    char	szLine[1024];
	char	str[50];
	int		startx;
	SIZE	sSize;
	RECT	rect;
	HFONT	hFont, hOldFont;
	int		Horz, Vert;
	float	XZoom, YZoom;
	TEXTMETRIC TextMetric;              /* information about character size      */

    
    Horz = GetDeviceCaps(hPr, HORZRES);
    XZoom = (float)Horz/2400; //in standard of 300dpi for A4
    Vert = GetDeviceCaps(hPr, VERTRES);
    YZoom = (float)Vert/3300;
    
	rect.top = (int)(600*YZoom);
	rect.bottom = (int)(2600*YZoom);
    
	// Set hospital name    
    hFont = CreateFont((int)(90*YZoom), (int)(35*XZoom), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL);
	hOldFont = (HFONT)SelectObject(hPr, hFont);
    GetTextMetrics(hPr, &TextMetric);
	Rectangle(hPr, (int)(100*XZoom), (int)(155*YZoom), (int)((Horz-100)*XZoom), (int)(156*YZoom)); //underline 

	strcpy(szLine, "κͼ޹˾--ӡʾ");
    GetTextExtentPoint32(hPr, szLine, strlen(szLine), &sSize);
	startx = (Horz-sSize.cx)/2;
	TextOut(hPr, startx, (int)(50*YZoom), (LPSTR)szLine, strlen(szLine));

	SelectObject(hPr, hOldFont);
    DeleteObject(hFont);

	// set date contents
    hFont = CreateFont((int)(62*YZoom), (int)(22*XZoom), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL);
	hOldFont = (HFONT)SelectObject(hPr, hFont);
	//year-month-date
	strcpy(szLine, "ӡ: ");
    _strdate(str);
	str[2] = 0;
	str[5] = 0;
	str[8] = 0;
	strcat(szLine, str+6);
	strcat(szLine, "-");//"");
	strcat(szLine, str);
	strcat(szLine, "-");//"");
	strcat(szLine, str+3);
	//strcat(szLine,"");
    TextOut(hPr, (int)(1600*XZoom), (int)(200*YZoom), (LPSTR)szLine, strlen(szLine));

	 //delete font
	SelectObject(hPr, hOldFont);
    DeleteObject(hFont);

    	
	rect.right = (int)((float)lpbi->biWidth/lpbi->biHeight
				*(rect.bottom-rect.top));
	rect.left = (int)((Horz-rect.right)/2+100*XZoom);		
	rect.right += rect.left;
	if (rect.left < 0) 
	{
		rect.left = (int)(100*XZoom);
		rect.right = (int)(2200*XZoom);
		
		rect.bottom = (int)((float)lpbi->biHeight/lpbi->biWidth
				*(rect.right-rect.left))+rect.top;
		
	}

   
    StretchDIBits (hPr,                         // DestDC
            rect.left,                     // DestX
            rect.top,                      // DestY
            rect.right - rect.left,        // DestWidth
            rect.bottom - rect.top,        // DestHeight
            
            0,                   // SrcX
            0,					 // SrcY
            (int)lpbi->biWidth,    // SrcWidth
            (int)lpbi->biHeight,    // SrcHeight
            lpdib,                     // lpBits
            (LPBITMAPINFO) lpbi,       // lpBitInfo
            DIB_RGB_COLORS,                // wUsage
            SRCCOPY);                      // dwROP
		
	
	return 1;
}

void COkMfcView::OnPrintpic() 
{
	// TODO: Add your command handler code here
	//ӡͼ
	CPrintDialog	cpd = (FALSE, PD_ALLPAGES);
	HDC				hPr;
	CDC				cdc;
	DOCINFO	docinfo;

	cpd.DoModal();
	hPr = cpd.GetPrinterDC();
	if (!hPr) return;
	cdc.Attach(hPr);

	docinfo.cbSize = sizeof(DOCINFO);
	docinfo.lpszDocName = "prnfile";
	docinfo.lpszOutput = NULL;
	docinfo.lpszDatatype = NULL;	
	docinfo.fwType = 0;

	if (cdc.StartDoc(&docinfo) == -1) return;
	cdc.StartPage();
	exOutReport(hPr, lpbi, lpdib);
	cdc.EndPage();
	cdc.EndDoc();
}

void COkMfcView::OnMouseMove(UINT nFlags, CPoint point) 
{
	if(!bActive) {
		exDispPointValue(hBoard, hWnd, MAKELONG(point.x, point.y));
	}
}

/*
* ܣ0
* 
* 
*   ֵ
*/
void COkMfcView::OnSettozero() 
{
	// TODO: Add your command handler code here
	//ͼ
	LPBYTE		lpLinear;
	short		height;
	long		stride;

	if (lpbi->biHeight) 
		ZeroMemory(lpdib, lpbi->biSizeImage);
	InvalidateRect(NULL, FALSE);

	lpLinear = (LPBYTE)okGetTargetInfo(hBoard, BUFFER, 0, NULL, &height, &stride);
	ZeroMemory(lpLinear, stride*height);
}

void COkMfcView::OnUpdateSinglecapto(CCmdUI* pCmdUI) 
{
	char str[100];
	char tstr[100];

	okGetProgramInfo(VERSION, str, 100); //name
	sprintf(tstr, "OKϵͼʾ OkMfc %s", str);
	AfxGetApp()->m_pMainWnd->SetWindowText(tstr);
}

void COkMfcView::OnMulchancap() 
{
	// TODO: Add your command handler code here
	//ͨʱʵʱ
	
	char	string[120];
	long	elapsed;
	long	i;
	RECT	rect;
	int		width, height;
	MSG		msg;
	CSetSNumBox		csbn;


	if (!csbn.DoModal()) 
		return;
	NoCapture = iNum;
	sprintf(string, " Any key to stop !");
	SetWindowText(string);

	
	rect.right = -1;
	okSetTargetRect(hBoard, VIDEO, &rect);
	width = rect.right-rect.left;
	height = rect.bottom-rect.top;

	GetClientRect(&rect);
	::MapWindowPoints(hWnd, HWND_DESKTOP, (LPPOINT)&rect, 2);
	if (m_Centerscreen) 
	{
		if (height < (rect.bottom-rect.top)) 
		{
			rect.top += (rect.bottom-rect.top-height)/2;
		}
		rect.left += max(0, (rect.right-rect.left-width)/2);
	}
	okSetTargetRect(hBoard, SCREEN, &rect);

	elapsed = GetTickCount();
	// fast test multi channel
	for (i=0; ; i++) 
	{
		okCaptureTo(hBoard, SCREEN, 0, 1);
		if (okGetTypeCode(hBoard, NULL) != OK_C30) //only C30 can switch source immediately 
			okGetCaptureStatus(hBoard, 1);
		okSetVideoParam(hBoard, VIDEO_SOURCECHAN, i%NoCapture);

		PeekMessage(&msg, NULL, 0, 0, PM_REMOVE);
		//GetMessage(&msg, NULL, 0, 0);
		if (msg.message==WM_KEYDOWN ||
			msg.message==WM_LBUTTONDOWN ||
			msg.message==WM_NCLBUTTONDOWN ) 
		{
				break;
		}
	}
	
	okStopCapture(hBoard);

	elapsed = GetTickCount()-elapsed;
	sprintf (string, "%d Frames Elapsed %d ms", i, elapsed);
	SetWindowText(string);
}

void COkMfcView::OnMulchancapsub() 
{
	// TODO: Add your command handler code here
	//ͨʱʵʱ

	char	string[120];
	long	elapsed;
	long	i;
	RECT	rcVideo;
	RECT	rect, lpRect[5];
	int		height;
	MSG		msg;
	CSetSNumBox		csbn;


	if (!csbn.DoModal()) 
		return;
	NoCapture = iNum;

	sprintf(string, " Any key to stop !");
	SetWindowText(string);

	rcVideo.right = -1;
	okSetTargetRect(hBoard, VIDEO, &rcVideo);
	height = rcVideo.bottom-rcVideo.top;

	GetClientRect(&rect);
	::MapWindowPoints(hWnd, HWND_DESKTOP, (LPPOINT)&rect, 2);

	for (i=0; i<NoCapture; i++) 
	{
		lpRect[i] = rect;
	} 

	if (NoCapture <= 2)  //two rect
	{
		if (m_Centerscreen && (height<(rect.bottom-rect.top))) 
		{
			lpRect[0].top += (rect.bottom-rect.top-height)/2;
			lpRect[1].top += (rect.bottom-rect.top-height)/2;
		}
		lpRect[0].right = (rect.left+rect.right)/2-1;
		lpRect[1].left = (rect.left+rect.right)/2+1;
	}
	else  //4 rect
	{
		//left-top
		lpRect[0].right = (rect.left+rect.right)/2-1;
		lpRect[0].bottom = (rect.top+rect.bottom)/2-1;

		//right-top
		lpRect[1].left = (rect.left+rect.right)/2+1;
		lpRect[1].bottom = (rect.top+rect.bottom)/2-1;

		//left-bottom
		lpRect[2].right = (rect.left+rect.right)/2-1;
		lpRect[2].top = (rect.top+rect.bottom)/2+1;

		//right-bottom
		lpRect[3].left = (rect.left+rect.right)/2+1;
		lpRect[3].top = (rect.top+rect.bottom)/2+1;

	}

	elapsed = GetTickCount();
	// fast test multi channel
	for (i=0; ; i++) 
	{
		//okSetTargetRect(hBoard, VIDEO, &rcVideo);
		okSetTargetRect(hBoard, SCREEN, &lpRect[i%NoCapture]);
		okSetVideoParam(hBoard, VIDEO_SOURCECHAN, i%NoCapture);
		okCaptureTo(hBoard, SCREEN, 0, 1);
		//okCaptureTo(hBoard,BUFFER,i,1);
		//okCaptureTo(hBoard,BUFFER,0,50);
		if (okGetTypeCode(hBoard,NULL) != OK_C30) //only C30 can switch source immediately 
			okGetCaptureStatus(hBoard, 1);

		PeekMessage(&msg, NULL, 0, 0, PM_REMOVE);
		//GetMessage(&msg, NULL, 0, 0);
		if (msg.message==WM_KEYDOWN ||
			msg.message==WM_LBUTTONDOWN ||
			msg.message==WM_NCLBUTTONDOWN) 
		{
				break;
		}
	}
	
	okStopCapture(hBoard);

	elapsed = GetTickCount()-elapsed;
	sprintf(string, "%d Frames Elapsed %d ms", i, elapsed);
	SetWindowText(string);
}

void COkMfcView::OnAsyncmulcap() 
{
	// TODO: Add your command handler code here
	//࿨ɼʱ
	
	char	string[120];
	long	lIndex;
	long	dwBufSize;
	RECT	rect, rect1;
	int		height;

	if(m_BackToScreen)
		bDispToScreen=1;
	else
		bDispToScreen=0;

	lIndex = 0;
	//open specified board
	lphBoard[0] = okOpenBoard(&lIndex);
	lIndex = 1;
	lphBoard[1] = okOpenBoard(&lIndex);

	if (lphBoard[0])  //if success
	{
		sprintf(string, " Any key to stop !");
		SetWindowText(string);

		okGetAvailBuffer(NULL, (DWORD *)&dwBufSize);
		okLockBuffer(lphBoard[0], dwBufSize/2, NULL);
		okLockBuffer(lphBoard[1], dwBufSize/2, NULL);
		
		rect.right = -1;
		okSetTargetRect(lphBoard[0], VIDEO, &rect);
		height = rect.bottom-rect.top;

		GetClientRect(&rect);
		::MapWindowPoints(hWnd, HWND_DESKTOP, (LPPOINT)&rect, 2);
		if (m_Centerscreen && (height<(rect.bottom-rect.top))) 
		{
			rect.top += (rect.bottom-rect.top-height)/2;
		}

		rect1 = rect;
		rect.right = (rect.right+rect.left)/2-1;
		okSetTargetRect(lphBoard[0], SCREEN, &rect);

		rect1.left = (rect1.right+rect1.left)/2+1;
		//rect1.left=(rect1.right+rect1.left)/2;
		okSetTargetRect(lphBoard[1], SCREEN, &rect1);
		//okSetTargetRect(lphBoard[1], SCREEN, &rect);

		okMulCaptureByBuffer(lphBoard, SCREEN, 0, 0);

		while (1) 
		{
		    MSG msg;

			//PeekMessage(&msg, NULL, 0, 0, PM_REMOVE);
			GetMessage(&msg, NULL, 0, 0);
			if (msg.message==WM_KEYDOWN ||
				msg.message==WM_LBUTTONDOWN ||
				msg.message==WM_NCLBUTTONDOWN) 
			{
					break;
			}
		}
		okStopCapture(lphBoard[0]);
		okStopCapture(lphBoard[1]);

		//close specified board
		okCloseBoard(lphBoard[0]);
		okCloseBoard(lphBoard[1]);

		okUnlockAllBuffer();

		sprintf(string, " Stoped !");
		SetWindowText(string);
	}
}


void COkMfcView::OnSyncmulcap() 
{
	// TODO: Add your command handler code here
	//࿨ʵʱʾ
	char	string[120];
	long	lIndex;
	int		i;
	int		height;
	RECT	rect, rect1;
	HANDLE	lphBoard[] = {0,0,0,0,0};
	CSetBNumBox		csbn;


	if (!csbn.DoModal())
		return;
	NoCapture = iNum;

	//open specified board
	for (i=0; i<NoCapture; i++) 
	{
		lIndex = i;
		lphBoard[i] = okOpenBoard(&lIndex);
		if (!lphBoard[i])
			break;
	}

	NoCapture = i;

	if (NoCapture)  //if success at min. 1 more	
	{
		exEnableItem(IDM_FREEZE, TRUE);

		sprintf(string, " Any key to stop !");
		SetWindowText(string);

		rect.right = -1;
		okSetTargetRect(lphBoard[0], VIDEO, &rect);
		height = rect.bottom-rect.top;

		GetClientRect(&rect);
		::MapWindowPoints(hWnd, HWND_DESKTOP, (LPPOINT)&rect, 2);

		if (NoCapture <= 2)  //two rect
		{
			if (m_Centerscreen && (height<(rect.bottom-rect.top))) 
			{
				rect.top += (rect.bottom-rect.top-height)/2;
			}
			rect1 = rect;
			rect.right = (rect.right+rect.left)/2-1;
			okSetTargetRect(lphBoard[0], SCREEN, &rect);

			rect1.left = (rect1.right+rect1.left)/2+1;
			okSetTargetRect(lphBoard[1], SCREEN, &rect1);
		}
		else  //4 rect
		{
			rect1 = rect;
			//left-top
			rect1.right = (rect.left+rect.right)/2;
			rect1.bottom = (rect.top+rect.bottom)/2;
			okSetTargetRect(lphBoard[0], SCREEN, &rect1);
			//right-top
			rect1.left = (rect.left+rect.right)/2+1;
			rect1.right = rect.right;
			okSetTargetRect(lphBoard[1], SCREEN, &rect1);
			//left-bottom
			rect1.left = rect.left+1;
			rect1.right = (rect.left+rect.right)/2;
			rect1.top = (rect.top+rect.bottom)/2+1;
			rect1.bottom = rect.bottom;
			okSetTargetRect(lphBoard[2], SCREEN, &rect1);
			//right-bottom
			rect1.left = (rect.left+rect.right)/2+1;
			rect1.right = rect.right;
			okSetTargetRect(lphBoard[3], SCREEN, &rect1);
		}

		Sleep(40);
		//start mul-capture
		okMulCaptureTo(lphBoard, SCREEN, 0, 0); 
		//okSetSeqCallback(lphBoard[0], exBeginCapture, exBackDisplay, exEndCapture);
		//okMulCaptureTo(lphBoard, BUFFER, 3, 0);//-1: loop infiniately

		while (1) 
		{
		    MSG msg;

			//PeekMessage(&msg, NULL, 0, 0, PM_REMOVE);
			GetMessage(&msg, NULL, 0, 0);
			if (msg.message==WM_KEYDOWN ||
				msg.message==WM_LBUTTONDOWN ||
				msg.message==WM_NCLBUTTONDOWN) 
			{
					break;
			}
		}

		for (i=0; i<NoCapture; i++) 
		{
			okStopCapture(lphBoard[i]);
			//close specified board
			okCloseBoard(lphBoard[i]);
		}

		okUnlockAllBuffer();

		sprintf(string, " Stoped !");
		SetWindowText(string);

		return;
	}
}

void COkMfcView::OnUpdateMatchclient(CCmdUI* pCmdUI) 
{
	// TODO: Add your command update UI handler code here
	
	pCmdUI->SetCheck(m_MatchClient);
}

void COkMfcView::OnMatchclient() 
{
	// TODO: Add your command handler code here
	//ƥû
	
	m_MatchClient = !m_MatchClient;
	if (m_MatchClient) 
	{
		if (m_Centerscreen)
			m_Centerscreen = 0;
		else
			m_Centerscreen = 1;
	}
	InvalidateRect(NULL, TRUE);
}

void COkMfcView::OnSetmatchsize() 
{
	// TODO: Add your command handler code here
	//ûС
	CSetCSizeBox	cscb;

	if (!cscb.DoModal()) return;
	InvalidateRect(NULL, TRUE);
}

void COkMfcView::OnMove(int x, int y) 
{
	CView::OnMove(x, y);
	
	// TODO: Add your message handler code here
	lScrnOffset = exSetToWndRectEx(hBoard, hWnd, m_Centerscreen);
	InvalidateRect(NULL, TRUE);
	
}

void COkMfcView::OnUpdateCaptureaudio(CCmdUI* pCmdUI) 
{
	pCmdUI->Enable(m_CaptureAudio);
}

void COkMfcView::OnCopytoclipb() 
{
	// TODO: Add your command handler code here
	//ճ
	HANDLE	hDIB;
	DWORD	size;
	LPBYTE	lpbuf;

	if (OpenClipboard()) 
	{
		size = (lpbi->biClrUsed==256) ? 1024:0;
		if(lpbi->biBitCount==16 || lpbi->biBitCount==32)
			size += 3 * sizeof(DWORD);
		size += lpbi->biSize+lpbi->biSizeImage;

		hDIB = GlobalAlloc(GMEM_MOVEABLE|GMEM_DDESHARE, size);
		lpbuf = (LPBYTE)GlobalLock(hDIB);
		CopyMemory(lpbuf, lpbi, size-lpbi->biSizeImage);
		CopyMemory(lpbuf+size-lpbi->biSizeImage, lpdib, lpbi->biSizeImage);
		GlobalUnlock(hDIB);

		SetClipboardData(CF_DIB, hDIB);
		CloseClipboard();
	}
}

void COkMfcView::OnSetallocbuf() 
{
	// TODO: Add your command handler code here
	CBufferBox BufferBox;
	
	BufferBox.DoModal();
}

BOOL CALLBACK exDrawAudio(HANDLE hAudio, short *lpwAudio, long size)
{
	int		i;
	char	value;
	static	lastsize = 0;
	int		height = lpbi->biHeight/2;
	int		width = min(lpbi->biWidth,1024);

	sprintf(str, "Recorded times = %d ms    ", GetTickCount()-elapsedtimes);
	TextOut(hdc, 10, 5, str, strlen(str));

	//SelectObject(hdc,BLACK_BRUSH)
    //SelectObject(hdc,GetStockObject(BLACK_BRUSH));//LTGRAY_BRUSH));
	//Rectangle(hdc,0,0,768,576);

	//clear 
	SelectObject(hdc, GetStockObject(BLACK_PEN));
	for (i=0; i<lastsize; i++) 
	{
		value = lastaudio[i];
		MoveToEx(hdc, i, height-value, NULL);
		LineTo(hdc, i, height+value);
	}
	
	size /= 2; //to WORD length
	SelectObject(hdc, hPen);

	if (okSetAudioParam(hAudio,AUDIO_SAMPLEBITS,-1) == 16) 
	{
		for (i=0; i<min(width,size); i++) 
		{
			value = lpwAudio[i]/256;
			MoveToEx(hdc, i, height-value, NULL);
			LineTo(hdc, i, height+value);
			lastaudio[i] = value;
		}
	}
	else 
	{
		LPBYTE	lpbAudio = (LPBYTE)lpwAudio;
		for (i=0; i<min(width,size); i++) 
		{
			value = lpbAudio[i]-128;
			MoveToEx(hdc, i, height-value, NULL);
			LineTo(hdc,i,height+value);
			lastaudio[i] = value;
		}
	}

	lastsize = size;

	return 1;
}

//write audio data to file by this callback function
BOOL CALLBACK exWriteAudioData(HANDLE hAudio, LPBYTE lpAudBuf, long length)
{

	if (length)  //write audio data to file
	{
		_lwrite(hFile, (LPSTR)lpAudBuf, length);
		waveheader.lDataLength += length;

		//display audio data
		exDrawAudio(hAudio, (short *)lpAudBuf, length);
	}
	else  //capture ended, so close the file
	{
		waveheader.lFileLength += waveheader.lDataLength;
		_llseek(hFile, 0, SEEK_SET);
		_lwrite(hFile, (LPSTR)&waveheader, sizeof(WAVEFILEHEADER));
		_lclose(hFile);
	}

	return 1;
}

//create wav file by way of callback function of capture audio function
int exCreateAudioFile2(HANDLE hAudio, LPSTR szFileName, long lSampFrq, short iSampBits)
{
	//set parameters
	okSetAudioParam(hAudio, AUDIO_SAMPLEFRQ, lSampFrq);
	okSetAudioParam(hAudio, AUDIO_SAMPLEBITS, iSampBits);
	okSetAudioParam(hAudio, AUDIO_INVOLUME, 250);

	//make header of wav file
	strncpy(waveheader.RIFF, "RIFF", 4);
	strncpy(waveheader.WAVE, "WAVE", 4);
	strncpy(waveheader.fmt, "fmt ", 4);
	strncpy(waveheader.RIFF, "RIFF", 4);
	waveheader.lHeadSize = 0x10;
	strncpy(waveheader.data, "data", 4);
	waveheader.wFormatTag = WAVE_FORMAT_PCM;//0x10;
	waveheader.nChannels = 1;

	waveheader.nSamplesPerSec = lSampFrq;
	waveheader.nAvgBytesPerSec = lSampFrq*(iSampBits/8);
	waveheader.nBlockAlign = 2;
	waveheader.wBitsPerSample = iSampBits;

	//create file
	{
		OFSTRUCT	OfStruct;   

		if ((hFile = OpenFile(szFileName, &OfStruct,
				  OF_CANCEL | OF_CREATE)) < 0) 
		{
			//lErroCode=OPENFILEERROR;
			return FALSE;
		}
	}
	
	waveheader.lFileLength = sizeof(WAVEFILEHEADER);
	_lwrite(hFile, (LPSTR)&waveheader, sizeof(WAVEFILEHEADER));
	waveheader.lDataLength = 0;

	//capture audio data
	okCaptureAudio(hAudio, BUFFER, (FARPROC)exWriteAudioData, 0);


	return 1;
}


void COkMfcView::OnCaptureaudio() 
{
	// TODO: Add your command handler code here
	char	szFileName[] = "test.wav";
	long	lSampFrq = 8000;
	short	iSampBits = 8;


	//okCaptureTo(hBoard,SCREEN,0,0);
	
	hAudio = okOpenAudio(hBoard, 0);
	if (hAudio) 
	{
		elapsedtimes = GetTickCount();
		
		//hwnd=hWnd;
//		hdc = GetDC()->GetSafeHdc();
		hPen = CreatePen(PS_SOLID, 1, RGB(0,255,0));

		//capture audio and create file
		exCreateAudioFile2(hAudio, szFileName, lSampFrq, iSampBits);

		exEnableItem(IDM_FREEZE, TRUE);
	}	
}

void COkMfcView::OnSeqcaptobuf() 
{
	// TODO: Add your command handler code here
	//жϷʽвɼ	
	long num;

	exEnableItem(IDM_FREEZE, TRUE);
	if(m_BackToScreen)
		bDispToScreen=1;
	else
		bDispToScreen=0;
	okSetSeqCallback(hBoard, exBeginCapture, exBackDisplay, exEndCapture);
	//okSetSeqProcWnd(hBoard,hWnd);
	num = okCaptureSequence(hBoard, 0, 0); //just get num for sequence

	okCaptureSequence(hBoard, 0, -1);//
}

void COkMfcView::OnUpdateSeqcaptobuf(CCmdUI* pCmdUI) 
{
	pCmdUI->Enable(m_SeqCapToBuf);
}

void COkMfcView::OnRegdevdriver() 
{
	//װ豸
	okSetNTDriver(1); //mainly for NT4
}

void COkMfcView::OnUpdateRegdevdriver(CCmdUI* pCmdUI) 
{
	pCmdUI->Enable(m_Regdevdriver);
}

void COkMfcView::OnCaptopseudo() 
{
	//αɫʾ
	exEnableItem(IDM_FREEZE, TRUE);
	bDispToScreen = 3;
	okSetSeqCallback(hBoard,exBeginCapture,exBackDisplay,exEndCapture);
	//just capture to buffer
	okCaptureByBuffer(hBoard, BUFFER, 0, 0);//0: cont.
}

void COkMfcView::OnUpdateMakexmirror(CCmdUI* pCmdUI) 
{
	pCmdUI->SetCheck(m_MakeXMirror);
}

void COkMfcView::OnUpdateMakeymirror(CCmdUI* pCmdUI) 
{
	pCmdUI->SetCheck(m_MakeYMirror);
}

void COkMfcView::OnMakexmirror() 
{
	//ˮƽ
	if (m_MakeXMirror) 
	{
		bMakeMirror &= 2;
	}
	else 
	{
		bMakeMirror |= 1;
	}

	m_MakeXMirror = !m_MakeXMirror;
	okSetConvertParam(hBoard, CONVERT_MIRROR, bMakeMirror);
}

void COkMfcView::OnMakeymirror() 
{
	//ֱ
	if (m_MakeYMirror) 
	{
		bMakeMirror &= 1;
	}
	else 
	{
		bMakeMirror |= 2;
	}

	m_MakeYMirror = !m_MakeYMirror;
	okSetConvertParam(hBoard, CONVERT_MIRROR, bMakeMirror);
}

void COkMfcView::OnSize(UINT nType, int cx, int cy) 
{
	CView::OnSize(nType, cx, cy);

	if(!bActive) {//non-capturing
		if(	!IsWindow(hwndPlay) && okGetBufferSize(hBoard,NULL,(DWORD *)&dwBufSize) ) {
			exGetBitmapHeader(hBoard, BUFFER, lpbi); 
		}
	}

	lScrnOffset = exSetToWndRectEx(hBoard, hWnd, m_Centerscreen);
	InvalidateRect(NULL,TRUE);
	if (bActive) //re-capture
		okCaptureToScreen(hBoard);	
}


void COkMfcView::OnZeroallbuffer() 
{
	//clear screen dib and buffer 0
	LPBYTE		lpLinear;
	DWORD		dwSize;

	//okGetAvailBuffer(&lpLinear,&dwSize);
	okGetBufferSize(hBoard, (void **)&lpLinear, &dwSize);
	memset(lpLinear, 255, dwSize);
	//ZeroMemory(lpLinear, dwSize);

	if (lpbi->biHeight) 
		ZeroMemory(lpdib, lpbi->biSizeImage);
	InvalidateRect(NULL, FALSE);
}

void COkMfcView::OnUpdateUptoright(CCmdUI* pCmdUI) 
{
	pCmdUI->Enable(m_UptoRight);
	if (m_UptoRight == TRUE)
		pCmdUI->SetCheck(m_UptoRightCheck);
	else
		pCmdUI->SetCheck(FALSE);
}

void COkMfcView::OnUpdateUptoleft(CCmdUI* pCmdUI) 
{
	pCmdUI->Enable(m_UptoLeft);
	if (m_UptoLeft == TRUE)
		pCmdUI->SetCheck(m_UptoLeftCheck);
	else
		pCmdUI->SetCheck(FALSE);
}

void COkMfcView::OnTestvgacard() 
{
	OnFreeze();

	exEnableItem(IDM_FREEZE, TRUE);
	bActive = 1;
	//must not to upright
	m_UptoRightCheck = FALSE;
	m_UptoLeftCheck = FALSE;
	okSetConvertParam(hBoard, CONVERT_UPRIGHT, 0); //un to upright

	//restore to normal (system palette)
//	okSetConvertParam(hBoard, CONVERT_PALETTE, (LPARAM)NULL);
	//direct to vga memory
	if (m_BackToScreen)
		okSetSeqCallback(hBoard,exBeginCapture,exBackDisplay,exEndCapture);

	//okSetToWndRect(hBoard,hWnd);
	lScrnOffset=exSetToWndRectEx(hBoard,hWnd,bScrnCenter); 
	//okSetCaptureParam(hBoard,CAPTURE_MISCCONTROL,0);
	okCaptureByBuffer(hBoard,SCREEN,0,0);//0: cont.
	//{
	//	RECT	rect;
	//	GetClientRect(hWnd,&rect);
	//	okSetTargetRect(hBoard,(TARGET)hWnd,&rect);
	//}
	//okCaptureByBuffer(hBoard,(TARGET)hWnd,0,0);//0: cont.
}

void COkMfcView::OnTestdrawwnd() 
{
	OnFreeze();
	exEnableItem(IDM_FREEZE, TRUE);
	bActive = -1;
	//must not to upright
	m_UptoRightCheck = FALSE;
	m_UptoLeftCheck = FALSE;
	okSetConvertParam(hBoard, CONVERT_UPRIGHT, 0); //un to upright

	//okSetCaptureParam(hBoard,CAPTURE_MISCCONTROL,1);

	//direct to wnd client
	{
		RECT	rect;

		if(m_MatchClient) {
			//
			//GetClientRect(hWnd,&rect);
			//okSetTargetRect(hBoard,(TARGET)hWnd,&rect);
			//auto matching mode: 
			rect.left=1;rect.right=0; //to match window client
			rect.top=rect.bottom=0;
			okSetTargetRect(hBoard,(TARGET)hWnd, &rect);
		}
		else { //same as set as screen
			//not matching mode: way 1 to take screen rect preset
			//okSetTargetRect(hBoard,(TARGET)hWnd,NULL); //clear rect set

			rect.left=rect.right=0; //not to match window client
			//not matvhing mode: way 2 
			//rect.right=-1;
			//okSetTargetRect(hBoard,(TARGET)SCREEN, &rect);
			//MapWindowPoints(HWND_DESKTOP, hWnd, (LPPOINT)&rect,2);
			
		}
		if (m_BackToScreen)
			okSetSeqCallback(hBoard,exBeginCapture,exBackDisplay,exEndCapture);
		okCaptureByBuffer(hBoard,(TARGET)hWnd,0,0);//0: cont.
	}
}

void COkMfcView::OnUptoright() 
{
	short	bChange = 1;

	if (m_UptoLeftCheck == TRUE) {
		m_UptoLeftCheck = FALSE;
		m_UptoRightCheck = TRUE;
		okSetConvertParam(hBoard, CONVERT_UPRIGHT, 1); //to right
		bChange = 0;
	}
	else if (m_UptoRightCheck == TRUE) {
		m_UptoRightCheck = FALSE;	
		okSetConvertParam(hBoard, CONVERT_UPRIGHT, 0); //un to
	}
	else { //new check
		m_UptoRightCheck = TRUE;
		okSetConvertParam(hBoard, CONVERT_UPRIGHT, 1); //up to right
	}

	if (bChange)  //exchange w and h
	{ //treat rotate
		long	temp=lpbi->biWidth;

		lpbi->biWidth = lpbi->biHeight;
		lpbi->biHeight = temp;
		exSetBitmapHeader(lpbi, (short)lpbi->biWidth, (short)lpbi->biHeight, (short)lpbi->biBitCount, 0 );
	}
	InvalidateRect(NULL, TRUE);				
}


void COkMfcView::OnUptoleft() 
{
	short	bChange=1;

	if (m_UptoRightCheck == TRUE) {
		m_UptoRightCheck = FALSE;
		m_UptoLeftCheck = TRUE;
		okSetConvertParam(hBoard, CONVERT_UPRIGHT, 2); //to left
		bChange = 0;
	}
	else if (m_UptoLeftCheck == TRUE) {
		m_UptoLeftCheck = FALSE;
		okSetConvertParam(hBoard, CONVERT_UPRIGHT, 0); //un to
	}
	else { //new check
		m_UptoLeftCheck = TRUE;
		okSetConvertParam(hBoard, CONVERT_UPRIGHT, 2); //up to left
	}

	if( bChange)  //exchange w and h
	{ //treat rotate
		long	temp=lpbi->biWidth;

		lpbi->biWidth=lpbi->biHeight;
		lpbi->biHeight=temp;
		exSetBitmapHeader(lpbi, (short)lpbi->biWidth, (short)lpbi->biHeight, (short)lpbi->biBitCount, 0 );
	}
	InvalidateRect(NULL, TRUE);				
}

void COkMfcView::OnUpdateCapturempeg2(CCmdUI* pCmdUI) 
{
	pCmdUI->Enable(m_CaptureMpeg2);
}

BOOL exM2VSaveName(HWND hWnd, char *szFileName)
{
	OPENFILENAME ofn;	 
	char		*szFilter=
					"MPEG-2 Video/Audio file (*.M2V)\0*.M2V\0"
					"MPEG-2 Video/Audio file (*.MPG)\0*.MPG\0"
					"Compressed AVI in MJPEG  (*.AVI)\0*.AVI\0"
					"Compressed AVI in MPEG4  (*.AVI)\0*.AVI\0";

    //Get file name
	// fill in non-variant fields of OPENszFileName struct. 
    ZeroMemory(&ofn,sizeof(OPENFILENAME));
    ofn.lStructSize		= sizeof(OPENFILENAME);
    ofn.hwndOwner	  	= hWnd;
    ofn.lpstrFilter 	= szFilter;
	ofn.nFilterIndex	= 0;//default
    ofn.lpstrFile	  	= szFileName;
    ofn.nMaxFile	  	= 128;
	ofn.lpstrDefExt		= "mpg";

    ofn.Flags		  	= OFN_HIDEREADONLY|OFN_OVERWRITEPROMPT;

    if (!GetSaveFileName ((LPOPENFILENAME)&ofn)) {
		return FALSE;
	}

	if(ofn.nFilterIndex==3) { //avi seq file in jpeg data
		strcat(szFileName,",mjpg"); //avi in mjpg
	}
	else if(ofn.nFilterIndex==4) { //avi seq file in mpg4 data
		strcat(szFileName,",mpg4"); //avi in mpg4
	}

	return TRUE;
}


//write audio data to file by this callback function
BOOL CALLBACK exWriteStreamData(HANDLE hStream, LPBYTE lpStreamBuf, long length)
{

	if(length) { //write audio data to file
		_lwrite(hFile, (LPCSTR)lpStreamBuf, length);

	}
	else { //capture ended, so close the file
		DWORD	total;

		 okStopCaptureStream(hStream,0);
		 total=okStopCaptureStream(hStream,0);
		_lwrite(hFile,"00ok",4);
		_lwrite(hFile,(LPSTR)&total,4);
		_lclose(hFile);
	}

	return 1;
}


//create wav file by way of callback function of capture audio function
HANDLE exCreateStreamFile1(HANDLE hAudio, LPSTR szFileName)
{
	//set parameters

	//create file
	{
		OFSTRUCT	OfStruct;   

		if ((hFile = OpenFile(szFileName, &OfStruct,
				  OF_CANCEL | OF_CREATE)) < 0) {
			//lErroCode=OPENFILEERROR;
			return FALSE;
		}
	}
	
	//capture stream data
	return okCaptureStream(hStream,NONE,(FARPROC)exWriteStreamData,0);


	//return 1;
}




//create m2v(MPEG2) file by myself completely
BOOL exCreateStreamFile2(HANDLE hStream, LPSTR szFileName)
{
	LPBYTE	lpStreamBuf;
	int		length;
	long	maxBufSize;


	//set parameters

	//make file header
	{
		OFSTRUCT	OfStruct;   

		if ((hFile = OpenFile(szFileName, &OfStruct,
				  OF_CANCEL | OF_CREATE)) < 0) {
			//lErroCode=OPENFILEERROR;
			return FALSE;
		}
	}

	
	//start capture audio data
	if(!okCaptureStream(hStream,0,0,0))
		return 0;

	maxBufSize=20*1024;//
	lpStreamBuf=(LPBYTE)malloc(maxBufSize*2);


	sprintf(str," Any key to stop !");
	SetWindowText(hwnd,str);
	while(1) {
		MSG msg;

		if(hStream==0) //ended
			break;

		//Sleep(maxMiliSeconds/3);
		
		length=okReadStreamData(hStream,lpStreamBuf,maxBufSize);
		if(length) {

			_lwrite(hFile,(LPCSTR)lpStreamBuf,length);
			
		}

		//
		PeekMessage(&msg, NULL, 0, 0, PM_REMOVE);
		if( msg.message==WM_KEYDOWN ||
			msg.message==WM_LBUTTONDOWN ||
			msg.message==WM_NCLBUTTONDOWN ) {
				break;
		}
	}
		

	//end
	okStopCaptureStream(hStream,0);
	
	{
		DWORD	total;

		 total=okStopCaptureStream(hStream,0);
		_lwrite(hFile,"00ok",4);
		_lwrite(hFile,(LPSTR)&total,4);
		_lclose(hFile);
	}

	free(lpStreamBuf);

	SendMessage(hwnd, WM_COMMAND, IDM_CAPTUREMPEG2, 0);
	return 1;
}

DWORD	starttime; 
//long	elapsed;

//if length=0, ended
BOOL CALLBACK exMsgCallback(HANDLE hStream, LPBYTE lpStreamBuf, long length)
{
	static count;
	static long TotalLength;
	long	currtime;

	if(!length) //stoped
		return 0;

	currtime=okGetTickCount()-elapsed;

	TotalLength+=length;
	if(currtime) {
		sprintf(str," MPEG2 Captured Times= %d Seconds;  Section = %d;  Rate = %d (KB/S)     ",(okGetTickCount()-starttime)/1000,length, TotalLength/(okGetTickCount()-elapsed));
		SetWindowText(hwnd,str);

		elapsed=okGetTickCount();
		TotalLength=0;
	}
	count++;

	return 1;

}

//create wav file by way of using capture audio function directly
HANDLE exCreateStreamFile3(HANDLE hStream, LPSTR szFileName)
{
	//set stream parameters

	//okSetStreamParam(hAudio,AUDIO_CALLINTERVAL,20); 

	elapsed = okGetTickCount();

	//make wav file by call this function
	return okCaptureStream(hStream, (TARGET)szFileName, (FARPROC)exMsgCallback, 0);

	//return 1;
}

//to open one board as current board to operate
BOOL exCaptureStreamFile(HANDLE hBoard, HWND hWnd)
{
	//test audio
	char	szFileName[256]="d:\\test"; //also as test.mpg
	int		reslution=0; //d1, 3 sif
	//okCaptureTo(hBoard,SCREEN,0,0);
	
	if( !exM2VSaveName(hWnd, szFileName) )
		return FALSE;
	
	if(!hStream)
		hStream=okOpenStream(hBoard, 0);

	if(hStream) {
		elapsedtimes=okGetTickCount();
		
		hwnd=hWnd;

		reslution=GetPrivateProfileInt("Init","StreamResolution",0,"OkDemo.ini");

		okSetStreamParam(hStream, STREAM_RESOLUTION, reslution); //SIF for c20b
		//okSetStreamParam(hStream, STREAM_BITRATEMODE, 1000); //
		okSetStreamParam(hStream, STREAM_BITRATEMODE, 3000); //for c20b
		okSetStreamParam(hStream, STREAM_MAXBITRATE, 9000); //for c20b

		//okSetStreamParam(hStream, STREAM_BITRATEMODE, 0); //for c20b
		//okSetStreamParam(hStream, STREAM_MAXBITRATE, 800); //for c20b, errer when small than 800

		//okSetStreamParam(hStream, STREAM_QUALITY, 50); //for rgb60c

		//okSetStreamParam(hStream, STREAM_MAXFILELEN, 1); //for c20b

		//capture audio and create file
		exCreateStreamFile3(hStream,szFileName);

		//exEnableItem(hwnd, IDM_FREEZE, TRUE);

		return 1;

	}	

	return 0;
}

BOOL exEndCaptureStream(HANDLE hStream)
{
	if(hStream) {
		
		//test pause
		//okStopCaptureStream(hStream,1); //pause
		//Sleep(5000);		
		//okStopCaptureStream(hStream,2); //re-encode
		//Sleep(10000);		

		
		okStopCaptureStream(hStream,0);

		total=okStopCaptureStream(hStream,0);

//		okCloseStream(hStream);
		//hStream=0;
		//way1 and way2 end file

		elapsedtimes=okGetTickCount()-elapsedtimes;
		sprintf(str," Stoped ! captured times = %d ms; Length=%d",elapsedtimes,total);
		SetWindowText(hwnd,str);

	}

	return 1;
}

void COkMfcView::OnCapturempeg2() 
{
	static  flag=0;

	if(flag==0) {
		GetMenu()->ModifyMenu(IDM_CAPTUREMPEG2, MF_BYCOMMAND|MF_STRING,IDM_CAPTUREMPEG2, "&G ֹͣɼ MPEG2");
		flag=1;
		if(!exCaptureStreamFile(hBoard, hWnd))
			flag=0;
	}
	else {
		exEndCaptureStream(hStream);
		GetMenu()->ModifyMenu(IDM_CAPTUREMPEG2, MF_BYCOMMAND|MF_STRING,IDM_CAPTUREMPEG2, "&G ɼ MPEG2");
		flag=0;
	}
}

BOOL exLoadCfgFile(HANDLE hBoard, HWND hWnd)
{
	OPENFILENAME ofn;	 
	char		*szFilter="Config file with full params. (*.OKF) \0*.OKF\0"
						  "Config file just for sample (*.OKS) \0*.OKS\0"
						  "Config file just for output (*.OKO) \0*.OKO\0";

	//char		szFileName[256]="";
	char		szFileName[512]="\0";
	//char		szDesc[256];

    //Get file name
	// fill in non-variant fields of OPENszFileName struct. 
    ZeroMemory(&ofn,sizeof(OPENFILENAME));
	ofn.lStructSize		= sizeof(OPENFILENAME);
    ofn.hwndOwner	  	= hWnd;
    ofn.lpstrFilter 	= szFilter;
	ofn.nFilterIndex	= 1;
    ofn.lpstrFile	  	= szFileName;
    ofn.nMaxFile	  	= 256;
	ofn.lpstrDefExt		= "okf";
    ofn.Flags		  	= OFN_HIDEREADONLY;

    if (! GetOpenFileName ((LPOPENFILENAME)&ofn)) {
		return FALSE;
	}


	//strcpy(szDesc,szFileName);
	//okLoadConfigFile(NULL,szDesc);

	okLoadConfigFile(hBoard,szFileName);

	return TRUE;

}

void COkMfcView::OnLoadconfigfile() 
{
	exLoadCfgFile(hBoard, hWnd);

	InitSetMenu(hWnd, hBoard);

	exGetBitmapHeader(hBoard, BUFFER, lpbi); //set-lpbi
	//get current size  
	sampwidth=(short)lpbi->biWidth;
	sampheight=(short)lpbi->biHeight;
	lScrnOffset=exSetToWndRectEx(hBoard, hWnd, m_Centerscreen);
	InvalidateRect(NULL,TRUE);				
}

void COkMfcView::OnSaveconfigfile() 
{
	OPENFILENAME ofn;	 
	char		*szFilter="Config file for Ok Card  (*.OKF)\0*.OKF\0";
	char		szFileName[512]="PAL.OKF";

	// fill in non-variant fields of OPENszFileName struct. 
    ZeroMemory(&ofn,sizeof(OPENFILENAME));
    ofn.lStructSize		= sizeof(OPENFILENAME);
    ofn.hwndOwner	  	= hWnd;
    ofn.lpstrFilter 	= szFilter;
	ofn.nFilterIndex	= 1;
    ofn.lpstrFile	  	= szFileName;
    ofn.nMaxFile	  	= 256;
	ofn.lpstrDefExt		= "okf";

    ofn.Flags		  	= OFN_HIDEREADONLY|OFN_OVERWRITEPROMPT;

    if (!GetSaveFileName ((LPOPENFILENAME)&ofn)) {
		return ;
	}

	okSaveConfigFile(hBoard,szFileName);
}

void COkMfcView::OnAbsolutedsa() 
{
	exFillOutLUT(hBoard, 3);
}

void COkMfcView::OnUpdateAbsolutelut(CCmdUI* pCmdUI) 
{
	pCmdUI->Enable(m_AbsoluteLut);
}

void COkMfcView::OnUpdateAbsolutedsa(CCmdUI* pCmdUI) 
{
	pCmdUI->Enable(m_AbsoluteDsa);
}

void COkMfcView::OnNormainlut() 
{
	//ұ	
	exFillInputLUT(hBoard, 0);
}

void COkMfcView::OnInverseinlut() 
{
	//ұ	
	exFillInputLUT(hBoard, 1);
}


//--demo to set text to target(here is BUFFER)
BOOL exDemoSetText(HANDLE hBoard)
{
	LOGFONT 	lfLogFont={ -20, 0, 0, 0, 400, 0, 0, 0, 0, 1, 2, 1, 26, "Arial"};
	SETTEXTMODE	textmode={0xffffff,0xf0,0,0,0};  //
	RECT		rect= {0,100,0,0};


	okSetTextTo(hBoard, BUFFER, &rect, &lfLogFont, &textmode, "κ", 8); 

	return 1;
}


//--demo to encode jpg data 
exEncodeJpeg(HANDLE hBoard, TARGET target, long start, LPBYTE *lpData )
{
	HANDLE		hCoder;
	JPEGPARAM	JpegParam;
	LPBYTE		lpJPEG;
	long		jpglen,maxlen;

	maxlen=768*576*3;
	lpJPEG= (LPBYTE)GlobalAlloc (GPTR, maxlen);

	ZeroMemory(&JpegParam,sizeof(JPEGPARAM));
	JpegParam.dwSize=sizeof(JPEGPARAM);
	JpegParam.dwQuality=50;
	hCoder=okBeginEncode(hBoard, CODE_JPEG, (LPARAM)&JpegParam);

	jpglen=okEncodeImage(hCoder, target, start, lpJPEG, maxlen);
	okEndEncode(hCoder);

	//jpeg data stored in lpJPEG, length = jpglen
	*lpData=lpJPEG;
	return jpglen; 
}


//--demo to decode jpg data 
exDecodeJpeg(HANDLE hBoard, LPBYTE lpJPEG, long jpglen, TARGET target, long start)
{
	IMAGESIZE	imageinfo;
	HANDLE		hCoder;

	hCoder=okBeginDecode(hBoard, CODE_JPEG, lpJPEG, (LPARAM)&imageinfo);

	okDecodeImage(hCoder, lpJPEG, &jpglen, target, start);

	okEndDecode(hCoder);

	return jpglen;
}



//test compress image
long exEncodeImage(HANDLE hBoard, long codeway, LPARAM lParam, TARGET src, LPBYTE lpJPEG, long maxlen)
{

	HANDLE		hCoder;
	long		length=0;
	int			i;
	long		basetime,elapsed;

	//lpJPEG to store coded data
	//set param and begin encode
	basetime=okGetTickCount();

	hCoder=okBeginEncode(hBoard, codeway, (LPARAM)lParam);

	for(i=0; i<5; i++) {
		//encode one frame, return coded data length of one frame
		length+=okEncodeImage(hCoder, src, i, lpJPEG+length, maxlen);
	}

	//end
	okEndEncode(hCoder);

	elapsed=okGetTickCount()-basetime;

	{
		DWORD	dw;
		HANDLE	hFile;
		hFile=CreateFile("mpeg4.3",GENERIC_READ|GENERIC_WRITE,FILE_SHARE_READ,NULL,OPEN_ALWAYS,FILE_ATTRIBUTE_NORMAL,NULL);

		if(hFile==INVALID_HANDLE_VALUE){
			return 0;
		}
		WriteFile(hFile, (LPSTR)lpJPEG, length, &dw, NULL);
		CloseHandle(hFile);
	}

	return length; 

}


//test decompress image
long exDecodeImage(HANDLE hBoard, long codeway, LPARAM lParam, LPBYTE lpJPEG, long maxlen, TARGET src)
{
	HANDLE		hCoder;
	int			i;
	long		length=0;
	
	MJPGHEADER	*lpImageinfo;
	EXTRAFRMINFO extrainfo;

	//lpJPEG stored coded data

	lpImageinfo=(MJPGHEADER	*)lParam;
	lpImageinfo->dwGetFrmInfo=MJPG_GINF;
	lpImageinfo->lpExtraInfo = (LPVOID)&extrainfo;

	//begin decode and get size info
	hCoder=okBeginDecode(hBoard, codeway, lpJPEG, lParam);

	extrainfo.dwFlgSkip = MJPG_SKIP;

	for(i=0; i<5; i++) {
		//decode one frame to BUFFER
		length=768*576*3;
		okDecodeImage(hCoder, lpJPEG, &length, src, i+1);
		lpJPEG+=length;
	}

	//end
	okEndDecode(hCoder);

	return length;
}

TestEncode(HANDLE hBoard)
{
	LPBYTE		lpBuf;
	long		lSize=768*576*4*4;
	MPEG4HEADER	sCodeParam;
	RECT		rect;
	long		basetime,elapsed;

	//
	rect.right=-1;
	okSetTargetRect(hBoard, BUFFER,&rect);
	ZeroMemory(&sCodeParam,sizeof(MPEG4HEADER));
	sCodeParam.lHeadSize=sizeof(MPEG4HEADER); //must be set
	sCodeParam.lQualityIdx=0;
	sCodeParam.lHorzSize=rect.right-rect.left; //768;
	sCodeParam.lVertSize=rect.bottom-rect.top; //576;
	sCodeParam.lBitCount=HIWORD(okSetCaptureParam(hBoard,CAPTURE_BUFRGBFORMAT,-1)); //24
	sCodeParam.lTotalFrame=1;


	basetime=okGetTickCount();

	lpBuf=(LPBYTE)GlobalAlloc(GPTR,lSize);

	exEncodeImage(hBoard, CODE_MJPG, (LPARAM)&sCodeParam, BUFFER, lpBuf, lSize);
	elapsed=okGetTickCount()-basetime;

	exDecodeImage(hBoard, CODE_MJPG, (LPARAM)&sCodeParam, lpBuf, lSize, BUFFER);

	elapsed=okGetTickCount()-basetime;

	return 1;
}


void COkMfcView::OnUpdateFillinglut(CCmdUI* pCmdUI) 
{
	pCmdUI->Enable(m_FillInGLut);	
}

void COkMfcView::OnFillinglut() 
{
	//okOpenSetLUTDlg(hBoard, hWnd, NULL);
}

void COkMfcView::OnTestmainwnd() 
{
	//д
	OnFreeze();
	exEnableItem(IDM_FREEZE, TRUE);
	bActive=-1;
	if (m_BackToScreen)
		bDispToScreen=1;
	else
		bDispToScreen=0;

	hLoopThread=exCreateLoopCapture(hBoard, hWnd);
}

BOOL COkMfcView::InitSetMenu(HWND hWnd, HANDLE hBoard)
{
	HMENU	hMenu;
	long	typecode;
	char	okname[120];

	intrMISCCONTROL=okSetCaptureParam(hBoard,CAPTURE_MISCCONTROL,-1)&0x3;

	exGetBitmapHeader(hBoard, SCREEN, lpbi); 
	//set initial size
	sampwidth = (short)lpbi->biWidth;
	sampheight = (short)lpbi->biHeight;
	//initailize screen
	lScrnOffset = exSetToWndRectEx(hBoard, hWnd, m_Centerscreen);
	InvalidateRect(NULL, FALSE);

	okSetConvertParam(hBoard, CONVERT_UPRIGHT, 0); //init to normal 
	m_UptoRight = TRUE;
	m_UptoLeft = TRUE;
	m_UptoRightCheck = FALSE;
	m_UptoLeftCheck = FALSE;

	okSetConvertParam(hBoard, CONVERT_MIRROR, 0);//init to normal 
	m_MakeXMirror = FALSE;
	m_MakeYMirror = FALSE;

	//set init menu 
	hMenu = ::GetMenu(hWnd);
	//modelcode=okGetTypeCode(hBoard,-1); //just get model code
    typecode=okGetTypeCode(hBoard,okname);
	if(typecode<0) //virtual 
		strcat(okname,"_");
	if (okSetVideoParam(hBoard, VIDEO_FRAMELINES, -1) != -1)  //support playback
	{
		EnableMenuItem(hMenu, 3, MF_BYPOSITION|MF_ENABLED);
		if (typecode == OK_M30) //special for M30 without outlut
		{
			m_NormalLut = FALSE;
			m_InverseLut = FALSE;
			m_AbsoluteLut = FALSE;
			m_AbsoluteDsa = FALSE;
		}
	}
	else 
	{
		EnableMenuItem(hMenu, 3, MF_BYPOSITION|MF_GRAYED);
		//EnableMenuItem(hMenu,3,MF_BYPOSITION|MF_GRAYED);
	}

	if (LOWORD(okSetCaptureParam(hBoard, CAPTURE_FRMRGBFORMAT, -1)) != 0xffff) 
	{
		m_CapToFrame = TRUE;
		m_BufferToFrame = TRUE;
		m_FrameToBuffer = TRUE;
		m_FrameToScreen = TRUE;
	}
	else 
	{
		m_CapToFrame = FALSE;
		m_BufferToFrame = FALSE;
		m_FrameToBuffer = FALSE;
		m_FrameToScreen = FALSE;
	}
	
	if (typecode == OK_M60)  //special for M60 with frame
	{
		m_CapToFrame = true;
		m_BufferToFrame = true;
	}
	else if (typecode == OK_RGB30)  //special for RGB30 with frame
	{
		m_CapToFrame = false;
		m_FrameToBuffer = false;
		m_FrameToScreen = false;
	}


	if (okOpenAudio(hBoard, 1))  //support audio funcrion
	{
		m_CaptureAudio = true;
	}
	else 
	{
		m_CaptureAudio = false;
	}
	if (okOpenStream(hBoard, 1))  //support stream funcrion
	{
		m_CaptureMpeg2 = true;
	}
	else 
	{
		m_CaptureMpeg2 = false;
	}

	//reg device driver for nt/2k/xp 
	if (okSetNTDriver(0))  // TRUE:registered already, -1:not nt system
	{
		m_Regdevdriver = false;
	}

	//okSaveInitParam(hBoard,2);
	//okLoadInitParam(hBoard,2);


	//get current mask mode 
	m_Enablemask = (short)okEnableMask(hBoard, -1);
	if(m_Enablemask == -1) //not support
	{
		b_Enablemask = false;
		m_Enablemask = false;
	}
	else 
	{
		b_Enablemask = true;
		exDemoMask();
	}

	if (okCaptureSequence(hBoard, 0, 0) == -1)
	{//interrupt to capture
		m_SeqCapToBuf = FALSE;
		m_LoopSeqCapToBuf = FALSE;
		m_InterToIndirect = FALSE;
	}
	else
	{
		m_SeqCapToBuf = TRUE;
		m_LoopSeqCapToBuf = TRUE;
		m_InterToIndirect = TRUE;
	}


	if( (okFillInputLUT(hBoard, NULL, 0, 0)>0 ) ||
			(okFillOutLUT(hBoard, NULL, 0, 0)>0) )    //set lut
		m_FillInGLut = true;
	else
		m_FillInGLut = false;

	//disable active and display sync with vert
	{
		long	lset;

		lset=okSetCaptureParam(hBoard,CAPTURE_MISCCONTROL,-1);
		//if(MF_CHECKED==LOWORD(GetMenuState(hMenu,IDM_DISABLEACTIVE,MF_BYCOMMAND))) 
		if((lset&0x800000) ||(lset&0x80)) //disabled
		{
			m_DisableActive = true;
		}
		else {
			m_DisableActive = false;
		}


		lset=okSetConvertParam(hBoard,CONVERT_NOSYNCSCREEN,-1); //0: sync
		if(lset) //disabled
		{
			m_DisableSyncVert = true;
		}
		else {
			m_DisableSyncVert = false;
		}

	}

	return TRUE;
}

void COkMfcView::OnUpdateDisableactive(CCmdUI* pCmdUI) 
{
	// TODO: Add your command update UI handler code here
	pCmdUI->SetCheck(m_DisableActive);
}

void COkMfcView::OnUpdateDisablesyncvert(CCmdUI* pCmdUI) 
{
	// TODO: Add your command update UI handler code here
	pCmdUI->SetCheck(m_DisableSyncVert);
}

void COkMfcView::OnDisablesyncvert() 
{
	// TODO: Add your command handler code here
	long	lset;
	
	lset=okSetConvertParam(hBoard,CONVERT_NOSYNCSCREEN,-1); //0: sync
	if(lset) //disabled
	{
		okSetConvertParam(hBoard,CONVERT_NOSYNCSCREEN,0); //un-disable
		m_DisableSyncVert = false;
	}
	else {
		okSetConvertParam(hBoard,CONVERT_NOSYNCSCREEN,1);//disable
		m_DisableSyncVert = true;
	}
}

void COkMfcView::OnDisableactive() 
{
	// TODO: Add your command handler code here
	long	lset;
	
	lset=okSetCaptureParam(hBoard,CAPTURE_MISCCONTROL,-1);
	//if(MF_CHECKED==LOWORD(GetMenuState(hMenu,IDM_DISABLEACTIVE,MF_BYCOMMAND))) 
	
	if(!(lset&0x800000)) { //allow to be change 
		lset |= 0x800000;  // set special flag
		if(lset&0x80) //disabled
		{
			lset &= ~0x81;  // enable
			okSetCaptureParam(hBoard,CAPTURE_MISCCONTROL,lset);
			m_DisableActive = false;
		}
		else {
			lset |= 0x81; //disable and change to control by interrupt
			okSetCaptureParam(hBoard,CAPTURE_MISCCONTROL,lset);
			m_DisableActive = true;
		}
		intrMISCCONTROL=okSetCaptureParam(hBoard,CAPTURE_MISCCONTROL,-1)&0x3;
	}
}

void COkMfcView::OnAskWaitVertical(WPARAM wParam, LPARAM lParam)
{
	if(!okSetConvertParam(hBoard,CONVERT_NOSYNCSCREEN,-1)) //0: sync
		okWaitVerticalSync(hBoard,1);
}

LRESULT COkMfcView::BeginProc(WPARAM wParam, LPARAM lParam)
{
	exBeginCapture((HANDLE)wParam);
	return 0;
}

LRESULT COkMfcView::SeqPross(WPARAM wParam, LPARAM lParam)
{
	exBackDisplay((HANDLE)wParam,lParam);
	return 0;
}

LRESULT COkMfcView::EndProc(WPARAM wParam, LPARAM lParam)
{
	exEndCapture((HANDLE)wParam);
	return 0;
}

void COkMfcView::OnInterfrombuffer() 
{
	//жϿƻԻ
	if (m_BackToScreen)
		bDispToScreen=1;
	else
		bDispToScreen=0;
	//bDispToScreen=0;
	OnFreeze();
	exEnableItem(IDM_FREEZE, TRUE);
	okSetSeqCallback(hBoard, exBeginCapture, exBackDisplay, exEndCapture);
	
	okPlaybackSequence(hBoard, 0, -1);// 
}

void COkMfcView::OnLockbufsize() 
{
	//
	CSetLockBuffer	cs;
	if(bActive>0)
		okStopCapture(hBoard);	
	cs.DoModal();
}

void COkMfcView::OnUpdateIntertoindirect(CCmdUI* pCmdUI) 
{
	pCmdUI->Enable(m_InterToIndirect);
	pCmdUI->SetCheck(m_InterToIndirectCheck);
}

void COkMfcView::OnIntertoindirect() 
{
	m_CapToIndirect = FALSE;
	m_InterToIndirectCheck = TRUE;

	OnFreeze();
	exEnableItem(IDM_FREEZE, TRUE);
	//restore to normal (system palette)
	okSetConvertParam(hBoard, CONVERT_PALETTE, (LPARAM)NULL);

	long lret=okSetCaptureParam(hBoard,CAPTURE_MISCCONTROL,-1)&~0x3;
	okSetCaptureParam(hBoard,CAPTURE_MISCCONTROL,lret|1); //forced interrupt controlled

	//okSetCaptureParam(hBoard,CAPTURE_MISCCONTROL,3); //normal

	//way 2 can support menu overlay, but too slow for NT 
	bDispToScreen=2;;
	okSetSeqCallback(hBoard,exBeginCapture,exBackDisplay,exEndCapture);
		//just capture to buffer
	if( okCaptureByBuffer(hBoard,BUFFER,0,0)==(HANDLE)1) //0: cont.
		//no enough buffer.
		::MessageBox(hwnd,""
			"\n This need at least two frame size! \n\t\t Try to increase bigger size of BUFFER .", 
			" No enough BUFFER can be used ",MB_OK);
}

void COkMfcView::OnUpdateLoopseqcaptobuf(CCmdUI* pCmdUI) 
{
	pCmdUI->Enable(m_LoopSeqCapToBuf);
}

void COkMfcView::OnLoopseqcaptobuf() 
{
	OnFreeze();
	exEnableItem(IDM_FREEZE, TRUE);

	num=okGetBufferSize(hBoard,NULL,NULL);//			

	if(m_BackToScreen)
		bDispToScreen=1;
	else
		bDispToScreen=0;
	okSetSeqCallback(hBoard,exBeginCapture,exBackDisplay,exEndCapture);

	//okSetSeqProcWnd(hBoard,hWnd);
	okCaptureTo(hBoard,BUFFER,0,-1);//-1: loop infiniately
}

void COkMfcView::OnUpdateCaptoindirect(CCmdUI* pCmdUI) 
{
	pCmdUI->SetCheck(m_CapToIndirect);
}

