// OkMfcView.h : interface of the COkMfcView class
//
/////////////////////////////////////////////////////////////////////////////

#if !defined(AFX_OKMFCVIEW_H__CDF3DFEC_790B_11D4_832C_F0AB548F1904__INCLUDED_)
#define AFX_OKMFCVIEW_H__CDF3DFEC_790B_11D4_832C_F0AB548F1904__INCLUDED_

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000

#include "okapi32.h"

class COkMfcView : public CView
{
protected: // create from serialization only
	COkMfcView();
	DECLARE_DYNCREATE(COkMfcView)

// Attributes
public:
	COkMfcDoc* GetDocument();

// Operations
public:

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(COkMfcView)
	public:
	virtual void OnDraw(CDC* pDC);  // overridden to draw this view
	virtual BOOL PreCreateWindow(CREATESTRUCT& cs);
	virtual BOOL Create(LPCTSTR lpszClassName, LPCTSTR lpszWindowName, DWORD dwStyle, const RECT& rect, CWnd* pParentWnd, UINT nID, CCreateContext* pContext = NULL);
	protected:
	virtual BOOL OnPreparePrinting(CPrintInfo* pInfo);
	virtual void OnBeginPrinting(CDC* pDC, CPrintInfo* pInfo);
	virtual void OnEndPrinting(CDC* pDC, CPrintInfo* pInfo);
	//}}AFX_VIRTUAL

// Implementation
public:
	virtual ~COkMfcView();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

protected:

// Generated message map functions
protected:
	//{{AFX_MSG(COkMfcView)
	afx_msg void OnActive();
	afx_msg void OnDestroy();
	afx_msg void OnFreeze();
	afx_msg void OnSinglecapto();
	afx_msg void OnPaint();
	afx_msg void OnAbout();
	afx_msg void OnExttrigger();
	afx_msg void OnSignaleinfo();
	afx_msg void OnBacktoscreen();
	afx_msg void OnUpdateBacktoscreen(CCmdUI* pCmdUI);
	afx_msg void OnCaptobuffer();
	afx_msg void OnLooptobuffer();
	afx_msg void OnSetupvideo();
	afx_msg void OnCapsequence();
	afx_msg void OnUpdateCenterscreen(CCmdUI* pCmdUI);
	afx_msg void OnCenterscreen();
	afx_msg void OnUpdateEnablemask(CCmdUI* pCmdUI);
	afx_msg void OnEnablemask();
	afx_msg void OnReplaybuffer();
	afx_msg void OnReplaymemory();
	afx_msg void OnReplayfile();
	afx_msg void OnBuffertoscreen();
	afx_msg void OnScreentobuffer();
	afx_msg void OnBuffer0tobuffer1();
	afx_msg void OnBuffer1tobuffer0();
	afx_msg void OnBuffertoframe();
	afx_msg void OnFrametobuffer();
	afx_msg void OnFrametoscreen();
	afx_msg void OnCaptomemory();
	afx_msg void OnCaptoseqfile();
	afx_msg void OnCaptoindirect();
	afx_msg void OnCaptodirect();
	afx_msg void OnCaptoforever();
	afx_msg void OnConttobuffer0();
	afx_msg void OnConttobuffer1();
	afx_msg void OnCaptoframe();
	afx_msg void OnDispfrombuffer();
	afx_msg void OnLoopfrombuffer();
	afx_msg void OnDispfrommemory();
	afx_msg void OnDispfromfile();
	afx_msg void OnCaptomonitor();
	afx_msg void OnDispfromframe();
	afx_msg void OnNormallut();
	afx_msg void OnInverselut();
	afx_msg void OnSelectcard();
	afx_msg void OnUpdateCaptoframe(CCmdUI* pCmdUI);
	afx_msg void OnUpdateBuffertoframe(CCmdUI* pCmdUI);
	afx_msg void OnUpdateFrametobuffer(CCmdUI* pCmdUI);
	afx_msg void OnUpdateFrametoscreen(CCmdUI* pCmdUI);
	afx_msg void OnUpdateNormallut(CCmdUI* pCmdUI);
	afx_msg void OnUpdateInverselut(CCmdUI* pCmdUI);
	afx_msg void OnLoadfile();
	afx_msg void OnSavescreen();
	afx_msg void OnSavebuffer();
	afx_msg void OnSettoband();
	afx_msg void OnPrintpic();
	afx_msg void OnMouseMove(UINT nFlags, CPoint point);
	afx_msg void OnSettozero();
	afx_msg void OnUpdateSinglecapto(CCmdUI* pCmdUI);
	afx_msg void OnAbsolutelut();
	afx_msg void OnMulchancap();
	afx_msg void OnMulchancapsub();
	afx_msg void OnAsyncmulcap();
	afx_msg void OnSyncmulcap();
	afx_msg void OnUpdateMatchclient(CCmdUI* pCmdUI);
	afx_msg void OnMatchclient();
	afx_msg void OnSetmatchsize();
	afx_msg void OnMove(int x, int y);
	afx_msg void OnUpdateCaptureaudio(CCmdUI* pCmdUI);
	afx_msg void OnCopytoclipb();
	afx_msg void OnSetallocbuf();
	afx_msg void OnCaptureaudio();
	afx_msg void OnSeqcaptobuf();
	afx_msg void OnUpdateSeqcaptobuf(CCmdUI* pCmdUI);
	afx_msg void OnRegdevdriver();
	afx_msg void OnUpdateRegdevdriver(CCmdUI* pCmdUI);
	afx_msg void OnCaptopseudo();
	afx_msg void OnUpdateMakexmirror(CCmdUI* pCmdUI);
	afx_msg void OnUpdateMakeymirror(CCmdUI* pCmdUI);
	afx_msg void OnMakexmirror();
	afx_msg void OnMakeymirror();
	afx_msg void OnSize(UINT nType, int cx, int cy);
	afx_msg void OnZeroallbuffer();
	afx_msg void OnUpdateUptoright(CCmdUI* pCmdUI);
	afx_msg void OnUpdateUptoleft(CCmdUI* pCmdUI);
	afx_msg void OnTestvgacard();
	afx_msg void OnTestdrawwnd();
	afx_msg void OnUptoright();
	afx_msg void OnUptoleft();
	afx_msg void OnUpdateCapturempeg2(CCmdUI* pCmdUI);
	afx_msg void OnCapturempeg2();
	afx_msg void OnLoadconfigfile();
	afx_msg void OnSaveconfigfile();
	afx_msg void OnAbsolutedsa();
	afx_msg void OnUpdateAbsolutelut(CCmdUI* pCmdUI);
	afx_msg void OnUpdateAbsolutedsa(CCmdUI* pCmdUI);
	afx_msg void OnNormainlut();
	afx_msg void OnInverseinlut();
	afx_msg void OnUpdateFillinglut(CCmdUI* pCmdUI);
	afx_msg void OnFillinglut();
	afx_msg void OnTestmainwnd();
	afx_msg void OnUpdateDisableactive(CCmdUI* pCmdUI);
	afx_msg void OnUpdateDisablesyncvert(CCmdUI* pCmdUI);
	afx_msg void OnDisablesyncvert();
	afx_msg void OnDisableactive();
	afx_msg void OnInterfrombuffer();
	afx_msg void OnLockbufsize();
	afx_msg void OnUpdateIntertoindirect(CCmdUI* pCmdUI);
	afx_msg void OnIntertoindirect();
	afx_msg void OnUpdateLoopseqcaptobuf(CCmdUI* pCmdUI);
	afx_msg void OnLoopseqcaptobuf();
	afx_msg void OnUpdateCaptoindirect(CCmdUI* pCmdUI);
	//}}AFX_MSG
	afx_msg void OnAskWaitVertical(WPARAM wParam, LPARAM lParam);
	afx_msg LRESULT BeginProc(WPARAM wParam, LPARAM lParam);
	afx_msg LRESULT SeqPross(WPARAM wParam, LPARAM lParam);
	afx_msg LRESULT EndProc(WPARAM wParam, LPARAM lParam);
	DECLARE_MESSAGE_MAP()

private:
	//
	short m_Centerscreen;
	BOOL m_MatchClient;				//ƥû״̬
	BOOL m_CapToFrame;
	BOOL m_BufferToFrame;
	BOOL m_FrameToBuffer;
	BOOL m_FrameToScreen;
	BOOL m_NormalLut;
	BOOL m_InverseLut;
	BOOL m_AbsoluteLut;
	BOOL m_AbsoluteDsa;
	short m_Enablemask;
	bool b_Enablemask;
	BOOL m_CaptureAudio;
	BOOL m_CaptureMpeg2;
	BOOL m_SeqCapToBuf;
	BOOL m_Regdevdriver;
	BOOL m_MakeXMirror;
	BOOL m_MakeYMirror;
	BOOL m_UptoRight;
	BOOL m_UptoLeft;
	BOOL m_UptoRightCheck;
	BOOL m_UptoLeftCheck;
	BOOL m_FillInGLut;				//òұ
	BOOL m_DisableActive;			//ʵʱʾ
	BOOL m_DisableSyncVert;			//ʾͬ
	BOOL m_BackToScreen;			//ʹвɼʱʾ
	BOOL m_InterToIndirect;			//жϾʵʱ
	BOOL m_LoopSeqCapToBuf;			//ѭжϲɼ

	BOOL m_CapToIndirect;			//ʵʱ
	BOOL m_InterToIndirectCheck;	//жϾʵʱ

	//
	HANDLE	exOpenCard(HWND hWnd);
	BOOL InitSetMenu(HWND hWnd, HANDLE hBoard);
	long exSetToWndRectEx(HANDLE hBoard, HWND hWnd, long lMode);


	short exGetInitSet(HWND hWnd);
	short exSaveInitSet(void);

	void exDemoMask();
	void exDisplayDIBInfo(void);
	void exEnableItem(int iMenuID, BOOL bEnable);

	BOOL exGetLoadName(HWND hWnd, char *szFileName);
	BOOL exGetSaveName(HWND hWnd, char *szFileName);

	BOOL exLoadImageFile(HANDLE hBoard, HWND hWnd);
	BOOL exSaveScreenFile(HANDLE hBoard, HWND hWnd);
	BOOL exSaveBufferFile(HANDLE hBoard, HWND hWnd);

	BOOL exFillOutLUT(HANDLE hBoard, short index);
	BOOL exFillInputLUT(HANDLE hBoard, short index);

	BOOL exGetBitmapHeader(HANDLE hBoard, TARGET src, LPBITMAPINFOHEADER lpbi);
	BOOL exGetBitmapData(HANDLE hBoard, TARGET tgt, short start, LPBITMAPINFOHEADER lpbi, LPSTR lpdib);

	long exSetDataToDIB(TARGET src, short start, LPBITMAPINFOHEADER lpbi, LPBYTE lpdib);

	HPALETTE exSetPaletteToWnd(HDC hDC);
	HPALETTE exMakeLogPalette(short iBits, short rgbForm);
};

#ifndef _DEBUG  // debug version in OkMfcView.cpp
inline COkMfcDoc* COkMfcView::GetDocument()
   { return (COkMfcDoc*)m_pDocument; }
#endif

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Developer Studio will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_OKMFCVIEW_H__CDF3DFEC_790B_11D4_832C_F0AB548F1904__INCLUDED_)
