// SignBox.cpp : implementation file
//

#include "stdafx.h"
#include "OkMfc.h"
#include "SignBox.h"
#include "math.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

#include "okapi32.h"

int		videotype;					//Ƶ
int		scanlines;					//ɨ
int		fieldfrq;					//Ƶ

long				lCameraCode=-1;		//OkCamera

extern	HANDLE		hBoard;			//ͼ񿨾

int exAutoSetVideoParams(int videotype, int scanlines, int fieldfrq, int sample43 );
long exAllocateDIBMemory(HANDLE hBoard );

/////////////////////////////////////////////////////////////////////////////
// CSignBox dialog


CSignBox::CSignBox(CWnd* pParent /*=NULL*/)
	: CDialog(CSignBox::IDD, pParent)
{
	//{{AFX_DATA_INIT(CSignBox)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
}


void CSignBox::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CSignBox)
		// NOTE: the ClassWizard will add DDX and DDV calls here
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CSignBox, CDialog)
	//{{AFX_MSG_MAP(CSignBox)
	ON_BN_CLICKED(IDC_SETVIDEO, OnSetvideo)
	ON_BN_CLICKED(IDC_AUTOSEARCH, OnAutosearch)
	ON_BN_CLICKED(IDC_AUTOFINESET, OnAutofineset)
	ON_BN_CLICKED(IDC_OKCAMERA, OnOkcamera)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

#define DEGREE 5
#define DEGREELIMIT	DEGREE*0.8
#define MINFREQ 10
#define MINLINE	10
#define MAXDIFFFIELD	3
#define MAXDIFFLINE		10

BOOL IsInput(HANDLE hBoard)
{
	int degree=10;
//	int fieldfrq[DEGREE]={0};
//	int averfield;
	int scanline[DEGREE]={0};
	int averline;
	int i;
	int count1,count2;
	
	for(i=0,count1=0;i<DEGREE;i++)
	{
// 		Sleep(5);

		if(okGetSignalParam(hBoard,SIGNAL_VIDEOEXIST)==1)
			count1++;
		
		if(count1>DEGREELIMIT)
			break;
	}

	if(count1>DEGREELIMIT)
	{
		for(i=0,averline=0;i<DEGREE;i++)//for(i=0,averfield=0,averline=0;i<DEGREE;i++)
		{
			Sleep(40);
//			fieldfrq[i]=okGetSignalParam(hBoard,SIGNAL_FIELDFREQ);
//			averfield+=fieldfrq[i];
			scanline[i]=okGetSignalParam(hBoard,SIGNAL_SCANLINES);
			averline+=scanline[i];
		}
//		averfield=averfield/DEGREE;
		averline=averline/DEGREE;

		if(averline>MINLINE)//if(averfield>MINFREQ && averline>MINLINE)
		{
			for(i=0,count2=0;i<DEGREE;i++)
			{
				int diffline;
//				int difffield;
				
//				difffield=fieldfrq[i]-averfield;
				diffline=scanline[i]-averline;
				if(fabs(diffline)<MAXDIFFLINE)//if(fabs(difffield)<MAXDIFFFIELD && fabs(diffline)<MAXDIFFLINE)
					count2++;
			}

			if(count2>DEGREELIMIT)
				return TRUE;
			else
				return FALSE;
	
		}

		else if(averline==-1)
			return TRUE;
		else 
			return FALSE;
	}
	else
		return FALSE;
	
}


BOOL AutoSetChan(HANDLE hBoard)//autosetchan return=TRUE(exist)	FALSE(not exist)
{	
	long boardtype;
	long source;
	short sync,sign;
	long syncsign;
	int totalsource;
	
	boardtype=okGetTypeCode(hBoard,NULL);
	if(boardtype<3000 || (boardtype>4000 ))//&& boardtype<5000))			//OK_M C	video 
	{
		if(boardtype>2000)		//Color Y/C
		{
			totalsource=0x100+okSetVideoParam(hBoard,VIDEO_SOURCECHAN,0x1ff);
			for(source=0x100;source<totalsource;source++)
			{
				okSetVideoParam(hBoard,VIDEO_SOURCECHAN,source);
				Sleep(500);
/*
				{
					char str[10];
				
					sprintf(str,"%d",source);
					MessageBox(hwnd,str,"source",MB_OK);
				}
*/
				if(IsInput(hBoard))
				{
					int videocolor=-1;
					videocolor=okGetSignalParam(hBoard,SIGNAL_VIDEOCOLOR);
									{
/*
					char str[10];
				
					sprintf(str,"%d",videocolor);
					MessageBox(hwnd,str,"videoclolr",MB_OK);
*/
				}

					if (videocolor==1)	//Color
					{
						return TRUE;
					}
				}
			}
		}

//		okSetVideoParam(hBoard,VIDEO_SOURCECHAN,0);
//		Sleep(300);
		//Mono || Color  Video
		{
			totalsource=okSetVideoParam(hBoard,VIDEO_SOURCECHAN,0x0ff);
			for(source=0;source<totalsource;source++)
			{
				okSetVideoParam(hBoard,VIDEO_SOURCECHAN,source);
				Sleep(500);
/*
				{
					char str[10];
				
					sprintf(str,"%d",source);
					MessageBox(hwnd,str,"source",MB_OK);
				}
*/
				if(IsInput(hBoard))
				{
					return TRUE;
				}
			}
		}
/*
		if(boardtype>2000 )		//OK_C		Y/C
		{
			for(source=0x100;source<0x103;source++)
			{
				if(okSetVideoParam(hBoard,VIDEO_SOURCECHAN,source)!=-1)
				{
					Sleep(40);

//					char str[10];
//				
//					sprintf(str,"%d",source);
//					MessageBox(hwnd,str,"source",MB_OK);
					if(IsInput(hBoard))
						return TRUE;
				}
			}
		}
*/
	}

	else //if(boardtype<4000)		//OK_RGB
	{
		totalsource=0x200+okSetVideoParam(hBoard,VIDEO_SOURCECHAN,0x2ff);
		for(source=0x200;source<totalsource;source++)			//RGB
		{
			if(okSetVideoParam(hBoard,VIDEO_SOURCECHAN,source)!=-1)
			{
				for(sign=0;sign<2;sign++)
				{
					for(sync=0;sync<5;sync++)
					{
						syncsign=MAKELONG(sync,sign);
						okSetVideoParam(hBoard,VIDEO_SYNCSIGCHAN,syncsign);

						Sleep(200);
/*
				{
					char str[10];
				
					sprintf(str,"%d",source);
					MessageBox(hwnd,str,"source",MB_OK);
				}
*/
						if(IsInput(hBoard))
						{

							if(sync==0 || sync==2)
							{
								okSetVideoParam(hBoard,VIDEO_SOURCECHAN,sync+sign*3);
							}
							return TRUE;
						}
					}
				}
			}
		}

/*
		for(source=0;source<6;source++)					//video
		{
			okSetVideoParam(hBoard,VIDEO_SOURCECHAN,source);
			okSetVideoParam(hBoard,VIDEO_SYNCSIGCHAN,MAKELONG(source%3,source/3));
			Sleep(40);
			if(IsInput(hBoard))
				return TRUE;
		}
*/
	}

	return FALSE;
}

/////////////////////////////////////////////////////////////////////////////
// CSignBox message handlers

void CSignBox::Init()
{
	char	str[256];
	int		extsign = 0;
	int		vidcolor = -1;
	int		ret;

	GetDlgItem(IDC_AUTOSEARCH)->EnableWindow(TRUE);

	//video exist
	extsign = okGetSignalParam(hBoard, SIGNAL_VIDEOEXIST);
	if (extsign == 1)
	{
		sprintf(str, "⵽źԴ");
	}
	else if (extsign == 0)
		sprintf(str, "ûźԴ");
	else //-1
	{
		sprintf(str, "֧");
		GetDlgItem(IDC_AUTOSEARCH)->EnableWindow(FALSE);
	}

	vidcolor = okGetSignalParam(hBoard, SIGNAL_VIDEOCOLOR);
	if (extsign == 1) 
	{
		if (vidcolor == 1)
			strcat(str, "(Color)");
		else if (vidcolor == 0)
			strcat(str, "(B/W)");
	}
	SetDlgItemText(IDC_VIDEOEXIST, str);


	//video type
	if (extsign == 1) 
	{
		okWaitSignalEvent(hBoard, EVENT_ODDFIELD, 40);
		videotype = okGetSignalParam(hBoard, SIGNAL_VIDEOTYPE);
		if (videotype == 1)
			sprintf(str, "ź(Interlaced)");
		else if (videotype == 0)
			sprintf(str, "ź(Non-interlaced)");
		else if (videotype == -1)
			sprintf(str, "֧");
	}
	else 
		sprintf(str, "δ֪");
		
	SetDlgItemText(IDC_VIDEOTYPE, str);

	//video scanlines
	scanlines = -1;
	if (extsign == 1) 
	{ 
		scanlines = okGetSignalParam(hBoard, SIGNAL_SCANLINES);
		if (scanlines == -1)
			sprintf(str, "֧");
		else
			sprintf(str, "%d /", scanlines);
	}
	else
		sprintf(str, "δ֪");
	SetDlgItemText(IDC_SCANLINES, str);

	//video field frequency
	if (extsign == 1) 
	{
		fieldfrq = okGetSignalParam(hBoard, SIGNAL_FIELDFREQ);
		if (fieldfrq == -1)
			sprintf(str, "δ֪");
		else 
			sprintf(str, "%d /", fieldfrq);
	}
	else if (extsign == -1) 
		sprintf(str, "δ֪");
	SetDlgItemText(IDC_FRAMEFREQ, str);


	//extern trigger
	ret = okGetSignalParam(hBoard, SIGNAL_EXTTRIGGER);
	if (ret == -1)
		sprintf(str, "֧");
	else if (ret == 1)
		sprintf(str, "״̬");
	else
		sprintf(str, "޴");
	SetDlgItemText(IDC_EXTTRIGGER, str);

	CheckDlgButton(IDC_SAMPLERATIO43, BST_CHECKED);
	GetDlgItem(IDC_SETVIDEO)->EnableWindow(FALSE);
	GetDlgItem(IDC_AUTOFINESET)->EnableWindow(FALSE);
	GetDlgItem(IDC_SAMPLERATIO43)->EnableWindow(FALSE);
	GetDlgItem(IDC_SAMPLERATIO11)->EnableWindow(FALSE);
	if(scanlines!=-1){
		GetDlgItem(IDC_SETVIDEO)->EnableWindow(TRUE);
		GetDlgItem(IDC_AUTOFINESET)->EnableWindow(TRUE);
		//if( okSetCaptureParam(hBoard,CAPTURE_HORZPIXELS,-1)!=-1 ) {
			GetDlgItem(IDC_SAMPLERATIO43)->EnableWindow(TRUE);
			GetDlgItem(IDC_SAMPLERATIO11)->EnableWindow(TRUE);
		//}
	}
	//if( (scanlines==625) && (videotype==1) || // PAL
	//	(scanlines==525) && (videotype==1) ) { //NTSC 
	//	EnableWindow(GetDlgItem(hDlg,IDC_SAMPLERATIO43),FALSE);
	//	EnableWindow(GetDlgItem(hDlg,IDC_SAMPLERATIO11),FALSE);
	//}

	//test out trigger
	okPutSignalParam(hBoard,PUTSIGNAL_TRIGGER,0xff);

	//enable vert sync
	okPutSignalParam(hBoard,PUTSIGNAL_VERTSYNC,0x1);
}

void CSignBox::OnSetvideo() 
{
	// TODO: Add your control notification handler code here

	if(!IsDlgButtonChecked(IDC_OKCAMERA) ) {
		lCameraCode=-1;	//OkCamera
	}
	exAutoSetVideoParams(videotype, scanlines, fieldfrq,
				IsDlgButtonChecked(IDC_SAMPLERATIO43) );

	exAllocateDIBMemory(hBoard); //may be re-new size

	//disable vert sync
	okPutSignalParam(hBoard,PUTSIGNAL_VERTSYNC,0x0);

	EndDialog(TRUE);
}

BOOL CSignBox::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	// TODO: Add extra initialization here

	char	str[256];

	//if(wParam) {
		GetWindowText(str, 100);
		strcat(str, "     (");
		okGetTypeCode(hBoard, str+strlen(str));
		strcat(str, ")");
		SetWindowText(str);
	//}

	Init();

	return (TRUE);
}

//--demo to auto-set video and pcapture params according to input signal infos
//just be used M20, M40, M30, M60. M70
int exAutoSetVideoParams(int videotype, int scanlines, int fieldfrq, int sample43 )
{

	long	tvstandard;
	long	samppixel,sampfreq,videoshift;
	RECT	rect;

	//1.video type, 2. sample mode as video type
	okSetVideoParam(hBoard, VIDEO_SIGNALTYPE, videotype);	
	okSetCaptureParam(hBoard, CAPTURE_SAMPLEFIELD, videotype); //0: field 1: frame

	//3.video standard 4.hp and vl, 5.frq segment 
	//6 vidoe shift 7, sample rect
	//4:3
	if ((scanlines==625) && (videotype==1))  //interlace
	{
		if (sample43)   //4:3
		{
			tvstandard = 0; //PAL
			okSetVideoParam(hBoard, VIDEO_TVSTANDARD, tvstandard);	
			okSetVideoParam(hBoard, VIDEO_FREQSEG, 0); //lo seg
			SetRect(&rect, 0, 0, 768, 576);
		}
		else  //1:1
		{
			//first do vidoe rect shift   
			videoshift = MAKELONG((short)100, HIWORD(okSetVideoParam(hBoard,VIDEO_RECTSHIFT,-1)));
			okSetVideoParam(hBoard, VIDEO_RECTSHIFT, videoshift);

			tvstandard = 2; //non-standard
			okSetVideoParam(hBoard, VIDEO_TVSTANDARD, tvstandard);	
			okSetVideoParam(hBoard, VIDEO_FREQSEG, 0); //lo seg
			okSetCaptureParam(hBoard, CAPTURE_HORZPIXELS, 709);
			okSetCaptureParam(hBoard, CAPTURE_VERTLINES, 625);
			SetRect(&rect, 0, 0, 576, 576);
		}
	}else if(sample43 && (scanlines==525) && (videotype==1)) 
	{ 
		if (sample43)  //4:3
		{
			tvstandard = 1; //NTSC
			okSetVideoParam(hBoard, VIDEO_TVSTANDARD, tvstandard);	
			okSetVideoParam(hBoard, VIDEO_FREQSEG, 0); //lo seg
			SetRect(&rect, 0, 0, 640, 480);
		}
		else  //1:1
		{
			//first do vidoe rect shift   
			videoshift = MAKELONG((short)70, HIWORD(okSetVideoParam(hBoard, VIDEO_RECTSHIFT,-1)));
			okSetVideoParam(hBoard, VIDEO_RECTSHIFT, videoshift);

			tvstandard = 2; //non-standard
			okSetVideoParam(hBoard, VIDEO_TVSTANDARD, tvstandard);	
			okSetVideoParam(hBoard, VIDEO_FREQSEG, 0); //lo seg
			okSetCaptureParam(hBoard, CAPTURE_HORZPIXELS, 591);
			okSetCaptureParam(hBoard, CAPTURE_VERTLINES, 525);
			SetRect(&rect, 0, 0, 480, 480);
		}
	}
	else
	{ 
		tvstandard = 2;//non-standard
		okSetVideoParam(hBoard, VIDEO_TVSTANDARD, tvstandard);	

		if (sample43)
			samppixel = (long)(scanlines*1.5104); //1.0 sample in 4:3
		else
			samppixel = (long)(scanlines*1.1328); //0.76 sample in 1:1
re_calc:
		sampfreq = scanlines*samppixel/1000*fieldfrq/1000; //to unit MHz
		if (videotype == 1) //interlaced 
			sampfreq /= 2;
	
		if (sampfreq < 14.75)
			sampfreq = 0; //low
		else if (sampfreq < 30)
			sampfreq = 1; //middle
		else if (sampfreq <= 60)
			sampfreq = 2; //high
		else 
		{
			samppixel = 60000000/(scanlines*(fieldfrq>>videotype)); //
			goto re_calc;
		}

		okSetCaptureParam(hBoard, CAPTURE_HORZPIXELS, samppixel);
		okSetCaptureParam(hBoard, CAPTURE_VERTLINES, scanlines);
		okSetVideoParam(hBoard, VIDEO_FREQSEG, sampfreq); 

		//vidoe rect shift   
		//videoshift=MAKELONG( (short)(samppixel*0.165),(short)(samppixel*0.0512));
		videoshift = MAKELONG((short)(samppixel*0.18), (short)(scanlines*0.08));
		okSetVideoParam(hBoard, VIDEO_RECTSHIFT, videoshift);
		//do again after set shift
		okSetVideoParam(hBoard, VIDEO_TVSTANDARD, tvstandard);	

		SetRect(&rect, 0, 0, (long)(samppixel*0.8), (long)(scanlines*0.9));
	}
	okSetTargetRect(hBoard, VIDEO, &rect);
	okSetTargetRect(hBoard, BUFFER, &rect);

	return tvstandard;
}

BOOL CSignBox::Create(LPCTSTR lpszClassName, LPCTSTR lpszWindowName, DWORD dwStyle, const RECT& rect, CWnd* pParentWnd, UINT nID, CCreateContext* pContext) 
{
	return CDialog::Create(IDD, pParentWnd);
}


void CSignBox::OnAutosearch() 
{
	if(AutoSetChan(hBoard))
	{
		Sleep(200);

		//SendMessage(hDlg,WM_INITDIALOG,0,0);
		Init();
		GetDlgItem(IDC_AUTOSEARCH)->EnableWindow(FALSE);
	}
}

void CSignBox::OnAutofineset() 
{
	okAutoSetCapRect(hBoard,0,0); //full auto-fine-set 
	exAllocateDIBMemory(hBoard); //may be re-new size

    EndDialog(TRUE);
}

void CSignBox::OnOK() 
{
	Init();
	
	//CDialog::OnOK();
}

void CSignBox::OnOkcamera() 
{
	HANDLE hCamera;
	char szPortName[10]="COM";
	char szCameraName[10];
	//HCURSOR	hArrow = LoadCursor(NULL, IDC_ARROW);
	//HCURSOR	hAppStart = LoadCursor(NULL, IDC_APPSTARTING );

	//SetCursor(hAppStart);
	//hCamera=okCamOpenCamera(&lCameraCode,szPortName);
	//SetCursor(hArrow);

	switch(lCameraCode)
	{
	case 201100:
		sprintf(szCameraName,"AM1100");
		break;
	case 201101:
		sprintf(szCameraName,"AM1101");
		break;
//				case 201102:
//					sprintf(szCameraName,"AM1100GX");
//					break;
//				case 201103:
//					sprintf(szCameraName,"AM1101GX");
//					break;
	case 201300:
		sprintf(szCameraName,"AM1300");
		break;
	case 211200:
		sprintf(szCameraName,"AC1200");
		break;
	case 211300:
		sprintf(szCameraName,"AC1300");
		break;
	default:
		lCameraCode=-1;
		//sprintf(szCameraName,"OK Camera?");
		GetDlgItem(IDC_OKCAMERA)->EnableWindow(FALSE);

		break;

	}
	if(lCameraCode>0)
		SetDlgItemText(IDC_OKCAMERA,szCameraName);
}
